(* ******************************************************************** *)
(*
   Project         : HOL-CSP - A Shallow Embedding of CSP in  Isabelle/HOL
   Version         : 2.0

   Author          : Burkhart Wolff
                     (Last modification by $Author: bu $)
                     (Based on HOL-CSP 1.0 by Haykal Tej and Burkhart Wolff)

   Affiliation     : Université Paris-Sud, LRI, Orsay
   This file       : A Combined CSP Theory

*)
(* ******************************************************************** *)


theory     CSPBPL
imports    Bot Skip Stop Mprefix Det Ndet
begin 

section{* An experiment in modeling a BPEL engine *}  

types sess_id = int    (* session id's; should be abstract type *) msg_id = int     (* message id's *)
      process_type = string (* represent one to one BPEL processes *)
      cs_name = int   (* correlation set name *)
      p_name = string
      val = string

record ArbiterState =
       corr_val_env :: "sess_id \<Rightarrow> (cs_name \<rightharpoonup> p_name \<rightharpoonup> val)"
       corr_set     :: "(sess_id \<times> msg_id \<times> val) set"
       enabled      :: "process_type \<Rightarrow> sess_id set"
       listening    :: "process_type \<Rightarrow> msg_id set"

 
 










text{* *}


end

