(* ******************************************************************** *)
(*
 * Project         : HOL-CSP - A Shallow Embedding of CSP in  Isabelle/HOL
 * Version         : 2.0
 *
 * Author          : Burkhart Wolff
 *                   (Based on HOL-CSP 1.0 by Haykal Tej and Burkhart Wolff)
 *
 * This file       : A Collection of Name-Bindings for Porting older Proofs
 *
 * Copyright (c) 2009 Université Paris-Sud, France
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials provided
 *       with the distribution.
 *
 *     * Neither the name of the copyright holders nor the names of its
 *       contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************)
(* $Id: ROOT.ML 8591 2009-09-26 09:58:14Z brucker $ *)



theory Legacy
imports Process
begin 

(* legacy: *)
lemmas tF_Nil   = tickFree_Nil
lemmas tF_Cons  = tickFree_Cons
lemmas NtF_tick = non_tickFree_tick
lemmas tF_rev   = tickFree_rev
lemmas ftF_Nil  = front_tickFree_Nil
lemmas tF_imp_ftF      = tickFree_implies_front_tickFree
lemmas ftF_imp_f_is_tF = front_tickFree_implies_tickFree 
lemmas NtF_ftF_ex = nonTickFree_n_frontTickFree
lemmas Nconj_eq_disjN  =  HOL.nnf_simps(1)
lemmas Ndisj_eq_conjN  = HOL.nnf_simps(2)
lemmas imp_disj        = HOL.nnf_simps(3)
lemmas conj_imp        = HOL.imp_conjL
lemmas Pair_fst_snd_eq = surjective_pairing
lemmas t_F_T           = Failures_implies_Traces 
lemmas f_F_is_tF       = front_trace_is_tickfree
lemmas f_T_is_tF       = trace_with_Tick_implies_tickFree_front
lemmas D_ftF_subset = D_front_tickFree_subset
lemmas append_T_tF = append_T_imp_tickFree
lemmas T_tF = append_single_T_imp_tickFree
lemmas T_tF1 = append_single_T_imp_tickFree
lemmas T_NtF_ex = T_nonTickFree_imp_decomp

definition member :: "'a list \<Rightarrow> 'a \<Rightarrow> bool" where
  mem_iff [code_post]: "member xs x \<longleftrightarrow> x \<in> set xs"


(*end legacy *)

(* legacy
val HOL_ss = HOL_ss delsimps (ex_simps @ all_simps @
                               [Nconj_eq_disjN,Ndisj_eq_conjN,
                                de_Morgan_conj,de_Morgan_disj]);
val set_ss = set_ss delsimps (ex_simps @ all_simps @
                               [Nconj_eq_disjN,Ndisj_eq_conjN,
                                de_Morgan_conj,de_Morgan_disj]);
val list_ss = list_ss delsimps (ex_simps @ all_simps @
                               [Nconj_eq_disjN,Ndisj_eq_conjN,
                                de_Morgan_conj,de_Morgan_disj]);
val prod_ss = prod_ss delsimps (ex_simps @ all_simps @
                               [Nconj_eq_disjN,Ndisj_eq_conjN,
                                de_Morgan_conj,de_Morgan_disj]);

val process_ss = HOL_ss;
 end legacy *)
(* legacy *)
lemmas is_process3_S     = is_process3 [rule_format]
lemmas is_process2_S     = is_process2 [THEN spec, THEN spec, THEN mp]
lemmas ProcessT_eqI      = Process_eq_spec[THEN iffD2,OF conjI]
lemmas is_processT_spec  = process_charn
lemmas is_processT2_TR_S = is_processT2_TR[rule_format]
lemmas is_processT2_S    = is_processT2[rule_format]
lemmas is_processT3_S    = is_processT3[rule_format]
lemmas is_processT4_S    = is_processT4[rule_format]
lemmas is_processT5_S    = is_processT5[rule_format, OF conjI]
lemmas is_processT6_S    = is_processT6[rule_format]
lemmas is_processT9_S    = is_processT9 [rule_format]
lemmas subsetND = Set.contra_subsetD
lemmas D_ftF    = D_imp_front_tickFree
lemmas  ftF_imp_f_is_tF1 = front_tickFree_implies_tickFree  

(* end legacy *)
(*legacy ... *)
lemmas less_eq_process_def = Process.le_ref_def

lemma Collect_eq_spec:
"{x. P x} = {x. Q x} = (\<forall> x. P x = Q x)"
by auto

lemmas subset_spec = subset_iff[THEN iffD1,rule_format] 

lemmas rec_ord_implies_ref_ord = le_approx_implies_le_ref

lemmas process_ref_ord_def = Process.le_ref_def

(* end legacy *)


(* TO BE REDEFINED IN HOLCF 

   "<|'_<<"   :: "[('s process) set, 's process] => bool"   (infixl 55)
   "<<|'_<<"  :: "[('s process) set, 's process] => bool"   (infixl 55)                 

   is_ref_ub_def "Y <|_<< x == (!y:Y. y << x)"
   is_ref_lub_def"Y <<|_<< x == (Y <|_<< x & (!y. Y <|_<< y --> x << y))"

*)


lemmas sq_eq_process = le_approx_def
lemmas process_ord_def = sq_eq_process

(* legacy . . . *)
lemmas proc_ord1=le_approx1
lemmas proc_ord2=le_approx2 
lemmas proc_ord3=le_approx3 
lemmas proc_ord2T=le_approx2T 
lemmas proc_ord_lemma_F=le_approx_lemma_F 
lemmas proc_ord_lemma_T=le_approx_lemma_T 
(* . . . legacy *)


lemmas le_approx_implies_ref_ord = le_approx_implies_le_ref 
lemmas ref_ord1 = le_ref1
lemmas ref_ord2 = le_ref2
lemmas ref_ord2T = le_ref2T



end
