(* ******************************************************************** *)
(*
        Project         : HOL-CSP - A Shallow Embedding of CSP 
                          in Isabelle/HOL

        $Source: /home/uniform/rep/isa_lang/CSP/univ_csp/Skip.thy,v $
        Author          : Haykal Tej, Burkhart Wolff
                          (Last modification by $Author: bu $)

        Affiliation     : (1)University of Bremen,
                             Bremen Institute for Safe Systems (BISS)
                          (2)Albert-Ludwigs Universität Freiburg

        Level           : 2 (operator definitions & proof of invariance)
        This file       : skip operator

        $Date: 1999/11/15 18:52:47 $
        $Revision: 1.5 $
*)
(* ******************************************************************** *)

theory Skip 
imports Process
      (*     Legacy *)
begin

definition SKIP :: "'a process"
where     "SKIP \<equiv> Abs_Process ({(s, X). s = [] \<and> tick \<notin> X} \<union> {(s, X). s = [tick]}, {})"

lemma is_process_REP_Skip:
" is_process ({(s, X). s = [] \<and> tick \<notin> X} \<union> {(s, X). s = [tick]}, {})"
apply(auto simp: FAILURES_def DIVERGENCES_def front_tickFree_def is_process_def)
apply(erule contrapos_np,drule neq_Nil_conv[THEN iffD1], auto)
done

lemma is_process_REP_Skip2:
"is_process ({[]} \<times> {X. tick \<notin> X} \<union> {(s, X). s = [tick]}, {})"
apply(insert is_process_REP_Skip)
apply auto done

lemmas process_prover = Process_def Abs_Process_inverse 
	                       FAILURES_def TRACES_def 
	                       DIVERGENCES_def is_process_REP_Skip

lemma F_SKIP:
"F SKIP = {(s, X). s = [] \<and> tick \<notin> X} \<union> {(s, X). s = [tick]}";
by(simp add:  process_prover SKIP_def F_def is_process_REP_Skip2)

lemma D_SKIP: "D SKIP = {}"
by(simp add:  process_prover SKIP_def D_def is_process_REP_Skip2)

lemma T_SKIP: "T SKIP ={[],[tick]}"
by(auto simp:  process_prover SKIP_def T_def is_process_REP_Skip2)


end
