#!/bin/bash

export WD=`pwd`
timing=1200

declare -a examples 
examples=('networks 1000' "rules 300" "personal-firewall 300" 
            "dmz 300" 'simple-dmz 300')
element_count=${#examples[@]}
index=0

while [ "$index" -lt "$element_count" ]
do 
    dir=`echo ${examples[$index]} | awk '{print $1}'`
    t=`echo ${examples[$index]} | awk '{print $timing}'`
    t=$timing
    echo 
    echo "***************************************************************************"
    echo "* Started $dir on `date`"
    echo "* time limit: $t"
    cd $dir;
    ulimit -S -t $t
    isabelle make -B;
    echo "* Finished $dir successfully on `date`"
    echo "***************************************************************************"
    echo 
    cd $WD;
    let "index = $index + 1"
done



