#!/bin/bash

export WD=`pwd`
timing=500000


declare -a examples 
examples=('ethz-01 $timing' 'ethz-02 $timing'  )
element_count=${#examples[@]}
index=0

echo "foo "

while [ "$index" -lt "$element_count" ]
do 
    dir=`echo ${examples[$index]} | awk '{print $1}'`
    t=`echo ${examples[$index]} | awk '{print $timing}'`
    t=$timing
    echo 
    echo "***************************************************************************"
    echo "* Started $dir on `date`" 
    echo "* time limit: $t"
    cd $dir;
#    ulimit -S -t $t
    ~/Isabelle2011-1/bin/isabelle env ISABELLE_OUTPUT=../heaps make -f IsaMakefile -B;
    echo "* Finished $dir successfully on `date`" >> ../time.log
    echo "***************************************************************************" 
    echo 
    cd $WD;
    let "index = $index + 1"
done

zgrep -hEo "^.+test cases in.+$" heaps/log/*.gz > ETHLogs.tex
