(*****************************************************************************
 * HOL-TestGen --- theorem-prover based test case generation
 *                 http://www.brucker.ch/projects/hol-testgen/
 *
 * FWTesting.thy ---
 * This file is part of HOL-TestGen.
 *
 * Copyright (c) 2005-2010 ETH Zurich, Switzerland
 *               2008-2010 Achim D. Brucker, Germany
 *               2009-2010 Université Paris-Sud, France
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials provided
 *       with the distribution.
 *
 *     * Neither the name of the copyright holders nor the names of its
 *       contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ***************.***************************************************************)
(* $Id$ *)

theory 
  PolicyDefinitions
imports
  FWTesting
begin


text{* This theory contains the definitions and theorems which are
used in the case studies for the normalisation procedure. *}


fun dupl :: "(adr\<^isub>i\<^isub>p net,port)Combinators list \<Rightarrow> int" where 
 "dupl (x#xs) = (if x \<in> set xs then ((dupl xs) + (1::int)) else (dupl xs))"
|"dupl [] = 0" 



definition one :: "(adr\<^isub>i\<^isub>p net)" where
"one = {{(a,b). (a = 1)}}"
definition two :: "(adr\<^isub>i\<^isub>p net)" where
"two = {{(a,b). (a = 2)}}"
definition three :: "(adr\<^isub>i\<^isub>p net)" where
"three = {{(a,b). (a = 3)}}"
definition four :: "(adr\<^isub>i\<^isub>p net)" where
"four = {{(a,b). (a = 4)}}"
definition five :: "(adr\<^isub>i\<^isub>p net)" where
"five = {{(a,b). (a = 5)}}"
definition six :: "(adr\<^isub>i\<^isub>p net)" where
"six = {{(a,b). (a = 6)}}"
definition seven :: "(adr\<^isub>i\<^isub>p net)" where
"seven = {{(a,b). (a = 7)}}"
definition eight :: "(adr\<^isub>i\<^isub>p net)" where
"eight = {{(a,b). (a = 8)}}"
definition nine :: "(adr\<^isub>i\<^isub>p net)" where
"nine = {{(a,b). (a = 9)}}"
definition ten :: "(adr\<^isub>i\<^isub>p net)" where
"ten = {{(a,b). (a = 10)}}"
definition eleven :: "(adr\<^isub>i\<^isub>p net)" where
"eleven = {{(a,b). (a = 11)}}"
definition twelve :: "(adr\<^isub>i\<^isub>p net)" where
"twelve = {{(a,b). (a = 12)}}"
definition thirteen :: "(adr\<^isub>i\<^isub>p net)" where
"thirteen = {{(a,b). (a = 13)}}"
definition fourteen :: "(adr\<^isub>i\<^isub>p net)" where
"fourteen = {{(a,b). (a = 14)}}"
definition fifteen :: "(adr\<^isub>i\<^isub>p net)" where
"fifteen = {{(a,b). (a = 15)}}"
definition sixteen :: "(adr\<^isub>i\<^isub>p net)" where
"sixteen = {{(a,b). (a = 16)}}"
definition seventeen :: "(adr\<^isub>i\<^isub>p net)" where
"seventeen = {{(a,b). (a = 17)}}"
definition eighteen :: "(adr\<^isub>i\<^isub>p net)" where
"eighteen = {{(a,b). (a = 18)}}"
definition nineteen :: "(adr\<^isub>i\<^isub>p net)" where
"nineteen = {{(a,b). (a = 19)}}"
definition twenty :: "(adr\<^isub>i\<^isub>p net)" where
"twenty = {{(a,b). (a = 20)}}"
definition twentyone :: "(adr\<^isub>i\<^isub>p net)" where
"twentyone = {{(a,b). (a = 21)}}"
definition twentytwo :: "(adr\<^isub>i\<^isub>p net)" where
"twentytwo = {{(a,b). (a = 22)}}"
definition twentythree :: "(adr\<^isub>i\<^isub>p net)" where
"twentythree = {{(a,b). (a = 23)}}"
definition twentyfour :: "(adr\<^isub>i\<^isub>p net)" where
"twentyfour = {{(a,b). (a = 24)}}"
definition twentyfive :: "(adr\<^isub>i\<^isub>p net)" where
"twentyfive = {{(a,b). (a = 25)}}"
definition twentysix :: "(adr\<^isub>i\<^isub>p net)" where
"twentysix = {{(a,b). (a = 26)}}"
definition twentyseven :: "(adr\<^isub>i\<^isub>p net)" where
"twentyseven = {{(a,b). (a = 27)}}"
definition twentyeight :: "(adr\<^isub>i\<^isub>p net)" where
"twentyeight = {{(a,b). (a = 28)}}"
definition twentynine :: "(adr\<^isub>i\<^isub>p net)" where
"twentynine = {{(a,b). (a = 29)}}"
definition thirty :: "(adr\<^isub>i\<^isub>p net)" where
"thirty = {{(a,b). (a = 30)}}"
definition thirtyone :: "(adr\<^isub>i\<^isub>p net)" where
"thirtyone = {{(a,b). (a = 31)}}"





lemmas UnfoldPolicy = one_def two_def three_def four_def five_def
six_def seven_def eight_def nine_def ten_def eleven_def twelve_def
thirteen_def fourteen_def fifteen_def sixteen_def seventeen_def
eighteen_def nineteen_def twenty_def twentyone_def twentytwo_def
twentythree_def twentyfour_def twentyfive_def twentysix_def
twentyseven_def twentyeight_def twentynine_def thirty_def
thirtyone_def


lemma sets_distinct1: "n \<noteq> m \<Longrightarrow> {(a,b). a = n} \<noteq> {(a,b). a = m}"
apply auto
done

lemma sets_distinct2: "m \<noteq> n \<Longrightarrow> {(a,b). a = n} \<noteq> {(a,b). a = m}"
apply auto
done



lemma nets_different: 
"one \<noteq> two \<and> one \<noteq> three
\<and> one \<noteq> four \<and> one \<noteq> five \<and> one \<noteq>
six \<and> one \<noteq> seven \<and> one \<noteq> eight \<and> one
\<noteq> nine \<and> one \<noteq> ten \<and> one \<noteq> eleven
\<and> one \<noteq> twelve \<and> one \<noteq> thirteen \<and> one \<noteq>
fourteen \<and> one \<noteq> fifteen \<and> one \<noteq> sixteen \<and> one
\<noteq> seventeen \<and> one \<noteq> eighteen \<and> one \<noteq>
nineteen \<and> one \<noteq> twenty \<and> one \<noteq> twentyone
\<and> one \<noteq> twentytwo \<and> one \<noteq> twentythree \<and>
one \<noteq> twentyfour \<and> one \<noteq> twentyfive \<and> one
\<noteq> twentysix \<and> one \<noteq> twentyseven \<and> one \<noteq>
twentyeight \<and> one \<noteq> twentynine \<and> one \<noteq> thirty
\<and> one \<noteq> thirtyone \<and> two \<noteq> one \<and> two
\<noteq> three \<and> two \<noteq> four \<and> two \<noteq> five
\<and> two \<noteq> six \<and> two \<noteq> seven \<and> two \<noteq>
eight \<and> two \<noteq> nine \<and> two \<noteq> ten \<and> two
\<noteq> eleven \<and> two \<noteq> twelve \<and> two \<noteq> thirteen
\<and> two \<noteq> fourteen \<and> two \<noteq> fifteen \<and> two
\<noteq> sixteen \<and> two \<noteq> seventeen \<and> two \<noteq>
eighteen \<and> two \<noteq> nineteen \<and> two \<noteq> twenty
\<and> two \<noteq> twentyone \<and> two \<noteq> twentytwo \<and> two
\<noteq> twentythree \<and> two \<noteq> twentyfour \<and> two
\<noteq> twentyfive \<and> two \<noteq> twentysix \<and> two \<noteq>
twentyseven \<and> two \<noteq> twentyeight \<and> two \<noteq>
twentynine \<and> two \<noteq> thirty \<and> two \<noteq> thirtyone
\<and> three \<noteq> one \<and> three \<noteq> two \<and> three
\<noteq> four \<and> three \<noteq> five \<and> three \<noteq> six
\<and> three \<noteq> seven \<and> three \<noteq> eight \<and> three
\<noteq> nine \<and> three \<noteq> ten \<and> three \<noteq> eleven
\<and> three \<noteq> twelve \<and> three \<noteq> thirteen \<and> three
\<noteq> fourteen \<and> three \<noteq> fifteen \<and> three \<noteq>
sixteen \<and> three \<noteq> seventeen \<and> three \<noteq> eighteen
\<and> three \<noteq> nineteen \<and> three \<noteq> twenty \<and>
three \<noteq> twentyone \<and> three \<noteq> twentytwo \<and> three
\<noteq> twentythree \<and> three \<noteq> twentyfour \<and> three
\<noteq> twentyfive \<and> three \<noteq> twentysix \<and> three
\<noteq> twentyseven \<and> three \<noteq> twentyeight \<and> three
\<noteq> twentynine \<and> three \<noteq> thirty \<and> three \<noteq>
thirtyone \<and> four \<noteq> one \<and> four \<noteq> two \<and>
four \<noteq> three \<and> four \<noteq> five \<and> four \<noteq> six
\<and> four \<noteq> seven \<and> four \<noteq> eight \<and> four
\<noteq> nine \<and> four \<noteq> ten \<and> four \<noteq> eleven
\<and> four \<noteq> twelve \<and> four \<noteq> thirteen \<and> four
\<noteq> fourteen \<and> four \<noteq> fifteen \<and> four \<noteq> sixteen
\<and> four \<noteq> seventeen \<and> four \<noteq> eighteen \<and>
four \<noteq> nineteen \<and> four \<noteq> twenty \<and> four
\<noteq> twentyone \<and> four \<noteq> twentytwo \<and> four \<noteq>
twentythree \<and> four \<noteq> twentyfour \<and> four \<noteq>
twentyfive \<and> four \<noteq> twentysix \<and> four \<noteq>
twentyseven \<and> four \<noteq> twentyeight \<and> four \<noteq>
twentynine \<and> four \<noteq> thirty \<and> four \<noteq> thirtyone
\<and> five \<noteq> one \<and> five \<noteq> two \<and> five \<noteq>
three \<and> five \<noteq> four \<and> five \<noteq> six \<and> five
\<noteq> seven \<and> five \<noteq> eight \<and> five \<noteq> nine
\<and> five \<noteq> ten \<and> five \<noteq> eleven \<and> five
\<noteq> twelve \<and> five \<noteq> thirteen \<and> five \<noteq> fourteen
\<and> five \<noteq> fifteen \<and> five \<noteq> sixteen \<and> five
\<noteq> seventeen \<and> five \<noteq> eighteen \<and> five \<noteq>
nineteen \<and> five \<noteq> twenty \<and> five \<noteq> twentyone
\<and> five \<noteq> twentytwo \<and> five \<noteq> twentythree \<and>
five \<noteq> twentyfour \<and> five \<noteq> twentyfive \<and> five
\<noteq> twentysix \<and> five \<noteq> twentyseven \<and> five
\<noteq> twentyeight \<and> five \<noteq> twentynine \<and> five
\<noteq> thirty \<and> five \<noteq> thirtyone \<and> six \<noteq> one
\<and> six \<noteq> two \<and> six \<noteq> three \<and> six \<noteq>
four \<and> six \<noteq> five \<and> six \<noteq> seven \<and> six
\<noteq> eight \<and> six \<noteq> nine \<and> six \<noteq> ten \<and>
six \<noteq> eleven \<and> six \<noteq> twelve \<and> six \<noteq> thirteen
\<and> six \<noteq> fourteen \<and> six \<noteq> fifteen \<and> six
\<noteq> sixteen \<and> six \<noteq> seventeen \<and> six \<noteq>
eighteen \<and> six \<noteq> nineteen \<and> six \<noteq> twenty
\<and> six \<noteq> twentyone \<and> six \<noteq> twentytwo \<and> six
\<noteq> twentythree \<and> six \<noteq> twentyfour \<and> six
\<noteq> twentyfive \<and> six \<noteq> twentysix \<and> six \<noteq>
twentyseven \<and> six \<noteq> twentyeight \<and> six \<noteq>
twentynine \<and> six \<noteq> thirty \<and> six \<noteq> thirtyone
\<and> seven \<noteq> one \<and> seven \<noteq> two \<and> seven
\<noteq> three \<and> seven \<noteq> four \<and> seven \<noteq> five
\<and> seven \<noteq> six \<and> seven \<noteq> eight \<and> seven
\<noteq> nine \<and> seven \<noteq> ten \<and> seven \<noteq> eleven
\<and> seven \<noteq> twelve \<and> seven \<noteq> thirteen \<and> seven
\<noteq> fourteen \<and> seven \<noteq> fifteen \<and> seven \<noteq>
sixteen \<and> seven \<noteq> seventeen \<and> seven \<noteq> eighteen
\<and> seven \<noteq> nineteen \<and> seven \<noteq> twenty \<and>
seven \<noteq> twentyone \<and> seven \<noteq> twentytwo \<and> seven
\<noteq> twentythree \<and> seven \<noteq> twentyfour \<and> seven
\<noteq> twentyfive \<and> seven \<noteq> twentysix \<and> seven
\<noteq> twentyseven \<and> seven \<noteq> twentyeight \<and> seven
\<noteq> twentynine \<and> seven \<noteq> thirty \<and> seven \<noteq>
thirtyone \<and> eight \<noteq> one \<and> eight \<noteq> two \<and>
eight \<noteq> three \<and> eight \<noteq> four \<and> eight \<noteq>
five \<and> eight \<noteq> six \<and> eight \<noteq> seven \<and>
eight \<noteq> nine \<and> eight \<noteq> ten \<and> eight \<noteq>
eleven \<and> eight \<noteq> twelve \<and> eight \<noteq> thirteen \<and>
eight \<noteq> fourteen \<and> eight \<noteq> fifteen \<and> eight \<noteq>
sixteen \<and> eight \<noteq> seventeen \<and> eight \<noteq> eighteen
\<and> eight \<noteq> nineteen \<and> eight \<noteq> twenty \<and>
eight \<noteq> twentyone \<and> eight \<noteq> twentytwo \<and> eight
\<noteq> twentythree \<and> eight \<noteq> twentyfour \<and> eight
\<noteq> twentyfive \<and> eight \<noteq> twentysix \<and> eight
\<noteq> twentyseven \<and> eight \<noteq> twentyeight \<and> eight
\<noteq> twentynine \<and> eight \<noteq> thirty \<and> eight \<noteq>
thirtyone \<and> nine \<noteq> one \<and> nine \<noteq> two \<and>
nine \<noteq> three \<and> nine \<noteq> four \<and> nine \<noteq>
five \<and> nine \<noteq> six \<and> nine \<noteq> seven \<and> nine
\<noteq> eight \<and> nine \<noteq> ten \<and> nine \<noteq> eleven
\<and> nine \<noteq> twelve \<and> nine \<noteq> thirteen \<and> nine
\<noteq> fourteen \<and> nine \<noteq> fifteen \<and> nine \<noteq> sixteen
\<and> nine \<noteq> seventeen \<and> nine \<noteq> eighteen \<and>
nine \<noteq> nineteen \<and> nine \<noteq> twenty \<and> nine
\<noteq> twentyone \<and> nine \<noteq> twentytwo \<and> nine \<noteq>
twentythree \<and> nine \<noteq> twentyfour \<and> nine \<noteq>
twentyfive \<and> nine \<noteq> twentysix \<and> nine \<noteq>
twentyseven \<and> nine \<noteq> twentyeight \<and> nine \<noteq>
twentynine \<and> nine \<noteq> thirty \<and> nine \<noteq> thirtyone
\<and> ten \<noteq> one \<and> ten \<noteq> two \<and> ten \<noteq>
three \<and> ten \<noteq> four \<and> ten \<noteq> five \<and> ten
\<noteq> six \<and> ten \<noteq> seven \<and> ten \<noteq> eight
\<and> ten \<noteq> nine \<and> ten \<noteq> eleven \<and> ten
\<noteq> twelve \<and> ten \<noteq> thirteen \<and> ten \<noteq> fourteen
\<and> ten \<noteq> fifteen \<and> ten \<noteq> sixteen \<and> ten \<noteq>
seventeen \<and> ten \<noteq> eighteen \<and> ten \<noteq> nineteen
\<and> ten \<noteq> twenty \<and> ten \<noteq> twentyone \<and> ten
\<noteq> twentytwo \<and> ten \<noteq> twentythree \<and> ten \<noteq>
twentyfour \<and> ten \<noteq> twentyfive \<and> ten \<noteq>
twentysix \<and> ten \<noteq> twentyseven \<and> ten \<noteq>
twentyeight \<and> ten \<noteq> twentynine \<and> ten \<noteq> thirty
\<and> ten \<noteq> thirtyone \<and> eleven \<noteq> one \<and> eleven
\<noteq> two \<and> eleven \<noteq> three \<and> eleven \<noteq> four
\<and> eleven \<noteq> five \<and> eleven \<noteq> six \<and> eleven
\<noteq> seven \<and> eleven \<noteq> eight \<and> eleven \<noteq>
nine \<and> eleven \<noteq> ten \<and> eleven \<noteq> twelve \<and>
eleven \<noteq> thirteen \<and> eleven \<noteq> fourteen \<and> eleven
\<noteq> fifteen \<and> eleven \<noteq> sixteen \<and> eleven \<noteq>
seventeen \<and> eleven \<noteq> eighteen \<and> eleven \<noteq>
nineteen \<and> eleven \<noteq> twenty \<and> eleven \<noteq>
twentyone \<and> eleven \<noteq> twentytwo \<and> eleven \<noteq>
twentythree \<and> eleven \<noteq> twentyfour \<and> eleven \<noteq>
twentyfive \<and> eleven \<noteq> twentysix \<and> eleven \<noteq>
twentyseven \<and> eleven \<noteq> twentyeight \<and> eleven \<noteq>
twentynine \<and> eleven \<noteq> thirty \<and> eleven \<noteq>
thirtyone \<and> twelve \<noteq> one \<and> twelve \<noteq> two \<and>
twelve \<noteq> three \<and> twelve \<noteq> four \<and> twelve
\<noteq> five \<and> twelve \<noteq> six \<and> twelve \<noteq> seven
\<and> twelve \<noteq> eight \<and> twelve \<noteq> nine \<and> twelve
\<noteq> ten \<and> twelve \<noteq> eleven \<and> twelve \<noteq> thirteen
\<and> twelve \<noteq> fourteen \<and> twelve \<noteq> fifteen \<and>
twelve \<noteq> sixteen \<and> twelve \<noteq> seventeen \<and> twelve
\<noteq> eighteen \<and> twelve \<noteq> nineteen \<and> twelve
\<noteq> twenty \<and> twelve \<noteq> twentyone \<and> twelve
\<noteq> twentytwo \<and> twelve \<noteq> twentythree \<and> twelve
\<noteq> twentyfour \<and> twelve \<noteq> twentyfive \<and> twelve
\<noteq> twentysix \<and> twelve \<noteq> twentyseven \<and> twelve
\<noteq> twentyeight \<and> twelve \<noteq> twentynine \<and> twelve
\<noteq> thirty \<and> twelve \<noteq> thirtyone \<and> thirteen \<noteq>
one \<and> thirteen \<noteq> two \<and> thirteen \<noteq> three \<and> thirteen \<noteq>
four \<and> thirteen \<noteq> five \<and> thirteen \<noteq> six \<and> thirteen \<noteq>
seven \<and> thirteen \<noteq> eight \<and> thirteen \<noteq> nine \<and> thirteen
\<noteq> ten \<and> thirteen \<noteq> eleven \<and> thirteen \<noteq> twelve
\<and> thirteen \<noteq> fourteen \<and> thirteen \<noteq> fifteen \<and> thirteen \<noteq>
sixteen \<and> thirteen \<noteq> seventeen \<and> thirteen \<noteq> eighteen
\<and> thirteen \<noteq> nineteen \<and> thirteen \<noteq> twenty \<and> thirteen
\<noteq> twentyone \<and> thirteen \<noteq> twentytwo \<and> thirteen \<noteq>
twentythree \<and> thirteen \<noteq> twentyfour \<and> thirteen \<noteq>
twentyfive \<and> thirteen \<noteq> twentysix \<and> thirteen \<noteq> twentyseven
\<and> thirteen \<noteq> twentyeight \<and> thirteen \<noteq> twentynine \<and> thirteen
\<noteq> thirty \<and> thirteen \<noteq> thirtyone \<and> fourteen \<noteq>
one \<and> fourteen \<noteq> two \<and> fourteen \<noteq> three \<and>
fourteen \<noteq> four \<and> fourteen \<noteq> five \<and> fourteen
\<noteq> six \<and> fourteen \<noteq> seven \<and> fourteen \<noteq>
eight \<and> fourteen \<noteq> nine \<and> fourteen \<noteq> ten
\<and> fourteen \<noteq> eleven \<and> fourteen \<noteq> twelve \<and>
fourteen \<noteq> thirteen \<and> fourteen \<noteq> fifteen \<and> fourteen
\<noteq> sixteen \<and> fourteen \<noteq> seventeen \<and> fourteen
\<noteq> eighteen \<and> fourteen \<noteq> nineteen \<and> fourteen
\<noteq> twenty \<and> fourteen \<noteq> twentyone \<and> fourteen
\<noteq> twentytwo \<and> fourteen \<noteq> twentythree \<and>
fourteen \<noteq> twentyfour \<and> fourteen \<noteq> twentyfive
\<and> fourteen \<noteq> twentysix \<and> fourteen \<noteq>
twentyseven \<and> fourteen \<noteq> twentyeight \<and> fourteen
\<noteq> twentynine \<and> fourteen \<noteq> thirty \<and> fourteen
\<noteq> thirtyone \<and> fifteen \<noteq> one \<and> fifteen \<noteq> two
\<and> fifteen \<noteq> three \<and> fifteen \<noteq> four \<and> fifteen \<noteq>
five \<and> fifteen \<noteq> six \<and> fifteen \<noteq> seven \<and> fifteen
\<noteq> eight \<and> fifteen \<noteq> nine \<and> fifteen \<noteq> ten \<and>
fifteen \<noteq> eleven \<and> fifteen \<noteq> twelve \<and> fifteen \<noteq> thirteen
\<and> fifteen \<noteq> fourteen \<and> fifteen \<noteq> sixteen \<and> fifteen
\<noteq> seventeen \<and> fifteen \<noteq> eighteen \<and> fifteen \<noteq>
nineteen \<and> fifteen \<noteq> twenty \<and> fifteen \<noteq> twentyone \<and>
fifteen \<noteq> twentytwo \<and> fifteen \<noteq> twentythree \<and> fifteen
\<noteq> twentyfour \<and> fifteen \<noteq> twentyfive \<and> fifteen \<noteq>
twentysix \<and> fifteen \<noteq> twentyseven \<and> fifteen \<noteq>
twentyeight \<and> fifteen \<noteq> twentynine \<and> fifteen \<noteq> thirty
\<and> fifteen \<noteq> thirtyone \<and> sixteen \<noteq> one \<and>
sixteen \<noteq> two \<and> sixteen \<noteq> three \<and> sixteen
\<noteq> four \<and> sixteen \<noteq> five \<and> sixteen \<noteq> six
\<and> sixteen \<noteq> seven \<and> sixteen \<noteq> eight \<and>
sixteen \<noteq> nine \<and> sixteen \<noteq> ten \<and> sixteen
\<noteq> eleven \<and> sixteen \<noteq> twelve \<and> sixteen \<noteq>
thirteen \<and> sixteen \<noteq> fourteen \<and> sixteen \<noteq> fifteen \<and>
sixteen \<noteq> seventeen \<and> sixteen \<noteq> eighteen \<and>
sixteen \<noteq> nineteen \<and> sixteen \<noteq> twenty \<and>
sixteen \<noteq> twentyone \<and> sixteen \<noteq> twentytwo \<and>
sixteen \<noteq> twentythree \<and> sixteen \<noteq> twentyfour \<and>
sixteen \<noteq> twentyfive \<and> sixteen \<noteq> twentysix \<and>
sixteen \<noteq> twentyseven \<and> sixteen \<noteq> twentyeight
\<and> sixteen \<noteq> twentynine \<and> sixteen \<noteq> thirty
\<and> sixteen \<noteq> thirtyone \<and> seventeen \<noteq> one \<and>
seventeen \<noteq> two \<and> seventeen \<noteq> three \<and>
seventeen \<noteq> four \<and> seventeen \<noteq> five \<and>
seventeen \<noteq> six \<and> seventeen \<noteq> seven \<and>
seventeen \<noteq> eight \<and> seventeen \<noteq> nine \<and>
seventeen \<noteq> ten \<and> seventeen \<noteq> eleven \<and>
seventeen \<noteq> twelve \<and> seventeen \<noteq> thirteen \<and>
seventeen \<noteq> fourteen \<and> seventeen \<noteq> fifteen \<and>
seventeen \<noteq> sixteen \<and> seventeen \<noteq> eighteen \<and>
seventeen \<noteq> nineteen \<and> seventeen \<noteq> twenty \<and>
seventeen \<noteq> twentyone \<and> seventeen \<noteq> twentytwo
\<and> seventeen \<noteq> twentythree \<and> seventeen \<noteq>
twentyfour \<and> seventeen \<noteq> twentyfive \<and> seventeen
\<noteq> twentysix \<and> seventeen \<noteq> twentyseven \<and>
seventeen \<noteq> twentyeight \<and> seventeen \<noteq> twentynine
\<and> seventeen \<noteq> thirty \<and> seventeen \<noteq> thirtyone
\<and> eighteen \<noteq> one \<and> eighteen \<noteq> two \<and>
eighteen \<noteq> three \<and> eighteen \<noteq> four \<and> eighteen
\<noteq> five \<and> eighteen \<noteq> six \<and> eighteen \<noteq>
seven \<and> eighteen \<noteq> eight \<and> eighteen \<noteq> nine
\<and> eighteen \<noteq> ten \<and> eighteen \<noteq> eleven \<and>
eighteen \<noteq> twelve \<and> eighteen \<noteq> thirteen \<and> eighteen
\<noteq> fourteen \<and> eighteen \<noteq> fifteen \<and> eighteen \<noteq>
sixteen \<and> eighteen \<noteq> seventeen \<and> eighteen \<noteq>
nineteen \<and> eighteen \<noteq> twenty \<and> eighteen \<noteq>
twentyone \<and> eighteen \<noteq> twentytwo \<and> eighteen \<noteq>
twentythree \<and> eighteen \<noteq> twentyfour \<and> eighteen
\<noteq> twentyfive \<and> eighteen \<noteq> twentysix \<and> eighteen
\<noteq> twentyseven \<and> eighteen \<noteq> twentyeight \<and>
eighteen \<noteq> twentynine \<and> eighteen \<noteq> thirty \<and>
eighteen \<noteq> thirtyone \<and> nineteen \<noteq> one \<and>
nineteen \<noteq> two \<and> nineteen \<noteq> three \<and> nineteen
\<noteq> four \<and> nineteen \<noteq> five \<and> nineteen \<noteq>
six \<and> nineteen \<noteq> seven \<and> nineteen \<noteq> eight
\<and> nineteen \<noteq> nine \<and> nineteen \<noteq> ten \<and>
nineteen \<noteq> eleven \<and> nineteen \<noteq> twelve \<and>
nineteen \<noteq> thirteen \<and> nineteen \<noteq> fourteen \<and> nineteen
\<noteq> fifteen \<and> nineteen \<noteq> sixteen \<and> nineteen \<noteq>
seventeen \<and> nineteen \<noteq> eighteen \<and> nineteen \<noteq>
twenty \<and> nineteen \<noteq> twentyone \<and> nineteen \<noteq>
twentytwo \<and> nineteen \<noteq> twentythree \<and> nineteen
\<noteq> twentyfour \<and> nineteen \<noteq> twentyfive \<and>
nineteen \<noteq> twentysix \<and> nineteen \<noteq> twentyseven
\<and> nineteen \<noteq> twentyeight \<and> nineteen \<noteq>
twentynine \<and> nineteen \<noteq> thirty \<and> nineteen \<noteq>
thirtyone \<and> twenty \<noteq> one \<and> twenty \<noteq> two \<and>
twenty \<noteq> three \<and> twenty \<noteq> four \<and> twenty
\<noteq> five \<and> twenty \<noteq> six \<and> twenty \<noteq> seven
\<and> twenty \<noteq> eight \<and> twenty \<noteq> nine \<and> twenty
\<noteq> ten \<and> twenty \<noteq> eleven \<and> twenty \<noteq>
twelve \<and> twenty \<noteq> thirteen \<and> twenty \<noteq> fourteen
\<and> twenty \<noteq> fifteen \<and> twenty \<noteq> sixteen \<and> twenty
\<noteq> seventeen \<and> twenty \<noteq> eighteen \<and> twenty
\<noteq> nineteen \<and> twenty \<noteq> twentyone \<and> twenty
\<noteq> twentytwo \<and> twenty \<noteq> twentythree \<and> twenty
\<noteq> twentyfour \<and> twenty \<noteq> twentyfive \<and> twenty
\<noteq> twentysix \<and> twenty \<noteq> twentyseven \<and> twenty
\<noteq> twentyeight \<and> twenty \<noteq> twentynine \<and> twenty
\<noteq> thirty \<and> twenty \<noteq> thirtyone \<and> twentyone
\<noteq> one \<and> twentyone \<noteq> two \<and> twentyone \<noteq>
three \<and> twentyone \<noteq> four \<and> twentyone \<noteq> five
\<and> twentyone \<noteq> six \<and> twentyone \<noteq> seven \<and>
twentyone \<noteq> eight \<and> twentyone \<noteq> nine \<and>
twentyone \<noteq> ten \<and> twentyone \<noteq> eleven \<and>
twentyone \<noteq> twelve \<and> twentyone \<noteq> thirteen \<and>
twentyone \<noteq> fourteen \<and> twentyone \<noteq> fifteen \<and>
twentyone \<noteq> sixteen \<and> twentyone \<noteq> seventeen \<and>
twentyone \<noteq> eighteen \<and> twentyone \<noteq> nineteen \<and>
twentyone \<noteq> twenty \<and> twentyone \<noteq> twentytwo \<and>
twentyone \<noteq> twentythree \<and> twentyone \<noteq> twentyfour
\<and> twentyone \<noteq> twentyfive \<and> twentyone \<noteq>
twentysix \<and> twentyone \<noteq> twentyseven \<and> twentyone
\<noteq> twentyeight \<and> twentyone \<noteq> twentynine \<and>
twentyone \<noteq> thirty \<and> twentyone \<noteq> thirtyone \<and>
twentytwo \<noteq> one \<and> twentytwo \<noteq> two \<and> twentytwo
\<noteq> three \<and> twentytwo \<noteq> four \<and> twentytwo
\<noteq> five \<and> twentytwo \<noteq> six \<and> twentytwo \<noteq>
seven \<and> twentytwo \<noteq> eight \<and> twentytwo \<noteq> nine
\<and> twentytwo \<noteq> ten \<and> twentytwo \<noteq> eleven \<and>
twentytwo \<noteq> twelve \<and> twentytwo \<noteq> thirteen \<and>
twentytwo \<noteq> fourteen \<and> twentytwo \<noteq> fifteen \<and>
twentytwo \<noteq> sixteen \<and> twentytwo \<noteq> seventeen \<and>
twentytwo \<noteq> eighteen \<and> twentytwo \<noteq> nineteen \<and>
twentytwo \<noteq> twenty \<and> twentytwo \<noteq> twentyone \<and>
twentytwo \<noteq> twentythree \<and> twentytwo \<noteq> twentyfour
\<and> twentytwo \<noteq> twentyfive \<and> twentytwo \<noteq>
twentysix \<and> twentytwo \<noteq> twentyseven \<and> twentytwo
\<noteq> twentyeight \<and> twentytwo \<noteq> twentynine \<and>
twentytwo \<noteq> thirty \<and> twentytwo \<noteq> thirtyone \<and>
twentythree \<noteq> one \<and> twentythree \<noteq> two \<and>
twentythree \<noteq> three \<and> twentythree \<noteq> four \<and>
twentythree \<noteq> five \<and> twentythree \<noteq> six \<and>
twentythree \<noteq> seven \<and> twentythree \<noteq> eight \<and>
twentythree \<noteq> nine \<and> twentythree \<noteq> ten \<and>
twentythree \<noteq> eleven \<and> twentythree \<noteq> twelve \<and>
twentythree \<noteq> thirteen \<and> twentythree \<noteq> fourteen \<and>
twentythree \<noteq> fifteen \<and> twentythree \<noteq> sixteen \<and>
twentythree \<noteq> seventeen \<and> twentythree \<noteq> eighteen
\<and> twentythree \<noteq> nineteen \<and> twentythree \<noteq>
twenty \<and> twentythree \<noteq> twentyone \<and> twentythree
\<noteq> twentytwo \<and> twentythree \<noteq> twentyfour \<and>
twentythree \<noteq> twentyfive \<and> twentythree \<noteq> twentysix
\<and> twentythree \<noteq> twentyseven \<and> twentythree \<noteq>
twentyeight \<and> twentythree \<noteq> twentynine \<and> twentythree
\<noteq> thirty \<and> twentythree \<noteq> thirtyone \<and>
twentyfour \<noteq> one \<and> twentyfour \<noteq> two \<and>
twentyfour \<noteq> three \<and> twentyfour \<noteq> four \<and>
twentyfour \<noteq> five \<and> twentyfour \<noteq> six \<and>
twentyfour \<noteq> seven \<and> twentyfour \<noteq> eight \<and>
twentyfour \<noteq> nine \<and> twentyfour \<noteq> ten \<and>
twentyfour \<noteq> eleven \<and> twentyfour \<noteq> twelve \<and>
twentyfour \<noteq> thirteen \<and> twentyfour \<noteq> fourteen \<and>
twentyfour \<noteq> fifteen \<and> twentyfour \<noteq> sixteen \<and>
twentyfour \<noteq> seventeen \<and> twentyfour \<noteq> eighteen
\<and> twentyfour \<noteq> nineteen \<and> twentyfour \<noteq> twenty
\<and> twentyfour \<noteq> twentyone \<and> twentyfour \<noteq>
twentytwo \<and> twentyfour \<noteq> twentythree \<and> twentyfour
\<noteq> twentyfive \<and> twentyfour \<noteq> twentysix \<and>
twentyfour \<noteq> twentyseven \<and> twentyfour \<noteq> twentyeight
\<and> twentyfour \<noteq> twentynine \<and> twentyfour \<noteq>
thirty \<and> twentyfour \<noteq> thirtyone \<and> twentyfive \<noteq>
one \<and> twentyfive \<noteq> two \<and> twentyfive \<noteq> three
\<and> twentyfive \<noteq> four \<and> twentyfive \<noteq> five \<and>
twentyfive \<noteq> six \<and> twentyfive \<noteq> seven \<and>
twentyfive \<noteq> eight \<and> twentyfive \<noteq> nine \<and>
twentyfive \<noteq> ten \<and> twentyfive \<noteq> eleven \<and>
twentyfive \<noteq> twelve \<and> twentyfive \<noteq> thirteen \<and>
twentyfive \<noteq> fourteen \<and> twentyfive \<noteq> fifteen \<and>
twentyfive \<noteq> sixteen \<and> twentyfive \<noteq> seventeen
\<and> twentyfive \<noteq> eighteen \<and> twentyfive \<noteq>
nineteen \<and> twentyfive \<noteq> twenty \<and> twentyfive \<noteq>
twentyone \<and> twentyfive \<noteq> twentytwo \<and> twentyfive
\<noteq> twentythree \<and> twentyfive \<noteq> twentyfour \<and>
twentyfive \<noteq> twentysix \<and> twentyfive \<noteq> twentyseven
\<and> twentyfive \<noteq> twentyeight \<and> twentyfive \<noteq>
twentynine \<and> twentyfive \<noteq> thirty \<and> twentyfive
\<noteq> thirtyone \<and> twentysix \<noteq> one \<and> twentysix
\<noteq> two \<and> twentysix \<noteq> three \<and> twentysix \<noteq>
four \<and> twentysix \<noteq> five \<and> twentysix \<noteq> six
\<and> twentysix \<noteq> seven \<and> twentysix \<noteq> eight \<and>
twentysix \<noteq> nine \<and> twentysix \<noteq> ten \<and> twentysix
\<noteq> eleven \<and> twentysix \<noteq> twelve \<and> twentysix
\<noteq> thirteen \<and> twentysix \<noteq> fourteen \<and> twentysix
\<noteq> fifteen \<and> twentysix \<noteq> sixteen \<and> twentysix
\<noteq> seventeen \<and> twentysix \<noteq> eighteen \<and> twentysix
\<noteq> nineteen \<and> twentysix \<noteq> twenty \<and> twentysix
\<noteq> twentyone \<and> twentysix \<noteq> twentytwo \<and>
twentysix \<noteq> twentythree \<and> twentysix \<noteq> twentyfour
\<and> twentysix \<noteq> twentyfive \<and> twentysix \<noteq>
twentyseven \<and> twentysix \<noteq> twentyeight \<and> twentysix
\<noteq> twentynine \<and> twentysix \<noteq> thirty \<and> twentysix
\<noteq> thirtyone \<and> twentyseven \<noteq> one \<and> twentyseven
\<noteq> two \<and> twentyseven \<noteq> three \<and> twentyseven
\<noteq> four \<and> twentyseven \<noteq> five \<and> twentyseven
\<noteq> six \<and> twentyseven \<noteq> seven \<and> twentyseven
\<noteq> eight \<and> twentyseven \<noteq> nine \<and> twentyseven
\<noteq> ten \<and> twentyseven \<noteq> eleven \<and> twentyseven
\<noteq> twelve \<and> twentyseven \<noteq> thirteen \<and> twentyseven
\<noteq> fourteen \<and> twentyseven \<noteq> fifteen \<and> twentyseven
\<noteq> sixteen \<and> twentyseven \<noteq> seventeen \<and>
twentyseven \<noteq> eighteen \<and> twentyseven \<noteq> nineteen
\<and> twentyseven \<noteq> twenty \<and> twentyseven \<noteq>
twentyone \<and> twentyseven \<noteq> twentytwo \<and> twentyseven
\<noteq> twentythree \<and> twentyseven \<noteq> twentyfour \<and>
twentyseven \<noteq> twentyfive \<and> twentyseven \<noteq> twentysix
\<and> twentyseven \<noteq> twentyeight \<and> twentyseven \<noteq>
twentynine \<and> twentyseven \<noteq> thirty \<and> twentyseven
\<noteq> thirtyone \<and> twentyeight \<noteq> one \<and> twentyeight
\<noteq> two \<and> twentyeight \<noteq> three \<and> twentyeight
\<noteq> four \<and> twentyeight \<noteq> five \<and> twentyeight
\<noteq> six \<and> twentyeight \<noteq> seven \<and> twentyeight
\<noteq> eight \<and> twentyeight \<noteq> nine \<and> twentyeight
\<noteq> ten \<and> twentyeight \<noteq> eleven \<and> twentyeight
\<noteq> twelve \<and> twentyeight \<noteq> thirteen \<and> twentyeight
\<noteq> fourteen \<and> twentyeight \<noteq> fifteen \<and> twentyeight
\<noteq> sixteen \<and> twentyeight \<noteq> seventeen \<and>
twentyeight \<noteq> eighteen \<and> twentyeight \<noteq> nineteen
\<and> twentyeight \<noteq> twenty \<and> twentyeight \<noteq>
twentyone \<and> twentyeight \<noteq> twentytwo \<and> twentyeight
\<noteq> twentythree \<and> twentyeight \<noteq> twentyfour \<and>
twentyeight \<noteq> twentyfive \<and> twentyeight \<noteq> twentysix
\<and> twentyeight \<noteq> twentyseven \<and> twentyeight \<noteq>
twentynine \<and> twentyeight \<noteq> thirty \<and> twentyeight
\<noteq> thirtyone \<and> twentynine \<noteq> one \<and> twentynine
\<noteq> two \<and> twentynine \<noteq> three \<and> twentynine
\<noteq> four \<and> twentynine \<noteq> five \<and> twentynine
\<noteq> six \<and> twentynine \<noteq> seven \<and> twentynine
\<noteq> eight \<and> twentynine \<noteq> nine \<and> twentynine
\<noteq> ten \<and> twentynine \<noteq> eleven \<and> twentynine
\<noteq> twelve \<and> twentynine \<noteq> thirteen \<and> twentynine
\<noteq> fourteen \<and> twentynine \<noteq> fifteen \<and> twentynine
\<noteq> sixteen \<and> twentynine \<noteq> seventeen \<and>
twentynine \<noteq> eighteen \<and> twentynine \<noteq> nineteen
\<and> twentynine \<noteq> twenty \<and> twentynine \<noteq> twentyone
\<and> twentynine \<noteq> twentytwo \<and> twentynine \<noteq>
twentythree \<and> twentynine \<noteq> twentyfour \<and> twentynine
\<noteq> twentyfive \<and> twentynine \<noteq> twentysix \<and>
twentynine \<noteq> twentyseven \<and> twentynine \<noteq> twentyeight
\<and> twentynine \<noteq> thirty \<and> twentynine \<noteq> thirtyone
\<and> thirty \<noteq> one \<and> thirty \<noteq> two \<and> thirty
\<noteq> three \<and> thirty \<noteq> four \<and> thirty \<noteq> five
\<and> thirty \<noteq> six \<and> thirty \<noteq> seven \<and> thirty
\<noteq> eight \<and> thirty \<noteq> nine \<and> thirty \<noteq> ten
\<and> thirty \<noteq> eleven \<and> thirty \<noteq> twelve \<and>
thirty \<noteq> thirteen \<and> thirty \<noteq> fourteen \<and> thirty
\<noteq> fifteen \<and> thirty \<noteq> sixteen \<and> thirty \<noteq>
seventeen \<and> thirty \<noteq> eighteen \<and> thirty \<noteq>
nineteen \<and> thirty \<noteq> twenty \<and> thirty \<noteq>
twentyone \<and> thirty \<noteq> twentytwo \<and> thirty \<noteq>
twentythree \<and> thirty \<noteq> twentyfour \<and> thirty \<noteq>
twentyfive \<and> thirty \<noteq> twentysix \<and> thirty \<noteq>
twentyseven \<and> thirty \<noteq> twentyeight \<and> thirty \<noteq>
twentynine \<and> thirty \<noteq> thirtyone \<and> thirtyone \<noteq>
one \<and> thirtyone \<noteq> two \<and> thirtyone \<noteq> three
\<and> thirtyone \<noteq> four \<and> thirtyone \<noteq> five \<and>
thirtyone \<noteq> six \<and> thirtyone \<noteq> seven \<and>
thirtyone \<noteq> eight \<and> thirtyone \<noteq> nine \<and>
thirtyone \<noteq> ten \<and> thirtyone \<noteq> eleven \<and>
thirtyone \<noteq> twelve \<and> thirtyone \<noteq> thirteen \<and>
thirtyone \<noteq> fourteen \<and> thirtyone \<noteq> fifteen \<and>
thirtyone \<noteq> sixteen \<and> thirtyone \<noteq> seventeen \<and>
thirtyone \<noteq> eighteen \<and> thirtyone \<noteq> nineteen \<and>
thirtyone \<noteq> twenty \<and> thirtyone \<noteq> twentyone \<and>
thirtyone \<noteq> twentytwo \<and> thirtyone \<noteq> twentythree
\<and> thirtyone \<noteq> twentyfour \<and> thirtyone \<noteq>
twentyfive \<and> thirtyone \<noteq> twentysix \<and> thirtyone
\<noteq> twentyseven \<and> thirtyone \<noteq> twentyeight \<and>
thirtyone \<noteq> twentynine \<and> thirtyone \<noteq> thirty"
apply (simp add: UnfoldPolicy) 
apply (auto simp: sets_distinct1) 
done


lemma nets_distinct_aux:
"a\<noteq>b \<Longrightarrow> netsDistinct {{(x,y). x = a}} {{(x,y). x = b}}"
apply (simp add: netsDistinct_def)
apply (simp add: in_subnet_def)
done

lemma netsDistinct: 
" netsDistinct one  two \<and> netsDistinct one  three
\<and> netsDistinct one  four \<and> netsDistinct one  five \<and> netsDistinct one 
six \<and> netsDistinct one  seven \<and> netsDistinct one  eight \<and> netsDistinct one
 nine \<and> netsDistinct one  ten \<and> netsDistinct one  eleven
\<and> netsDistinct one  twelve \<and> netsDistinct one  thirteen \<and> netsDistinct one 
fourteen \<and> netsDistinct one  fifteen \<and> netsDistinct one  sixteen \<and> netsDistinct one
 seventeen \<and> netsDistinct one  eighteen \<and> netsDistinct one 
nineteen \<and> netsDistinct one  twenty \<and> netsDistinct one  twentyone
\<and> netsDistinct one  twentytwo \<and> netsDistinct one  twentythree \<and> netsDistinct
one  twentyfour \<and> netsDistinct one  twentyfive \<and> netsDistinct one
 twentysix \<and> netsDistinct one  twentyseven \<and> netsDistinct one 
twentyeight \<and> netsDistinct one  twentynine \<and> netsDistinct one  thirty
\<and> netsDistinct one  thirtyone \<and> netsDistinct two  one \<and> netsDistinct two
 three \<and> netsDistinct two  four \<and> netsDistinct two  five
\<and> netsDistinct two  six \<and> netsDistinct two  seven \<and> netsDistinct two 
eight \<and> netsDistinct two  nine \<and> netsDistinct two  ten \<and> netsDistinct two
 eleven \<and> netsDistinct two  twelve \<and> netsDistinct two  thirteen
\<and> netsDistinct two  fourteen \<and> netsDistinct two  fifteen \<and> netsDistinct two
 sixteen \<and> netsDistinct two  seventeen \<and> netsDistinct two 
eighteen \<and> netsDistinct two  nineteen \<and> netsDistinct two  twenty
\<and> netsDistinct two  twentyone \<and> netsDistinct two  twentytwo \<and> netsDistinct two
 twentythree \<and> netsDistinct two  twentyfour \<and> netsDistinct two
 twentyfive \<and> netsDistinct two  twentysix \<and> netsDistinct two 
twentyseven \<and> netsDistinct two  twentyeight \<and> netsDistinct two 
twentynine \<and> netsDistinct two  thirty \<and> netsDistinct two  thirtyone
\<and> netsDistinct three  one \<and> netsDistinct three  two \<and> netsDistinct three
 four \<and> netsDistinct three  five \<and> netsDistinct three  six
\<and> netsDistinct three  seven \<and> netsDistinct three  eight \<and> netsDistinct three
 nine \<and> netsDistinct three  ten \<and> netsDistinct three  eleven
\<and> netsDistinct three  twelve \<and> netsDistinct three  thirteen \<and> netsDistinct three
 fourteen \<and> netsDistinct three  fifteen \<and> netsDistinct three 
sixteen \<and> netsDistinct three  seventeen \<and> netsDistinct three  eighteen
\<and> netsDistinct three  nineteen \<and> netsDistinct three  twenty \<and> netsDistinct
three  twentyone \<and> netsDistinct three  twentytwo \<and> netsDistinct three
 twentythree \<and> netsDistinct three  twentyfour \<and> netsDistinct three
 twentyfive \<and> netsDistinct three  twentysix \<and> netsDistinct three
 twentyseven \<and> netsDistinct three  twentyeight \<and> netsDistinct three
 twentynine \<and> netsDistinct three  thirty \<and> netsDistinct three 
thirtyone \<and> netsDistinct four  one \<and> netsDistinct four  two \<and> netsDistinct
four  three \<and> netsDistinct four  five \<and> netsDistinct four  six
\<and> netsDistinct four  seven \<and> netsDistinct four  eight \<and> netsDistinct four
 nine \<and> netsDistinct four  ten \<and> netsDistinct four  eleven
\<and> netsDistinct four  twelve \<and> netsDistinct four  thirteen \<and> netsDistinct four
 fourteen \<and> netsDistinct four  fifteen \<and> netsDistinct four  sixteen
\<and> netsDistinct four  seventeen \<and> netsDistinct four  eighteen \<and> netsDistinct
four  nineteen \<and> netsDistinct four  twenty \<and> netsDistinct four
 twentyone \<and> netsDistinct four  twentytwo \<and> netsDistinct four 
twentythree \<and> netsDistinct four  twentyfour \<and> netsDistinct four 
twentyfive \<and> netsDistinct four  twentysix \<and> netsDistinct four 
twentyseven \<and> netsDistinct four  twentyeight \<and> netsDistinct four 
twentynine \<and> netsDistinct four  thirty \<and> netsDistinct four  thirtyone
\<and> netsDistinct five  one \<and> netsDistinct five  two \<and> netsDistinct five 
three \<and> netsDistinct five  four \<and> netsDistinct five  six \<and> netsDistinct five
 seven \<and> netsDistinct five  eight \<and> netsDistinct five  nine
\<and> netsDistinct five  ten \<and> netsDistinct five  eleven \<and> netsDistinct five
 twelve \<and> netsDistinct five  thirteen \<and> netsDistinct five  fourteen
\<and> netsDistinct five  fifteen \<and> netsDistinct five  sixteen \<and> netsDistinct five
 seventeen \<and> netsDistinct five  eighteen \<and> netsDistinct five 
nineteen \<and> netsDistinct five  twenty \<and> netsDistinct five  twentyone
\<and> netsDistinct five  twentytwo \<and> netsDistinct five  twentythree \<and> netsDistinct
five  twentyfour \<and> netsDistinct five  twentyfive \<and> netsDistinct five
 twentysix \<and> netsDistinct five  twentyseven \<and> netsDistinct five
 twentyeight \<and> netsDistinct five  twentynine \<and> netsDistinct five
 thirty \<and> netsDistinct five  thirtyone \<and> netsDistinct six  one
\<and> netsDistinct six  two \<and> netsDistinct six  three \<and> netsDistinct six 
four \<and> netsDistinct six  five \<and> netsDistinct six  seven \<and> netsDistinct six
 eight \<and> netsDistinct six  nine \<and> netsDistinct six  ten \<and> netsDistinct
six  eleven \<and> netsDistinct six  twelve \<and> netsDistinct six  thirteen
\<and> netsDistinct six  fourteen \<and> netsDistinct six  fifteen \<and> netsDistinct six
 sixteen \<and> netsDistinct six  seventeen \<and> netsDistinct six 
eighteen \<and> netsDistinct six  nineteen \<and> netsDistinct six  twenty
\<and> netsDistinct six  twentyone \<and> netsDistinct six  twentytwo \<and> netsDistinct six
 twentythree \<and> netsDistinct six  twentyfour \<and> netsDistinct six
 twentyfive \<and> netsDistinct six  twentysix \<and> netsDistinct six 
twentyseven \<and> netsDistinct six  twentyeight \<and> netsDistinct six 
twentynine \<and> netsDistinct six  thirty \<and> netsDistinct six  thirtyone
\<and> netsDistinct seven  one \<and> netsDistinct seven  two \<and> netsDistinct seven
 three \<and> netsDistinct seven  four \<and> netsDistinct seven  five
\<and> netsDistinct seven  six \<and> netsDistinct seven  eight \<and> netsDistinct seven
 nine \<and> netsDistinct seven  ten \<and> netsDistinct seven  eleven
\<and> netsDistinct seven  twelve \<and> netsDistinct seven  thirteen \<and> netsDistinct seven
 fourteen \<and> netsDistinct seven  fifteen \<and> netsDistinct seven 
sixteen \<and> netsDistinct seven  seventeen \<and> netsDistinct seven  eighteen
\<and> netsDistinct seven  nineteen \<and> netsDistinct seven  twenty \<and> netsDistinct
seven  twentyone \<and> netsDistinct seven  twentytwo \<and> netsDistinct seven
 twentythree \<and> netsDistinct seven  twentyfour \<and> netsDistinct seven
 twentyfive \<and> netsDistinct seven  twentysix \<and> netsDistinct seven
 twentyseven \<and> netsDistinct seven  twentyeight \<and> netsDistinct seven
 twentynine \<and> netsDistinct seven  thirty \<and> netsDistinct seven 
thirtyone \<and> netsDistinct eight  one \<and> netsDistinct eight  two \<and> netsDistinct
eight  three \<and> netsDistinct eight  four \<and> netsDistinct eight 
five \<and> netsDistinct eight  six \<and> netsDistinct eight  seven \<and> netsDistinct
eight  nine \<and> netsDistinct eight  ten \<and> netsDistinct eight 
eleven \<and> netsDistinct eight  twelve \<and> netsDistinct eight  thirteen \<and> netsDistinct
eight  fourteen \<and> netsDistinct eight  fifteen \<and> netsDistinct eight 
sixteen \<and> netsDistinct eight  seventeen \<and> netsDistinct eight  eighteen
\<and> netsDistinct eight  nineteen \<and> netsDistinct eight  twenty \<and> netsDistinct
eight  twentyone \<and> netsDistinct eight  twentytwo \<and> netsDistinct eight
 twentythree \<and> netsDistinct eight  twentyfour \<and> netsDistinct eight
 twentyfive \<and> netsDistinct eight  twentysix \<and> netsDistinct eight
 twentyseven \<and> netsDistinct eight  twentyeight \<and> netsDistinct eight
 twentynine \<and> netsDistinct eight  thirty \<and> netsDistinct eight 
thirtyone \<and> netsDistinct nine  one \<and> netsDistinct nine  two \<and> netsDistinct
nine  three \<and> netsDistinct nine  four \<and> netsDistinct nine 
five \<and> netsDistinct nine  six \<and> netsDistinct nine  seven \<and> netsDistinct nine
 eight \<and> netsDistinct nine  ten \<and> netsDistinct nine  eleven
\<and> netsDistinct nine  twelve \<and> netsDistinct nine  thirteen \<and> netsDistinct nine
 fourteen \<and> netsDistinct nine  fifteen \<and> netsDistinct nine  sixteen
\<and> netsDistinct nine  seventeen \<and> netsDistinct nine  eighteen \<and> netsDistinct
nine  nineteen \<and> netsDistinct nine  twenty \<and> netsDistinct nine
 twentyone \<and> netsDistinct nine  twentytwo \<and> netsDistinct nine 
twentythree \<and> netsDistinct nine  twentyfour \<and> netsDistinct nine 
twentyfive \<and> netsDistinct nine  twentysix \<and> netsDistinct nine 
twentyseven \<and> netsDistinct nine  twentyeight \<and> netsDistinct nine 
twentynine \<and> netsDistinct nine  thirty \<and> netsDistinct nine  thirtyone
\<and> netsDistinct ten  one \<and> netsDistinct ten  two \<and> netsDistinct ten 
three \<and> netsDistinct ten  four \<and> netsDistinct ten  five \<and> netsDistinct ten
 six \<and> netsDistinct ten  seven \<and> netsDistinct ten  eight
\<and> netsDistinct ten  nine \<and> netsDistinct ten  eleven \<and> netsDistinct ten
 twelve \<and> netsDistinct ten  thirteen \<and> netsDistinct ten  fourteen
\<and> netsDistinct ten  fifteen \<and> netsDistinct ten  sixteen \<and> netsDistinct ten 
seventeen \<and> netsDistinct ten  eighteen \<and> netsDistinct ten  nineteen
\<and> netsDistinct ten  twenty \<and> netsDistinct ten  twentyone \<and> netsDistinct ten
 twentytwo \<and> netsDistinct ten  twentythree \<and> netsDistinct ten 
twentyfour \<and> netsDistinct ten  twentyfive \<and> netsDistinct ten 
twentysix \<and> netsDistinct ten  twentyseven \<and> netsDistinct ten 
twentyeight \<and> netsDistinct ten  twentynine \<and> netsDistinct ten  thirty
\<and> netsDistinct ten  thirtyone \<and> netsDistinct eleven  one \<and> netsDistinct eleven
 two \<and> netsDistinct eleven  three \<and> netsDistinct eleven  four
\<and> netsDistinct eleven  five \<and> netsDistinct eleven  six \<and> netsDistinct eleven
 seven \<and> netsDistinct eleven  eight \<and> netsDistinct eleven 
nine \<and> netsDistinct eleven  ten \<and> netsDistinct eleven  twelve \<and> netsDistinct
eleven  thirteen \<and> netsDistinct eleven  fourteen \<and> netsDistinct eleven
 fifteen \<and> netsDistinct eleven  sixteen \<and> netsDistinct eleven 
seventeen \<and> netsDistinct eleven  eighteen \<and> netsDistinct eleven 
nineteen \<and> netsDistinct eleven  twenty \<and> netsDistinct eleven 
twentyone \<and> netsDistinct eleven  twentytwo \<and> netsDistinct eleven 
twentythree \<and> netsDistinct eleven  twentyfour \<and> netsDistinct eleven 
twentyfive \<and> netsDistinct eleven  twentysix \<and> netsDistinct eleven 
twentyseven \<and> netsDistinct eleven  twentyeight \<and> netsDistinct eleven 
twentynine \<and> netsDistinct eleven  thirty \<and> netsDistinct eleven 
thirtyone \<and> netsDistinct twelve  one \<and> netsDistinct twelve  two \<and> netsDistinct
twelve  three \<and> netsDistinct twelve  four \<and> netsDistinct twelve
 five \<and> netsDistinct twelve  six \<and> netsDistinct twelve  seven
\<and> netsDistinct twelve  eight \<and> netsDistinct twelve  nine \<and> netsDistinct twelve
 ten \<and> netsDistinct twelve  eleven \<and> netsDistinct twelve  thirteen
\<and> netsDistinct twelve  fourteen \<and> netsDistinct twelve  fifteen \<and> netsDistinct
twelve  sixteen \<and> netsDistinct twelve  seventeen \<and> netsDistinct twelve
 eighteen \<and> netsDistinct twelve  nineteen \<and> netsDistinct twelve
 twenty \<and> netsDistinct twelve  twentyone \<and> netsDistinct twelve
 twentytwo \<and> netsDistinct twelve  twentythree \<and> netsDistinct twelve
 twentyfour \<and> netsDistinct twelve  twentyfive \<and> netsDistinct twelve
 twentysix \<and> netsDistinct twelve  twentyseven \<and> netsDistinct twelve
 twentyeight \<and> netsDistinct twelve  twentynine \<and> netsDistinct twelve
 thirty \<and> netsDistinct twelve  thirtyone \<and> netsDistinct thirteen 
one \<and> netsDistinct thirteen  two \<and> netsDistinct thirteen  three \<and> netsDistinct thirteen 
four \<and> netsDistinct thirteen  five \<and> netsDistinct thirteen  six \<and> netsDistinct thirteen 
seven \<and> netsDistinct thirteen  eight \<and> netsDistinct thirteen  nine \<and> netsDistinct thirteen
 ten \<and> netsDistinct thirteen  eleven \<and> netsDistinct thirteen  twelve
\<and> netsDistinct thirteen  fourteen \<and> netsDistinct thirteen  fifteen \<and> netsDistinct thirteen 
sixteen \<and> netsDistinct thirteen  seventeen \<and> netsDistinct thirteen  eighteen
\<and> netsDistinct thirteen  nineteen \<and> netsDistinct thirteen  twenty \<and> netsDistinct thirteen
 twentyone \<and> netsDistinct thirteen  twentytwo \<and> netsDistinct thirteen 
twentythree \<and> netsDistinct thirteen  twentyfour \<and> netsDistinct thirteen 
twentyfive \<and> netsDistinct thirteen  twentysix \<and> netsDistinct thirteen  twentyseven
\<and> netsDistinct thirteen  twentyeight \<and> netsDistinct thirteen  twentynine \<and> netsDistinct thirteen
 thirty \<and> netsDistinct thirteen  thirtyone \<and> netsDistinct fourteen 
one \<and> netsDistinct fourteen  two \<and> netsDistinct fourteen  three \<and> netsDistinct
fourteen  four \<and> netsDistinct fourteen  five \<and> netsDistinct fourteen
 six \<and> netsDistinct fourteen  seven \<and> netsDistinct fourteen 
eight \<and> netsDistinct fourteen  nine \<and> netsDistinct fourteen  ten
\<and> netsDistinct fourteen  eleven \<and> netsDistinct fourteen  twelve \<and> netsDistinct
fourteen  thirteen \<and> netsDistinct fourteen  fifteen \<and> netsDistinct fourteen
 sixteen \<and> netsDistinct fourteen  seventeen \<and> netsDistinct fourteen
 eighteen \<and> netsDistinct fourteen  nineteen \<and> netsDistinct fourteen
 twenty \<and> netsDistinct fourteen  twentyone \<and> netsDistinct fourteen
 twentytwo \<and> netsDistinct fourteen  twentythree \<and> netsDistinct
fourteen  twentyfour \<and> netsDistinct fourteen  twentyfive
\<and> netsDistinct fourteen  twentysix \<and> netsDistinct fourteen 
twentyseven \<and> netsDistinct fourteen  twentyeight \<and> netsDistinct fourteen
 twentynine \<and> netsDistinct fourteen  thirty \<and> netsDistinct fourteen
 thirtyone \<and> netsDistinct fifteen  one \<and> netsDistinct fifteen  two
\<and> netsDistinct fifteen  three \<and> netsDistinct fifteen  four \<and> netsDistinct fifteen 
five \<and> netsDistinct fifteen  six \<and> netsDistinct fifteen  seven \<and> netsDistinct fifteen
 eight \<and> netsDistinct fifteen  nine \<and> netsDistinct fifteen  ten \<and> netsDistinct
fifteen  eleven \<and> netsDistinct fifteen  twelve \<and> netsDistinct fifteen  thirteen
\<and> netsDistinct fifteen  fourteen \<and> netsDistinct fifteen  sixteen \<and> netsDistinct fifteen
 seventeen \<and> netsDistinct fifteen  eighteen \<and> netsDistinct fifteen 
nineteen \<and> netsDistinct fifteen  twenty \<and> netsDistinct fifteen  twentyone \<and> netsDistinct
fifteen  twentytwo \<and> netsDistinct fifteen  twentythree \<and> netsDistinct fifteen
 twentyfour \<and> netsDistinct fifteen  twentyfive \<and> netsDistinct fifteen 
twentysix \<and> netsDistinct fifteen  twentyseven \<and> netsDistinct fifteen 
twentyeight \<and> netsDistinct fifteen  twentynine \<and> netsDistinct fifteen  thirty
\<and> netsDistinct fifteen  thirtyone \<and> netsDistinct sixteen  one \<and> netsDistinct
sixteen  two \<and> netsDistinct sixteen  three \<and> netsDistinct sixteen
 four \<and> netsDistinct sixteen  five \<and> netsDistinct sixteen  six
\<and> netsDistinct sixteen  seven \<and> netsDistinct sixteen  eight \<and> netsDistinct
sixteen  nine \<and> netsDistinct sixteen  ten \<and> netsDistinct sixteen
 eleven \<and> netsDistinct sixteen  twelve \<and> netsDistinct sixteen 
thirteen \<and> netsDistinct sixteen  fourteen \<and> netsDistinct sixteen  fifteen \<and> netsDistinct
sixteen  seventeen \<and> netsDistinct sixteen  eighteen \<and> netsDistinct
sixteen  nineteen \<and> netsDistinct sixteen  twenty \<and> netsDistinct
sixteen  twentyone \<and> netsDistinct sixteen  twentytwo \<and> netsDistinct
sixteen  twentythree \<and> netsDistinct sixteen  twentyfour \<and> netsDistinct
sixteen  twentyfive \<and> netsDistinct sixteen  twentysix \<and> netsDistinct
sixteen  twentyseven \<and> netsDistinct sixteen  twentyeight
\<and> netsDistinct sixteen  twentynine \<and> netsDistinct sixteen  thirty
\<and> netsDistinct sixteen  thirtyone \<and> netsDistinct seventeen  one \<and> netsDistinct
seventeen  two \<and> netsDistinct seventeen  three \<and> netsDistinct
seventeen  four \<and> netsDistinct seventeen  five \<and> netsDistinct
seventeen  six \<and> netsDistinct seventeen  seven \<and> netsDistinct
seventeen  eight \<and> netsDistinct seventeen  nine \<and> netsDistinct
seventeen  ten \<and> netsDistinct seventeen  eleven \<and> netsDistinct
seventeen  twelve \<and> netsDistinct seventeen  thirteen \<and> netsDistinct
seventeen  fourteen \<and> netsDistinct seventeen  fifteen \<and> netsDistinct
seventeen  sixteen \<and> netsDistinct seventeen  eighteen \<and> netsDistinct
seventeen  nineteen \<and> netsDistinct seventeen  twenty \<and> netsDistinct
seventeen  twentyone \<and> netsDistinct seventeen  twentytwo
\<and> netsDistinct seventeen  twentythree \<and> netsDistinct seventeen 
twentyfour \<and> netsDistinct seventeen  twentyfive \<and> netsDistinct seventeen
 twentysix \<and> netsDistinct seventeen  twentyseven \<and> netsDistinct
seventeen  twentyeight \<and> netsDistinct seventeen  twentynine
\<and> netsDistinct seventeen  thirty \<and> netsDistinct seventeen  thirtyone
\<and> netsDistinct eighteen  one \<and> netsDistinct eighteen  two \<and> netsDistinct
eighteen  three \<and> netsDistinct eighteen  four \<and> netsDistinct eighteen
 five \<and> netsDistinct eighteen  six \<and> netsDistinct eighteen 
seven \<and> netsDistinct eighteen  eight \<and> netsDistinct eighteen  nine
\<and> netsDistinct eighteen  ten \<and> netsDistinct eighteen  eleven \<and> netsDistinct
eighteen  twelve \<and> netsDistinct eighteen  thirteen \<and> netsDistinct eighteen
 fourteen \<and> netsDistinct eighteen  fifteen \<and> netsDistinct eighteen 
sixteen \<and> netsDistinct eighteen  seventeen \<and> netsDistinct eighteen 
nineteen \<and> netsDistinct eighteen  twenty \<and> netsDistinct eighteen 
twentyone \<and> netsDistinct eighteen  twentytwo \<and> netsDistinct eighteen 
twentythree \<and> netsDistinct eighteen  twentyfour \<and> netsDistinct eighteen
 twentyfive \<and> netsDistinct eighteen  twentysix \<and> netsDistinct eighteen
 twentyseven \<and> netsDistinct eighteen  twentyeight \<and> netsDistinct
eighteen  twentynine \<and> netsDistinct eighteen  thirty \<and> netsDistinct
eighteen  thirtyone \<and> netsDistinct nineteen  one \<and> netsDistinct
nineteen  two \<and> netsDistinct nineteen  three \<and> netsDistinct nineteen
 four \<and> netsDistinct nineteen  five \<and> netsDistinct nineteen 
six \<and> netsDistinct nineteen  seven \<and> netsDistinct nineteen  eight
\<and> netsDistinct nineteen  nine \<and> netsDistinct nineteen  ten \<and> netsDistinct
nineteen  eleven \<and> netsDistinct nineteen  twelve \<and> netsDistinct
nineteen  thirteen \<and> netsDistinct nineteen  fourteen \<and> netsDistinct nineteen
 fifteen \<and> netsDistinct nineteen  sixteen \<and> netsDistinct nineteen 
seventeen \<and> netsDistinct nineteen  eighteen \<and> netsDistinct nineteen 
twenty \<and> netsDistinct nineteen  twentyone \<and> netsDistinct nineteen 
twentytwo \<and> netsDistinct nineteen  twentythree \<and> netsDistinct nineteen
 twentyfour \<and> netsDistinct nineteen  twentyfive \<and> netsDistinct
nineteen  twentysix \<and> netsDistinct nineteen  twentyseven
\<and> netsDistinct nineteen  twentyeight \<and> netsDistinct nineteen 
twentynine \<and> netsDistinct nineteen  thirty \<and> netsDistinct nineteen 
thirtyone \<and> netsDistinct twenty  one \<and> netsDistinct twenty  two \<and> netsDistinct
twenty  three \<and> netsDistinct twenty  four \<and> netsDistinct twenty
 five \<and> netsDistinct twenty  six \<and> netsDistinct twenty  seven
\<and> netsDistinct twenty  eight \<and> netsDistinct twenty  nine \<and> netsDistinct twenty
 ten \<and> netsDistinct twenty  eleven \<and> netsDistinct twenty 
twelve \<and> netsDistinct twenty  thirteen \<and> netsDistinct twenty  fourteen
\<and> netsDistinct twenty  fifteen \<and> netsDistinct twenty  sixteen \<and> netsDistinct twenty
 seventeen \<and> netsDistinct twenty  eighteen \<and> netsDistinct twenty
 nineteen \<and> netsDistinct twenty  twentyone \<and> netsDistinct twenty
 twentytwo \<and> netsDistinct twenty  twentythree \<and> netsDistinct twenty
 twentyfour \<and> netsDistinct twenty  twentyfive \<and> netsDistinct twenty
 twentysix \<and> netsDistinct twenty  twentyseven \<and> netsDistinct twenty
 twentyeight \<and> netsDistinct twenty  twentynine \<and> netsDistinct twenty
 thirty \<and> netsDistinct twenty  thirtyone \<and> netsDistinct twentyone
 one \<and> netsDistinct twentyone  two \<and> netsDistinct twentyone 
three \<and> netsDistinct twentyone  four \<and> netsDistinct twentyone  five
\<and> netsDistinct twentyone  six \<and> netsDistinct twentyone  seven \<and> netsDistinct
twentyone  eight \<and> netsDistinct twentyone  nine \<and> netsDistinct
twentyone  ten \<and> netsDistinct twentyone  eleven \<and> netsDistinct
twentyone  twelve \<and> netsDistinct twentyone  thirteen \<and> netsDistinct
twentyone  fourteen \<and> netsDistinct twentyone  fifteen \<and> netsDistinct
twentyone  sixteen \<and> netsDistinct twentyone  seventeen \<and> netsDistinct
twentyone  eighteen \<and> netsDistinct twentyone  nineteen \<and> netsDistinct
twentyone  twenty \<and> netsDistinct twentyone  twentytwo \<and> netsDistinct
twentyone  twentythree \<and> netsDistinct twentyone  twentyfour
\<and> netsDistinct twentyone  twentyfive \<and> netsDistinct twentyone 
twentysix \<and> netsDistinct twentyone  twentyseven \<and> netsDistinct twentyone
 twentyeight \<and> netsDistinct twentyone  twentynine \<and> netsDistinct
twentyone  thirty \<and> netsDistinct twentyone  thirtyone \<and> netsDistinct
twentytwo  one \<and> netsDistinct twentytwo  two \<and> netsDistinct twentytwo
 three \<and> netsDistinct twentytwo  four \<and> netsDistinct twentytwo
 five \<and> netsDistinct twentytwo  six \<and> netsDistinct twentytwo 
seven \<and> netsDistinct twentytwo  eight \<and> netsDistinct twentytwo  nine
\<and> netsDistinct twentytwo  ten \<and> netsDistinct twentytwo  eleven \<and> netsDistinct
twentytwo  twelve \<and> netsDistinct twentytwo  thirteen \<and> netsDistinct
twentytwo  fourteen \<and> netsDistinct twentytwo  fifteen \<and> netsDistinct
twentytwo  sixteen \<and> netsDistinct twentytwo  seventeen \<and> netsDistinct
twentytwo  eighteen \<and> netsDistinct twentytwo  nineteen \<and> netsDistinct
twentytwo  twenty \<and> netsDistinct twentytwo  twentyone \<and> netsDistinct
twentytwo  twentythree \<and> netsDistinct twentytwo  twentyfour
\<and> netsDistinct twentytwo  twentyfive \<and> netsDistinct twentytwo 
twentysix \<and> netsDistinct twentytwo  twentyseven \<and> netsDistinct twentytwo
 twentyeight \<and> netsDistinct twentytwo  twentynine \<and> netsDistinct
twentytwo  thirty \<and> netsDistinct twentytwo  thirtyone \<and> netsDistinct
twentythree  one \<and> netsDistinct twentythree  two \<and> netsDistinct
twentythree  three \<and> netsDistinct twentythree  four \<and> netsDistinct
twentythree  five \<and> netsDistinct twentythree  six \<and> netsDistinct
twentythree  seven \<and> netsDistinct twentythree  eight \<and> netsDistinct
twentythree  nine \<and> netsDistinct twentythree  ten \<and> netsDistinct
twentythree  eleven \<and> netsDistinct twentythree  twelve \<and> netsDistinct
twentythree  thirteen \<and> netsDistinct twentythree  fourteen \<and> netsDistinct
twentythree  fifteen \<and> netsDistinct twentythree  sixteen \<and> netsDistinct
twentythree  seventeen \<and> netsDistinct twentythree  eighteen
\<and> netsDistinct twentythree  nineteen \<and> netsDistinct twentythree 
twenty \<and> netsDistinct twentythree  twentyone \<and> netsDistinct twentythree
 twentytwo \<and> netsDistinct twentythree  twentyfour \<and> netsDistinct
twentythree  twentyfive \<and> netsDistinct twentythree  twentysix
\<and> netsDistinct twentythree  twentyseven \<and> netsDistinct twentythree 
twentyeight \<and> netsDistinct twentythree  twentynine \<and> netsDistinct twentythree
 thirty \<and> netsDistinct twentythree  thirtyone \<and> netsDistinct
twentyfour  one \<and> netsDistinct twentyfour  two \<and> netsDistinct
twentyfour  three \<and> netsDistinct twentyfour  four \<and> netsDistinct
twentyfour  five \<and> netsDistinct twentyfour  six \<and> netsDistinct
twentyfour  seven \<and> netsDistinct twentyfour  eight \<and> netsDistinct
twentyfour  nine \<and> netsDistinct twentyfour  ten \<and> netsDistinct
twentyfour  eleven \<and> netsDistinct twentyfour  twelve \<and> netsDistinct
twentyfour  thirteen \<and> netsDistinct twentyfour  fourteen \<and> netsDistinct
twentyfour  fifteen \<and> netsDistinct twentyfour  sixteen \<and> netsDistinct
twentyfour  seventeen \<and> netsDistinct twentyfour  eighteen
\<and> netsDistinct twentyfour  nineteen \<and> netsDistinct twentyfour  twenty
\<and> netsDistinct twentyfour  twentyone \<and> netsDistinct twentyfour 
twentytwo \<and> netsDistinct twentyfour  twentythree \<and> netsDistinct twentyfour
 twentyfive \<and> netsDistinct twentyfour  twentysix \<and> netsDistinct
twentyfour  twentyseven \<and> netsDistinct twentyfour  twentyeight
\<and> netsDistinct twentyfour  twentynine \<and> netsDistinct twentyfour 
thirty \<and> netsDistinct twentyfour  thirtyone \<and> netsDistinct twentyfive 
one \<and> netsDistinct twentyfive  two \<and> netsDistinct twentyfive  three
\<and> netsDistinct twentyfive  four \<and> netsDistinct twentyfive  five \<and> netsDistinct
twentyfive  six \<and> netsDistinct twentyfive  seven \<and> netsDistinct
twentyfive  eight \<and> netsDistinct twentyfive  nine \<and> netsDistinct
twentyfive  ten \<and> netsDistinct twentyfive  eleven \<and> netsDistinct
twentyfive  twelve \<and> netsDistinct twentyfive  thirteen \<and> netsDistinct
twentyfive  fourteen \<and> netsDistinct twentyfive  fifteen \<and> netsDistinct
twentyfive  sixteen \<and> netsDistinct twentyfive  seventeen
\<and> netsDistinct twentyfive  eighteen \<and> netsDistinct twentyfive 
nineteen \<and> netsDistinct twentyfive  twenty \<and> netsDistinct twentyfive 
twentyone \<and> netsDistinct twentyfive  twentytwo \<and> netsDistinct twentyfive
 twentythree \<and> netsDistinct twentyfive  twentyfour \<and> netsDistinct
twentyfive  twentysix \<and> netsDistinct twentyfive  twentyseven
\<and> netsDistinct twentyfive  twentyeight \<and> netsDistinct twentyfive 
twentynine \<and> netsDistinct twentyfive  thirty \<and> netsDistinct twentyfive
 thirtyone \<and> netsDistinct twentysix  one \<and> netsDistinct twentysix
 two \<and> netsDistinct twentysix  three \<and> netsDistinct twentysix 
four \<and> netsDistinct twentysix  five \<and> netsDistinct twentysix  six
\<and> netsDistinct twentysix  seven \<and> netsDistinct twentysix  eight \<and> netsDistinct
twentysix  nine \<and> netsDistinct twentysix  ten \<and> netsDistinct twentysix
 eleven \<and> netsDistinct twentysix  twelve \<and> netsDistinct twentysix
 thirteen \<and> netsDistinct twentysix  fourteen \<and> netsDistinct twentysix
 fifteen \<and> netsDistinct twentysix  sixteen \<and> netsDistinct twentysix
 seventeen \<and> netsDistinct twentysix  eighteen \<and> netsDistinct twentysix
 nineteen \<and> netsDistinct twentysix  twenty \<and> netsDistinct twentysix
 twentyone \<and> netsDistinct twentysix  twentytwo \<and> netsDistinct
twentysix  twentythree \<and> netsDistinct twentysix  twentyfour
\<and> netsDistinct twentysix  twentyfive \<and> netsDistinct twentysix 
twentyseven \<and> netsDistinct twentysix  twentyeight \<and> netsDistinct twentysix
 twentynine \<and> netsDistinct twentysix  thirty \<and> netsDistinct twentysix
 thirtyone \<and> netsDistinct twentyseven  one \<and> netsDistinct twentyseven
 two \<and> netsDistinct twentyseven  three \<and> netsDistinct twentyseven
 four \<and> netsDistinct twentyseven  five \<and> netsDistinct twentyseven
 six \<and> netsDistinct twentyseven  seven \<and> netsDistinct twentyseven
 eight \<and> netsDistinct twentyseven  nine \<and> netsDistinct twentyseven
 ten \<and> netsDistinct twentyseven  eleven \<and> netsDistinct twentyseven
 twelve \<and> netsDistinct twentyseven  thirteen \<and> netsDistinct twentyseven
 fourteen \<and> netsDistinct twentyseven  fifteen \<and> netsDistinct twentyseven
 sixteen \<and> netsDistinct twentyseven  seventeen \<and> netsDistinct
twentyseven  eighteen \<and> netsDistinct twentyseven  nineteen
\<and> netsDistinct twentyseven  twenty \<and> netsDistinct twentyseven 
twentyone \<and> netsDistinct twentyseven  twentytwo \<and> netsDistinct twentyseven
 twentythree \<and> netsDistinct twentyseven  twentyfour \<and> netsDistinct
twentyseven  twentyfive \<and> netsDistinct twentyseven  twentysix
\<and> netsDistinct twentyseven  twentyeight \<and> netsDistinct twentyseven 
twentynine \<and> netsDistinct twentyseven  thirty \<and> netsDistinct twentyseven
 thirtyone \<and> netsDistinct twentyeight  one \<and> netsDistinct twentyeight
 two \<and> netsDistinct twentyeight  three \<and> netsDistinct twentyeight
 four \<and> netsDistinct twentyeight  five \<and> netsDistinct twentyeight
 six \<and> netsDistinct twentyeight  seven \<and> netsDistinct twentyeight
 eight \<and> netsDistinct twentyeight  nine \<and> netsDistinct twentyeight
 ten \<and> netsDistinct twentyeight  eleven \<and> netsDistinct twentyeight
 twelve \<and> netsDistinct twentyeight  thirteen \<and> netsDistinct twentyeight
 fourteen \<and> netsDistinct twentyeight  fifteen \<and> netsDistinct twentyeight
 sixteen \<and> netsDistinct twentyeight  seventeen \<and> netsDistinct
twentyeight  eighteen \<and> netsDistinct twentyeight  nineteen
\<and> netsDistinct twentyeight  twenty \<and> netsDistinct twentyeight 
twentyone \<and> netsDistinct twentyeight  twentytwo \<and> netsDistinct twentyeight
 twentythree \<and> netsDistinct twentyeight  twentyfour \<and> netsDistinct
twentyeight  twentyfive \<and> netsDistinct twentyeight  twentysix
\<and> netsDistinct twentyeight  twentyseven \<and> netsDistinct twentyeight 
twentynine \<and> netsDistinct twentyeight  thirty \<and> netsDistinct twentyeight
 thirtyone \<and> netsDistinct twentynine  one \<and> netsDistinct twentynine
 two \<and> netsDistinct twentynine  three \<and> netsDistinct twentynine
 four \<and> netsDistinct twentynine  five \<and> netsDistinct twentynine
 six \<and> netsDistinct twentynine  seven \<and> netsDistinct twentynine
 eight \<and> netsDistinct twentynine  nine \<and> netsDistinct twentynine
 ten \<and> netsDistinct twentynine  eleven \<and> netsDistinct twentynine
 twelve \<and> netsDistinct twentynine  thirteen \<and> netsDistinct twentynine
 fourteen \<and> netsDistinct twentynine  fifteen \<and> netsDistinct twentynine
 sixteen \<and> netsDistinct twentynine  seventeen \<and> netsDistinct
twentynine  eighteen \<and> netsDistinct twentynine  nineteen
\<and> netsDistinct twentynine  twenty \<and> netsDistinct twentynine  twentyone
\<and> netsDistinct twentynine  twentytwo \<and> netsDistinct twentynine 
twentythree \<and> netsDistinct twentynine  twentyfour \<and> netsDistinct twentynine
 twentyfive \<and> netsDistinct twentynine  twentysix \<and> netsDistinct
twentynine  twentyseven \<and> netsDistinct twentynine  twentyeight
\<and> netsDistinct twentynine  thirty \<and> netsDistinct twentynine  thirtyone
\<and> netsDistinct thirty  one \<and> netsDistinct thirty  two \<and> netsDistinct thirty
 three \<and> netsDistinct thirty  four \<and> netsDistinct thirty  five
\<and> netsDistinct thirty  six \<and> netsDistinct thirty  seven \<and> netsDistinct thirty
 eight \<and> netsDistinct thirty  nine \<and> netsDistinct thirty  ten
\<and> netsDistinct thirty  eleven \<and> netsDistinct thirty  twelve \<and> netsDistinct
thirty  thirteen \<and> netsDistinct thirty  fourteen \<and> netsDistinct thirty
 fifteen \<and> netsDistinct thirty  sixteen \<and> netsDistinct thirty 
seventeen \<and> netsDistinct thirty  eighteen \<and> netsDistinct thirty 
nineteen \<and> netsDistinct thirty  twenty \<and> netsDistinct thirty 
twentyone \<and> netsDistinct thirty  twentytwo \<and> netsDistinct thirty 
twentythree \<and> netsDistinct thirty  twentyfour \<and> netsDistinct thirty 
twentyfive \<and> netsDistinct thirty  twentysix \<and> netsDistinct thirty 
twentyseven \<and> netsDistinct thirty  twentyeight \<and> netsDistinct thirty 
twentynine \<and> netsDistinct thirty  thirtyone \<and> netsDistinct thirtyone 
one \<and> netsDistinct thirtyone  two \<and> netsDistinct thirtyone  three
\<and> netsDistinct thirtyone  four \<and> netsDistinct thirtyone  five \<and> netsDistinct
thirtyone  six \<and> netsDistinct thirtyone  seven \<and> netsDistinct
thirtyone  eight \<and> netsDistinct thirtyone  nine \<and> netsDistinct
thirtyone  ten \<and> netsDistinct thirtyone  eleven \<and> netsDistinct
thirtyone  twelve \<and> netsDistinct thirtyone  thirteen \<and> netsDistinct
thirtyone  fourteen \<and> netsDistinct thirtyone  fifteen \<and> netsDistinct
thirtyone  sixteen \<and> netsDistinct thirtyone  seventeen \<and> netsDistinct
thirtyone  eighteen \<and> netsDistinct thirtyone  nineteen \<and> netsDistinct
thirtyone  twenty \<and> netsDistinct thirtyone  twentyone \<and> netsDistinct
thirtyone  twentytwo \<and> netsDistinct thirtyone  twentythree
\<and> netsDistinct thirtyone  twentyfour \<and> netsDistinct thirtyone 
twentyfive \<and> netsDistinct thirtyone  twentysix \<and> netsDistinct thirtyone
 twentyseven \<and> netsDistinct thirtyone  twentyeight \<and> netsDistinct
thirtyone  twentynine \<and> netsDistinct thirtyone  thirty"
apply (simp add: nets_distinct_aux UnfoldPolicy)
done
 

lemma aux: "\<lbrakk>x \<noteq> a; y\<noteq>b; (x \<noteq> y \<and> x \<noteq> b) \<or>  (a \<noteq> b \<and> a \<noteq> y)\<rbrakk> \<Longrightarrow> {x,a} \<noteq> {y,b}"
  apply auto
done


lemma aux2: "{a,b} = {b,a}"
  apply auto
done

 
consts fixID :: id
consts fixContent :: DummyContent

definition "fixElements p = (id p = fixID)"

lemmas fixDefs = fixElements_def NetworkCore.id_def NetworkCore.content_def



fun numberOfRules where 
 "numberOfRules (a\<oplus>b) = numberOfRules a + numberOfRules b"
 |"numberOfRules a = (1::int)" 


fun numberOfRulesList where 
 "numberOfRulesList  (x#xs) = ((numberOfRules x)#(numberOfRulesList xs)) "
 |"numberOfRulesList [] = []" 



end
