(*****************************************************************************
 * HOL-TestGen --- theorem-prover based test case generation
 *                 http://www.brucker.ch/projects/hol-testgen/
 *
 * FWTesting.thy ---
 * This file is part of HOL-TestGen.
 *
 * Copyright (c) 2005-2010 ETH Zurich, Switzerland
 *               2008-2010 Achim D. Brucker, Germany
 *               2009-2010 Université Paris-Sud, France
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials provided
 *       with the distribution.
 *
 *     * Neither the name of the copyright holders nor the names of its
 *       contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ***************.***************************************************************)
(* $Id$ *)

theory 
  "RandomPolicies"
imports
  "../PolicyDefinitions"
begin

 
(* 50 rules, 5 networks, 20% *)
definition Policy1 :: "(adr\<^isub>i\<^isub>p net, port) Combinators" where
"Policy1 =
DenyAll \<oplus>  AllowPortFromTo two three 751 \<oplus> AllowPortFromTo three four 314 \<oplus> AllowPortFromTo three four 682 \<oplus> AllowPortFromTo five two 951 \<oplus> AllowPortFromTo four five 193 \<oplus> AllowPortFromTo three two 57 \<oplus> AllowPortFromTo five four 318 \<oplus> DenyAllFromTo three four\<oplus> DenyAllFromTo one five\<oplus> AllowPortFromTo three five 263 \<oplus> AllowPortFromTo three one 761 \<oplus> DenyAllFromTo one two\<oplus> AllowPortFromTo three four 537 \<oplus> AllowPortFromTo three four 933 \<oplus> DenyAllFromTo four three\<oplus> AllowPortFromTo two five 387 \<oplus> AllowPortFromTo one five 447 \<oplus> DenyAllFromTo four two\<oplus> AllowPortFromTo three two 551 \<oplus> AllowPortFromTo two four 720 \<oplus> AllowPortFromTo five two 774 \<oplus> AllowPortFromTo one two 927 \<oplus> AllowPortFromTo three one 71 \<oplus> AllowPortFromTo three four 986 \<oplus> AllowPortFromTo four five 109 \<oplus> AllowPortFromTo three five 225 \<oplus> AllowPortFromTo two three 731 \<oplus> AllowPortFromTo five one 700 \<oplus> AllowPortFromTo four one 855 \<oplus> AllowPortFromTo three two 602 \<oplus> AllowPortFromTo five one 371 \<oplus> AllowPortFromTo three two 888 \<oplus> AllowPortFromTo one five 361 \<oplus> AllowPortFromTo two five 956 \<oplus> DenyAllFromTo four one\<oplus> AllowPortFromTo one four 649 \<oplus> AllowPortFromTo five three 523 \<oplus> AllowPortFromTo three four 60 \<oplus> AllowPortFromTo one two 179 \<oplus> AllowPortFromTo one four 641 \<oplus> AllowPortFromTo four five 799 \<oplus> DenyAllFromTo five two\<oplus> DenyAllFromTo five four\<oplus> AllowPortFromTo five three 470 \<oplus> DenyAllFromTo three two\<oplus> AllowPortFromTo four two 467 \<oplus> AllowPortFromTo five three 317 \<oplus> AllowPortFromTo five four 545 \<oplus> AllowPortFromTo one five 663 \<oplus> AllowPortFromTo four five 940

"
(* 50 rules, 10 networks, 20% *)

definition Policy2 :: "(adr\<^isub>i\<^isub>p net, port) Combinators" where
"Policy2 =
DenyAll \<oplus>  DenyAllFromTo nine eight\<oplus> AllowPortFromTo seven one 838 \<oplus> DenyAllFromTo one ten\<oplus> AllowPortFromTo five six 604 \<oplus> AllowPortFromTo four five 82 \<oplus> AllowPortFromTo six four 368 \<oplus> AllowPortFromTo ten eight 873 \<oplus> AllowPortFromTo five three 274 \<oplus> AllowPortFromTo two ten 748 \<oplus> AllowPortFromTo ten six 546 \<oplus> AllowPortFromTo nine seven 718 \<oplus> AllowPortFromTo ten two 126 \<oplus> DenyAllFromTo seven five\<oplus> AllowPortFromTo five three 490 \<oplus> DenyAllFromTo eight seven\<oplus> AllowPortFromTo two one 120 \<oplus> AllowPortFromTo one five 970 \<oplus> AllowPortFromTo four three 71 \<oplus> AllowPortFromTo eight five 892 \<oplus> AllowPortFromTo five two 247 \<oplus> AllowPortFromTo two seven 423 \<oplus> AllowPortFromTo ten two 432 \<oplus> AllowPortFromTo eight seven 491 \<oplus> AllowPortFromTo ten eight 140 \<oplus> AllowPortFromTo ten one 121 \<oplus> AllowPortFromTo four ten 645 \<oplus> AllowPortFromTo three five 913 \<oplus> AllowPortFromTo four one 567 \<oplus> AllowPortFromTo four three 901 \<oplus> AllowPortFromTo five four 621 \<oplus> AllowPortFromTo one nine 263 \<oplus> AllowPortFromTo one two 874 \<oplus> AllowPortFromTo six five 211 \<oplus> AllowPortFromTo three nine 2 \<oplus> AllowPortFromTo one eight 241 \<oplus> AllowPortFromTo six seven 862 \<oplus> AllowPortFromTo four three 159 \<oplus> AllowPortFromTo four nine 757 \<oplus> AllowPortFromTo two six 19 \<oplus> AllowPortFromTo three five 256 \<oplus> AllowPortFromTo ten one 929 \<oplus> DenyAllFromTo five four\<oplus> AllowPortFromTo nine eight 400 \<oplus> DenyAllFromTo three four\<oplus> DenyAllFromTo three seven\<oplus> AllowPortFromTo nine two 630 \<oplus> AllowPortFromTo eight four 700 \<oplus> AllowPortFromTo eight three 639 \<oplus> AllowPortFromTo ten six 625 \<oplus> AllowPortFromTo nine eight 316

"
(* 50 rules, 25  networks, 20% *)

definition Policy3 :: "(adr\<^isub>i\<^isub>p net, port) Combinators" where
"Policy3 =
DenyAll \<oplus>  AllowPortFromTo nineteen one 573 \<oplus> AllowPortFromTo nineteen twentyfour 187 \<oplus> AllowPortFromTo nineteen six 502 \<oplus> AllowPortFromTo ten six 1 \<oplus> AllowPortFromTo twenty nine 3 \<oplus> AllowPortFromTo twentyone nineteen 435 \<oplus> AllowPortFromTo twentyfour ten 643 \<oplus> AllowPortFromTo nineteen eight 634 \<oplus> AllowPortFromTo twentyfive seventeen 324 \<oplus> AllowPortFromTo eleven twelve 145 \<oplus> DenyAllFromTo eighteen twentytwo\<oplus> AllowPortFromTo sixteen ten 298 \<oplus> AllowPortFromTo eighteen twentytwo 204 \<oplus> AllowPortFromTo fifteen three 581 \<oplus> AllowPortFromTo twentythree eleven 580 \<oplus> DenyAllFromTo seventeen twelve\<oplus> AllowPortFromTo nine twentythree 175 \<oplus> AllowPortFromTo twentyone six 402 \<oplus> AllowPortFromTo nineteen eighteen 666 \<oplus> AllowPortFromTo seventeen thirteen 459 \<oplus> AllowPortFromTo three twentyone 404 \<oplus> DenyAllFromTo twentyfour eight\<oplus> DenyAllFromTo thirteen twentyfour\<oplus> AllowPortFromTo eleven one 724 \<oplus> AllowPortFromTo five thirteen 92 \<oplus> AllowPortFromTo thirteen twentytwo 253 \<oplus> AllowPortFromTo twelve eight 278 \<oplus> AllowPortFromTo twentyone twentyfive 95 \<oplus> AllowPortFromTo twenty three 240 \<oplus> AllowPortFromTo six twentyfive 429 \<oplus> AllowPortFromTo one twenty 280 \<oplus> AllowPortFromTo sixteen six 779 \<oplus> AllowPortFromTo three one 600 \<oplus> AllowPortFromTo twentytwo five 639 \<oplus> DenyAllFromTo eight six\<oplus> AllowPortFromTo twelve fourteen 860 \<oplus> AllowPortFromTo thirteen three 1 \<oplus> DenyAllFromTo twentyfour twentyfive\<oplus> DenyAllFromTo seven twentythree\<oplus> DenyAllFromTo twentyfour six\<oplus> AllowPortFromTo twelve eight 53 \<oplus> AllowPortFromTo twelve five 245 \<oplus> AllowPortFromTo seven ten 233 \<oplus> AllowPortFromTo seventeen twentytwo 350 \<oplus> AllowPortFromTo twelve four 712 \<oplus> AllowPortFromTo twentyone six 624 \<oplus> DenyAllFromTo two one\<oplus> AllowPortFromTo ten thirteen 253 \<oplus> AllowPortFromTo six two 391 \<oplus> AllowPortFromTo seventeen five 527 

"

(* 100  rules,5  networks, 20% *)
definition Policy4 :: "(adr\<^isub>i\<^isub>p net, port) Combinators" where
"Policy4 =

DenyAll \<oplus>  AllowPortFromTo four five 50 \<oplus> AllowPortFromTo one five 385 \<oplus> DenyAllFromTo three four\<oplus> AllowPortFromTo two three 188 \<oplus> AllowPortFromTo one three 571 \<oplus> AllowPortFromTo two one 548 \<oplus> DenyAllFromTo two three\<oplus> AllowPortFromTo one four 1 \<oplus> AllowPortFromTo two one 164 \<oplus> DenyAllFromTo two five\<oplus> DenyAllFromTo one two\<oplus> AllowPortFromTo three two 588 \<oplus> AllowPortFromTo one five 190 \<oplus> AllowPortFromTo five three 397 \<oplus> AllowPortFromTo two four 161 \<oplus> AllowPortFromTo five one 155 \<oplus> AllowPortFromTo four three 390 \<oplus> AllowPortFromTo one two 376 \<oplus> AllowPortFromTo three two 448 \<oplus> AllowPortFromTo three four 411 \<oplus> DenyAllFromTo four one\<oplus> AllowPortFromTo one two 502 \<oplus> AllowPortFromTo five two 377 \<oplus> AllowPortFromTo one four 622 \<oplus> AllowPortFromTo four two 50 \<oplus> AllowPortFromTo five four 11 \<oplus> DenyAllFromTo three two\<oplus> AllowPortFromTo four one 999 \<oplus> AllowPortFromTo five four 235 \<oplus> AllowPortFromTo five one 501 \<oplus> AllowPortFromTo five one 628 \<oplus> AllowPortFromTo four two 666 \<oplus> AllowPortFromTo one three 589 \<oplus> DenyAllFromTo three five\<oplus> AllowPortFromTo one four 395 \<oplus> DenyAllFromTo three four\<oplus> AllowPortFromTo three two 787 \<oplus> AllowPortFromTo five three 803 \<oplus> AllowPortFromTo three two 531 \<oplus> AllowPortFromTo one four 895 \<oplus> AllowPortFromTo five one 764 \<oplus> AllowPortFromTo four one 680 \<oplus> DenyAllFromTo three two\<oplus> AllowPortFromTo one four 492 \<oplus> AllowPortFromTo one four 109 \<oplus> AllowPortFromTo two one 521 \<oplus> AllowPortFromTo one five 781 \<oplus> AllowPortFromTo three five 777 \<oplus> DenyAllFromTo four three\<oplus> AllowPortFromTo five three 472 \<oplus> DenyAllFromTo one four\<oplus> AllowPortFromTo five four 804 \<oplus> AllowPortFromTo five three 907 \<oplus> AllowPortFromTo two one 146 \<oplus> AllowPortFromTo one five 969 \<oplus> AllowPortFromTo three five 390 \<oplus> AllowPortFromTo five four 840 \<oplus> AllowPortFromTo two one 750 \<oplus> AllowPortFromTo two five 361 \<oplus> AllowPortFromTo five four 723 \<oplus> DenyAllFromTo two three\<oplus> AllowPortFromTo one two 546 \<oplus> AllowPortFromTo five three 684 \<oplus> AllowPortFromTo one five 326 \<oplus> DenyAllFromTo one two\<oplus> AllowPortFromTo four three 86 \<oplus> DenyAllFromTo four two\<oplus> DenyAllFromTo two five\<oplus> AllowPortFromTo two one 793 \<oplus> DenyAllFromTo four two\<oplus> AllowPortFromTo one three 906 \<oplus> AllowPortFromTo two one 116 \<oplus> DenyAllFromTo two one\<oplus> DenyAllFromTo one three\<oplus> AllowPortFromTo two four 918 \<oplus> AllowPortFromTo one three 65 \<oplus> AllowPortFromTo four five 799 \<oplus> DenyAllFromTo two five\<oplus> AllowPortFromTo four three 229 \<oplus> AllowPortFromTo five one 813 \<oplus> AllowPortFromTo three one 293 \<oplus> AllowPortFromTo two one 108 \<oplus> AllowPortFromTo one four 366 \<oplus> AllowPortFromTo one five 44 \<oplus> AllowPortFromTo five four 479 \<oplus> AllowPortFromTo five one 93 \<oplus> AllowPortFromTo two four 25 \<oplus> AllowPortFromTo three five 164 \<oplus> DenyAllFromTo four two\<oplus> DenyAllFromTo three two\<oplus> DenyAllFromTo one three\<oplus> AllowPortFromTo three two 3 \<oplus> AllowPortFromTo one five 951 \<oplus> AllowPortFromTo three two 700 \<oplus> AllowPortFromTo four five 684 \<oplus> AllowPortFromTo five two 65 \<oplus> AllowPortFromTo one four 280 \<oplus> AllowPortFromTo four one 282 \<oplus> AllowPortFromTo five three 169 \<oplus> AllowPortFromTo two three 299
"

(*100  rules, 10 networks, 20% *)
definition Policy5 :: "(adr\<^isub>i\<^isub>p net, port) Combinators" where
"Policy5 =

DenyAll \<oplus>  AllowPortFromTo nine five 190 \<oplus> AllowPortFromTo ten three 684 \<oplus> AllowPortFromTo three seven 564 \<oplus> AllowPortFromTo five three 552 \<oplus> DenyAllFromTo three one\<oplus> AllowPortFromTo seven eight 441 \<oplus> AllowPortFromTo seven three 928 \<oplus> AllowPortFromTo six one 86 \<oplus> DenyAllFromTo three six\<oplus> AllowPortFromTo two six 11 \<oplus> AllowPortFromTo two one 65 \<oplus> AllowPortFromTo nine five 628 \<oplus> AllowPortFromTo three nine 212 \<oplus> AllowPortFromTo two nine 686 \<oplus> AllowPortFromTo nine one 362 \<oplus> AllowPortFromTo eight nine 454 \<oplus> AllowPortFromTo three six 875 \<oplus> AllowPortFromTo three eight 262 \<oplus> AllowPortFromTo five six 363 \<oplus> AllowPortFromTo nine one 145 \<oplus> AllowPortFromTo six seven 860 \<oplus> AllowPortFromTo five one 48 \<oplus> AllowPortFromTo four ten 607 \<oplus> DenyAllFromTo ten six\<oplus> AllowPortFromTo eight nine 143 \<oplus> DenyAllFromTo nine one\<oplus> AllowPortFromTo eight ten 73 \<oplus> AllowPortFromTo three five 473 \<oplus> AllowPortFromTo nine ten 75 \<oplus> AllowPortFromTo eight five 135 \<oplus> AllowPortFromTo four seven 245 \<oplus> AllowPortFromTo three seven 51 \<oplus> AllowPortFromTo three seven 980 \<oplus> AllowPortFromTo seven eight 744 \<oplus> AllowPortFromTo eight five 837 \<oplus> AllowPortFromTo four ten 547 \<oplus> DenyAllFromTo nine four\<oplus> AllowPortFromTo ten eight 789 \<oplus> AllowPortFromTo eight two 510 \<oplus> AllowPortFromTo five eight 656 \<oplus> DenyAllFromTo one nine\<oplus> DenyAllFromTo seven nine\<oplus> AllowPortFromTo two four 886 \<oplus> DenyAllFromTo eight two\<oplus> AllowPortFromTo one three 523 \<oplus> AllowPortFromTo five six 802 \<oplus> AllowPortFromTo six eight 157 \<oplus> AllowPortFromTo eight seven 958 \<oplus> DenyAllFromTo two one\<oplus> DenyAllFromTo two seven\<oplus> AllowPortFromTo nine two 582 \<oplus> DenyAllFromTo two ten\<oplus> AllowPortFromTo four three 690 \<oplus> AllowPortFromTo eight nine 135 \<oplus> AllowPortFromTo nine six 724 \<oplus> AllowPortFromTo seven five 953 \<oplus> AllowPortFromTo one seven 808 \<oplus> AllowPortFromTo three two 142 \<oplus> AllowPortFromTo four ten 453 \<oplus> AllowPortFromTo two four 464 \<oplus> AllowPortFromTo three six 513 \<oplus> AllowPortFromTo eight six 270 \<oplus> DenyAllFromTo nine three\<oplus> AllowPortFromTo ten seven 253 \<oplus> AllowPortFromTo eight ten 766 \<oplus> AllowPortFromTo eight three 367 \<oplus> AllowPortFromTo two four 657 \<oplus> AllowPortFromTo ten six 326 \<oplus> AllowPortFromTo one three 83 \<oplus> AllowPortFromTo eight six 456 \<oplus> AllowPortFromTo seven ten 574 \<oplus> AllowPortFromTo one three 752 \<oplus> DenyAllFromTo eight two\<oplus> AllowPortFromTo five eight 385 \<oplus> DenyAllFromTo eight six\<oplus> DenyAllFromTo seven three\<oplus> DenyAllFromTo nine one\<oplus> AllowPortFromTo eight three 952 \<oplus> AllowPortFromTo ten four 82 \<oplus> AllowPortFromTo four three 781 \<oplus> AllowPortFromTo seven ten 129 \<oplus> AllowPortFromTo six nine 795 \<oplus> AllowPortFromTo four five 678 \<oplus> AllowPortFromTo eight six 709 \<oplus> DenyAllFromTo seven nine\<oplus> AllowPortFromTo four two 732 \<oplus> AllowPortFromTo one eight 592 \<oplus> AllowPortFromTo seven three 497 \<oplus> AllowPortFromTo ten eight 673 \<oplus> AllowPortFromTo nine one 87 \<oplus> AllowPortFromTo eight four 641 \<oplus> AllowPortFromTo two ten 325 \<oplus> DenyAllFromTo five nine\<oplus> AllowPortFromTo nine seven 499 \<oplus> AllowPortFromTo five eight 928 \<oplus> AllowPortFromTo six eight 271 \<oplus> AllowPortFromTo six eight 777 \<oplus> AllowPortFromTo six five 206 \<oplus> DenyAllFromTo two six\<oplus> AllowPortFromTo four seven 993
"

(*100  rules, 25 networks, 20% *)
definition Policy6 :: "(adr\<^isub>i\<^isub>p net, port) Combinators" where
"Policy6 =

DenyAll \<oplus>  AllowPortFromTo seven twentyone 383 \<oplus> AllowPortFromTo four twentytwo 904 \<oplus> AllowPortFromTo five twentytwo 743 \<oplus> AllowPortFromTo four twentyfour 105 \<oplus> AllowPortFromTo one ten 627 \<oplus> AllowPortFromTo twentyone seventeen 927 \<oplus> AllowPortFromTo seven fourteen 842 \<oplus> AllowPortFromTo twentyfive seventeen 35 \<oplus> AllowPortFromTo twenty nineteen 361 \<oplus> AllowPortFromTo ten four 37 \<oplus> AllowPortFromTo six ten 718 \<oplus> AllowPortFromTo ten seventeen 547 \<oplus> DenyAllFromTo ten six\<oplus> AllowPortFromTo twentytwo nineteen 642 \<oplus> AllowPortFromTo fifteen eleven 251 \<oplus> DenyAllFromTo twelve nineteen\<oplus> AllowPortFromTo eighteen nine 570 \<oplus> DenyAllFromTo nineteen twelve\<oplus> AllowPortFromTo four eighteen 752 \<oplus> AllowPortFromTo eleven five 821 \<oplus> AllowPortFromTo sixteen ten 871 \<oplus> AllowPortFromTo seventeen fourteen 182 \<oplus> AllowPortFromTo twentytwo twelve 613 \<oplus> AllowPortFromTo twentythree sixteen 22 \<oplus> AllowPortFromTo fourteen twentythree 5 \<oplus> AllowPortFromTo twentythree seven 630 \<oplus> AllowPortFromTo nine eight 3 \<oplus> DenyAllFromTo fifteen six\<oplus> AllowPortFromTo twentyfive fifteen 514 \<oplus> AllowPortFromTo two nine 851 \<oplus> AllowPortFromTo thirteen sixteen 690 \<oplus> AllowPortFromTo fifteen twentythree 800 \<oplus> AllowPortFromTo seventeen twentyfive 94 \<oplus> DenyAllFromTo twentythree two\<oplus> DenyAllFromTo eight seventeen\<oplus> AllowPortFromTo twentyone twentytwo 290 \<oplus> AllowPortFromTo twentytwo sixteen 820 \<oplus> AllowPortFromTo twentyone four 143 \<oplus> DenyAllFromTo six eighteen\<oplus> AllowPortFromTo one two 904 \<oplus> AllowPortFromTo fourteen eleven 55 \<oplus> AllowPortFromTo thirteen ten 318 \<oplus> AllowPortFromTo twentyfive eighteen 977 \<oplus> AllowPortFromTo eighteen nine 396 \<oplus> AllowPortFromTo twentyone seventeen 365 \<oplus> AllowPortFromTo sixteen eleven 896 \<oplus> AllowPortFromTo thirteen twentyone 732 \<oplus> AllowPortFromTo two seventeen 515 \<oplus> AllowPortFromTo twentyone sixteen 119 \<oplus> AllowPortFromTo twentyone three 287 \<oplus> AllowPortFromTo twentyfive eighteen 969 \<oplus> AllowPortFromTo eighteen fourteen 601 \<oplus> DenyAllFromTo fifteen five\<oplus> AllowPortFromTo seven nine 882 \<oplus> AllowPortFromTo twentytwo nineteen 227 \<oplus> AllowPortFromTo twentyone ten 385 \<oplus> AllowPortFromTo thirteen twentythree 104 \<oplus> DenyAllFromTo ten twentyfive\<oplus> AllowPortFromTo twentythree six 949 \<oplus> AllowPortFromTo twentyfive eight 677 \<oplus> AllowPortFromTo sixteen twentyone 297 \<oplus> AllowPortFromTo eighteen ten 597 \<oplus> AllowPortFromTo six twentytwo 750 \<oplus> DenyAllFromTo four fifteen\<oplus> AllowPortFromTo twentythree seven 97 \<oplus> AllowPortFromTo thirteen fifteen 472 \<oplus> AllowPortFromTo six twentyone 295 \<oplus> AllowPortFromTo twelve nineteen 746 \<oplus> AllowPortFromTo twelve twentyfive 301 \<oplus> AllowPortFromTo twentyfour fourteen 738 \<oplus> AllowPortFromTo ten eight 798 \<oplus> DenyAllFromTo seven sixteen\<oplus> DenyAllFromTo seventeen ten\<oplus> AllowPortFromTo twentythree five 681 \<oplus> AllowPortFromTo seven seventeen 886 \<oplus> AllowPortFromTo one eighteen 328 \<oplus> AllowPortFromTo twentyfour eleven 892 \<oplus> AllowPortFromTo thirteen fourteen 828 \<oplus> DenyAllFromTo two sixteen\<oplus> AllowPortFromTo sixteen fifteen 413 \<oplus> DenyAllFromTo ten eleven\<oplus> DenyAllFromTo eight fifteen\<oplus> DenyAllFromTo seven one\<oplus> AllowPortFromTo fourteen twentyone 34 \<oplus> AllowPortFromTo six nine 649 \<oplus> DenyAllFromTo twentythree ten\<oplus> AllowPortFromTo twelve eighteen 215 \<oplus> AllowPortFromTo twelve one 927 \<oplus> DenyAllFromTo four eleven\<oplus> AllowPortFromTo eleven nineteen 120 \<oplus> AllowPortFromTo twentyfour five 876 \<oplus> AllowPortFromTo eighteen five 651 \<oplus> AllowPortFromTo four twentyfour 63 \<oplus> DenyAllFromTo ten twentyone\<oplus> AllowPortFromTo thirteen nine 472 \<oplus> DenyAllFromTo four sixteen\<oplus> AllowPortFromTo twelve twentyfive 93 \<oplus> AllowPortFromTo nineteen twentythree 573 \<oplus> AllowPortFromTo fourteen sixteen 900 \<oplus> AllowPortFromTo two seventeen 340 
"

(* 200 rules, 5 networks, 20% *)
definition Policy7 :: "(adr\<^isub>i\<^isub>p net, port) Combinators" where
"Policy7 =
DenyAll \<oplus>  AllowPortFromTo four two 342 \<oplus> DenyAllFromTo two three\<oplus> AllowPortFromTo four two 311 \<oplus> AllowPortFromTo five three 809 \<oplus> AllowPortFromTo two four 157 \<oplus> AllowPortFromTo four three 948 \<oplus> AllowPortFromTo five three 827 \<oplus> DenyAllFromTo one four\<oplus> AllowPortFromTo three two 487 \<oplus> AllowPortFromTo five two 788 \<oplus> AllowPortFromTo four five 456 \<oplus> AllowPortFromTo five one 825 \<oplus> AllowPortFromTo four three 781 \<oplus> AllowPortFromTo five one 279 \<oplus> DenyAllFromTo one two\<oplus> AllowPortFromTo four one 541 \<oplus> AllowPortFromTo two one 679 \<oplus> AllowPortFromTo five four 713 \<oplus> AllowPortFromTo one five 927 \<oplus> AllowPortFromTo one two 906 \<oplus> DenyAllFromTo three four\<oplus> AllowPortFromTo three two 795 \<oplus> AllowPortFromTo one four 235 \<oplus> AllowPortFromTo one two 735 \<oplus> DenyAllFromTo two four\<oplus> AllowPortFromTo five four 847 \<oplus> AllowPortFromTo four five 335 \<oplus> AllowPortFromTo four one 207 \<oplus> AllowPortFromTo one two 909 \<oplus> AllowPortFromTo two three 247 \<oplus> AllowPortFromTo four five 224 \<oplus> AllowPortFromTo four three 442 \<oplus> AllowPortFromTo three four 356 \<oplus> AllowPortFromTo one two 903 \<oplus> AllowPortFromTo four five 695 \<oplus> AllowPortFromTo one five 358 \<oplus> AllowPortFromTo four two 197 \<oplus> AllowPortFromTo five two 380 \<oplus> AllowPortFromTo three four 492 \<oplus> AllowPortFromTo two five 618 \<oplus> DenyAllFromTo five two\<oplus> AllowPortFromTo three two 696 \<oplus> AllowPortFromTo five four 894 \<oplus> AllowPortFromTo five three 727 \<oplus> DenyAllFromTo three four\<oplus> AllowPortFromTo five one 901 \<oplus> AllowPortFromTo three four 257 \<oplus> AllowPortFromTo three one 518 \<oplus> AllowPortFromTo three five 2 \<oplus> AllowPortFromTo four three 584 \<oplus> AllowPortFromTo five two 742 \<oplus> AllowPortFromTo five two 0 \<oplus> AllowPortFromTo two three 414 \<oplus> DenyAllFromTo two five\<oplus> AllowPortFromTo five three 677 \<oplus> AllowPortFromTo five one 20 \<oplus> AllowPortFromTo one five 817 \<oplus> AllowPortFromTo four three 315 \<oplus> AllowPortFromTo five one 18 \<oplus> DenyAllFromTo one four\<oplus> AllowPortFromTo five three 915 \<oplus> AllowPortFromTo four one 275 \<oplus> AllowPortFromTo three one 88 \<oplus> DenyAllFromTo five two\<oplus> DenyAllFromTo three two\<oplus> AllowPortFromTo four three 769 \<oplus> AllowPortFromTo one four 132 \<oplus> AllowPortFromTo three one 84 \<oplus> DenyAllFromTo four one\<oplus> AllowPortFromTo three one 437 \<oplus> DenyAllFromTo three five\<oplus> AllowPortFromTo three one 136 \<oplus> AllowPortFromTo three one 327 \<oplus> AllowPortFromTo two five 226 \<oplus> AllowPortFromTo three one 386 \<oplus> AllowPortFromTo one three 494 \<oplus> DenyAllFromTo three four\<oplus> DenyAllFromTo three five\<oplus> DenyAllFromTo two four\<oplus> DenyAllFromTo five one\<oplus> DenyAllFromTo two five\<oplus> DenyAllFromTo three five\<oplus> AllowPortFromTo one five 693 \<oplus> AllowPortFromTo two three 750 \<oplus> AllowPortFromTo two one 449 \<oplus> AllowPortFromTo three two 254 \<oplus> AllowPortFromTo one three 41 \<oplus> AllowPortFromTo one four 215 \<oplus> AllowPortFromTo three four 345 \<oplus> AllowPortFromTo two one 248 \<oplus> AllowPortFromTo four three 45 \<oplus> AllowPortFromTo five one 149 \<oplus> AllowPortFromTo one five 926 \<oplus> AllowPortFromTo four one 306 \<oplus> AllowPortFromTo two three 674 \<oplus> AllowPortFromTo two five 544 \<oplus> AllowPortFromTo four one 429 \<oplus> AllowPortFromTo five three 666 \<oplus> AllowPortFromTo two three 189 \<oplus> AllowPortFromTo five three 717 \<oplus> AllowPortFromTo four three 992 \<oplus> AllowPortFromTo one four 635 \<oplus> AllowPortFromTo five three 194 \<oplus> DenyAllFromTo five two\<oplus> AllowPortFromTo five two 274 \<oplus> AllowPortFromTo three five 732 \<oplus> AllowPortFromTo four three 705 \<oplus> AllowPortFromTo five two 414 \<oplus> AllowPortFromTo five three 922 \<oplus> AllowPortFromTo two three 290 \<oplus> DenyAllFromTo one five\<oplus> AllowPortFromTo two three 419 \<oplus> AllowPortFromTo three one 606 \<oplus> AllowPortFromTo two four 45 \<oplus> AllowPortFromTo one two 581 \<oplus> AllowPortFromTo four one 751 \<oplus> AllowPortFromTo five one 747 \<oplus> AllowPortFromTo three one 743 \<oplus> AllowPortFromTo one two 257 \<oplus> AllowPortFromTo five two 428 \<oplus> AllowPortFromTo one three 508 \<oplus> AllowPortFromTo three five 629 \<oplus> AllowPortFromTo three one 676 \<oplus> AllowPortFromTo five two 519 \<oplus> AllowPortFromTo one three 840 \<oplus> AllowPortFromTo three one 108 \<oplus> AllowPortFromTo two four 487 \<oplus> AllowPortFromTo five three 428 \<oplus> AllowPortFromTo four five 615 \<oplus> AllowPortFromTo three four 269 \<oplus> AllowPortFromTo one five 846 \<oplus> AllowPortFromTo two three 475 \<oplus> DenyAllFromTo two four\<oplus> AllowPortFromTo three four 25 \<oplus> AllowPortFromTo three five 820 \<oplus> AllowPortFromTo two one 992 \<oplus> AllowPortFromTo one four 562 \<oplus> DenyAllFromTo five one\<oplus> DenyAllFromTo three one\<oplus> AllowPortFromTo three two 751 \<oplus> AllowPortFromTo two five 354 \<oplus> DenyAllFromTo three five\<oplus> AllowPortFromTo five one 157 \<oplus> AllowPortFromTo four two 654 \<oplus> AllowPortFromTo five four 838 \<oplus> AllowPortFromTo two one 12 \<oplus> AllowPortFromTo four two 458 \<oplus> AllowPortFromTo one three 680 \<oplus> DenyAllFromTo two one\<oplus> DenyAllFromTo four three\<oplus> AllowPortFromTo four five 559 \<oplus> AllowPortFromTo two one 268 \<oplus> AllowPortFromTo two three 404 \<oplus> AllowPortFromTo two four 940 \<oplus> AllowPortFromTo five one 567 \<oplus> AllowPortFromTo two three 288 \<oplus> DenyAllFromTo three one\<oplus> AllowPortFromTo five four 385 \<oplus> AllowPortFromTo three four 486 \<oplus> AllowPortFromTo one two 908 \<oplus> AllowPortFromTo one three 67 \<oplus> AllowPortFromTo five two 884 \<oplus> AllowPortFromTo two five 825 \<oplus> AllowPortFromTo three four 210 \<oplus> DenyAllFromTo two three\<oplus> AllowPortFromTo two five 3 \<oplus> AllowPortFromTo four one 495 \<oplus> AllowPortFromTo two four 333 \<oplus> AllowPortFromTo two three 802 \<oplus> AllowPortFromTo two five 304 \<oplus> DenyAllFromTo five one\<oplus> AllowPortFromTo one four 159 \<oplus> AllowPortFromTo three one 577 \<oplus> AllowPortFromTo two one 160 \<oplus> AllowPortFromTo two three 396 \<oplus> AllowPortFromTo four three 983 \<oplus> AllowPortFromTo four one 84 \<oplus> AllowPortFromTo three four 208 \<oplus> AllowPortFromTo three two 7 \<oplus> AllowPortFromTo one two 323 \<oplus> DenyAllFromTo two five\<oplus> AllowPortFromTo three four 646 \<oplus> AllowPortFromTo four three 152 \<oplus> AllowPortFromTo four five 965 \<oplus> AllowPortFromTo three one 882 \<oplus> DenyAllFromTo three four\<oplus> AllowPortFromTo three one 696 \<oplus> AllowPortFromTo two four 308 \<oplus> AllowPortFromTo three two 57 \<oplus> AllowPortFromTo one two 27 \<oplus> DenyAllFromTo three five\<oplus> AllowPortFromTo three four 877 \<oplus> AllowPortFromTo one three 969 \<oplus> DenyAllFromTo four two\<oplus> DenyAllFromTo five four\<oplus> AllowPortFromTo five one 771 \<oplus> AllowPortFromTo three four 510 \<oplus> AllowPortFromTo two four 407 \<oplus> AllowPortFromTo five four 295 \<oplus> DenyAllFromTo three four

"

(*200  rules,10  networks, 20% *)
definition Policy8 :: "(adr\<^isub>i\<^isub>p net, port) Combinators" where
"Policy8 =
DenyAll \<oplus>  AllowPortFromTo seven five 206 \<oplus> AllowPortFromTo seven two 445 \<oplus> DenyAllFromTo ten one\<oplus> AllowPortFromTo ten three 240 \<oplus> AllowPortFromTo six seven 27 \<oplus> AllowPortFromTo two seven 701 \<oplus> AllowPortFromTo three seven 165 \<oplus> DenyAllFromTo six seven\<oplus> AllowPortFromTo five eight 553 \<oplus> AllowPortFromTo one four 188 \<oplus> AllowPortFromTo eight six 54 \<oplus> AllowPortFromTo five one 462 \<oplus> AllowPortFromTo six two 952 \<oplus> AllowPortFromTo three four 891 \<oplus> AllowPortFromTo four five 225 \<oplus> DenyAllFromTo ten one\<oplus> AllowPortFromTo two four 714 \<oplus> AllowPortFromTo eight seven 160 \<oplus> DenyAllFromTo eight four\<oplus> AllowPortFromTo four two 779 \<oplus> AllowPortFromTo eight ten 435 \<oplus> AllowPortFromTo one seven 362 \<oplus> AllowPortFromTo four one 822 \<oplus> AllowPortFromTo three six 43 \<oplus> AllowPortFromTo ten one 362 \<oplus> AllowPortFromTo one ten 237 \<oplus> DenyAllFromTo eight four\<oplus> AllowPortFromTo five six 343 \<oplus> AllowPortFromTo five eight 114 \<oplus> AllowPortFromTo one nine 133 \<oplus> AllowPortFromTo six one 657 \<oplus> DenyAllFromTo ten seven\<oplus> DenyAllFromTo one seven\<oplus> AllowPortFromTo three two 631 \<oplus> AllowPortFromTo eight five 213 \<oplus> AllowPortFromTo two five 438 \<oplus> AllowPortFromTo eight ten 302 \<oplus> AllowPortFromTo one six 319 \<oplus> DenyAllFromTo four two\<oplus> AllowPortFromTo eight five 6 \<oplus> DenyAllFromTo three one\<oplus> AllowPortFromTo six seven 160 \<oplus> AllowPortFromTo four one 59 \<oplus> AllowPortFromTo ten seven 257 \<oplus> AllowPortFromTo one five 377 \<oplus> AllowPortFromTo nine six 415 \<oplus> AllowPortFromTo six three 799 \<oplus> AllowPortFromTo two nine 708 \<oplus> AllowPortFromTo two eight 464 \<oplus> DenyAllFromTo two seven\<oplus> AllowPortFromTo nine six 268 \<oplus> AllowPortFromTo two five 24 \<oplus> AllowPortFromTo seven six 36 \<oplus> AllowPortFromTo five ten 853 \<oplus> AllowPortFromTo three two 497 \<oplus> AllowPortFromTo four two 775 \<oplus> AllowPortFromTo four nine 147 \<oplus> AllowPortFromTo nine six 814 \<oplus> AllowPortFromTo six one 958 \<oplus> AllowPortFromTo two ten 68 \<oplus> AllowPortFromTo seven eight 177 \<oplus> DenyAllFromTo nine four\<oplus> AllowPortFromTo five two 661 \<oplus> AllowPortFromTo six one 444 \<oplus> AllowPortFromTo four seven 864 \<oplus> AllowPortFromTo one nine 957 \<oplus> AllowPortFromTo one five 256 \<oplus> DenyAllFromTo six three\<oplus> AllowPortFromTo six four 719 \<oplus> AllowPortFromTo eight one 265 \<oplus> AllowPortFromTo four nine 453 \<oplus> AllowPortFromTo one seven 157 \<oplus> AllowPortFromTo four one 349 \<oplus> AllowPortFromTo five six 553 \<oplus> DenyAllFromTo eight five\<oplus> AllowPortFromTo eight four 146 \<oplus> DenyAllFromTo one four\<oplus> AllowPortFromTo five nine 127 \<oplus> AllowPortFromTo eight two 865 \<oplus> AllowPortFromTo four nine 877 \<oplus> AllowPortFromTo one nine 296 \<oplus> AllowPortFromTo seven ten 409 \<oplus> AllowPortFromTo eight one 922 \<oplus> AllowPortFromTo nine ten 626 \<oplus> AllowPortFromTo one five 551 \<oplus> AllowPortFromTo ten one 320 \<oplus> AllowPortFromTo two seven 513 \<oplus> AllowPortFromTo nine ten 976 \<oplus> AllowPortFromTo seven three 564 \<oplus> AllowPortFromTo two eight 389 \<oplus> DenyAllFromTo nine seven\<oplus> AllowPortFromTo ten five 820 \<oplus> AllowPortFromTo one four 337 \<oplus> AllowPortFromTo eight one 268 \<oplus> AllowPortFromTo eight seven 927 \<oplus> AllowPortFromTo four three 675 \<oplus> DenyAllFromTo five eight\<oplus> AllowPortFromTo nine one 182 \<oplus> AllowPortFromTo seven eight 958 \<oplus> DenyAllFromTo four three\<oplus> AllowPortFromTo three five 325 \<oplus> AllowPortFromTo eight five 857 \<oplus> AllowPortFromTo two ten 611 \<oplus> AllowPortFromTo three five 635 \<oplus> AllowPortFromTo ten five 819 \<oplus> AllowPortFromTo three five 256 \<oplus> AllowPortFromTo eight nine 751 \<oplus> AllowPortFromTo five eight 214 \<oplus> AllowPortFromTo eight three 13 \<oplus> DenyAllFromTo nine six\<oplus> AllowPortFromTo ten four 620 \<oplus> DenyAllFromTo five seven\<oplus> AllowPortFromTo six ten 775 \<oplus> AllowPortFromTo ten two 142 \<oplus> AllowPortFromTo seven ten 677 \<oplus> AllowPortFromTo five three 19 \<oplus> AllowPortFromTo four ten 502 \<oplus> AllowPortFromTo five nine 274 \<oplus> AllowPortFromTo seven two 534 \<oplus> AllowPortFromTo ten seven 305 \<oplus> AllowPortFromTo four six 848 \<oplus> AllowPortFromTo seven one 522 \<oplus> AllowPortFromTo eight ten 700 \<oplus> AllowPortFromTo ten three 719 \<oplus> AllowPortFromTo one ten 883 \<oplus> AllowPortFromTo seven eight 435 \<oplus> AllowPortFromTo three one 676 \<oplus> AllowPortFromTo five eight 723 \<oplus> AllowPortFromTo one nine 162 \<oplus> AllowPortFromTo eight seven 631 \<oplus> AllowPortFromTo five four 978 \<oplus> DenyAllFromTo nine three\<oplus> AllowPortFromTo three four 672 \<oplus> AllowPortFromTo one two 522 \<oplus> AllowPortFromTo one ten 799 \<oplus> DenyAllFromTo one six\<oplus> AllowPortFromTo three five 840 \<oplus> AllowPortFromTo one six 893 \<oplus> AllowPortFromTo nine four 126 \<oplus> DenyAllFromTo six two\<oplus> DenyAllFromTo seven five\<oplus> DenyAllFromTo three six\<oplus> AllowPortFromTo ten nine 3 \<oplus> AllowPortFromTo four seven 222 \<oplus> DenyAllFromTo four eight\<oplus> AllowPortFromTo six seven 188 \<oplus> AllowPortFromTo seven five 968 \<oplus> AllowPortFromTo four five 28 \<oplus> DenyAllFromTo six ten\<oplus> AllowPortFromTo seven six 186 \<oplus> AllowPortFromTo one three 260 \<oplus> AllowPortFromTo six ten 469 \<oplus> AllowPortFromTo four nine 414 \<oplus> AllowPortFromTo one four 180 \<oplus> DenyAllFromTo one six\<oplus> DenyAllFromTo one three\<oplus> AllowPortFromTo one ten 255 \<oplus> AllowPortFromTo five two 791 \<oplus> AllowPortFromTo six two 257 \<oplus> AllowPortFromTo six two 217 \<oplus> AllowPortFromTo ten five 527 \<oplus> DenyAllFromTo eight ten\<oplus> AllowPortFromTo eight seven 967 \<oplus> AllowPortFromTo five six 552 \<oplus> AllowPortFromTo five ten 167 \<oplus> AllowPortFromTo two five 686 \<oplus> AllowPortFromTo seven nine 517 \<oplus> AllowPortFromTo one two 152 \<oplus> AllowPortFromTo five ten 321 \<oplus> AllowPortFromTo two six 973 \<oplus> AllowPortFromTo nine six 886 \<oplus> DenyAllFromTo nine three\<oplus> AllowPortFromTo eight five 958 \<oplus> AllowPortFromTo three eight 210 \<oplus> AllowPortFromTo one five 827 \<oplus> DenyAllFromTo six one\<oplus> AllowPortFromTo three ten 210 \<oplus> AllowPortFromTo six seven 308 \<oplus> AllowPortFromTo six nine 418 \<oplus> DenyAllFromTo four five\<oplus> AllowPortFromTo ten four 378 \<oplus> AllowPortFromTo three one 214 \<oplus> DenyAllFromTo six ten\<oplus> AllowPortFromTo nine five 464 \<oplus> AllowPortFromTo three two 981 \<oplus> AllowPortFromTo eight six 101 \<oplus> AllowPortFromTo nine seven 864 \<oplus> DenyAllFromTo four six\<oplus> DenyAllFromTo one four\<oplus> AllowPortFromTo nine four 442 \<oplus> AllowPortFromTo eight one 754 \<oplus> AllowPortFromTo seven three 350 \<oplus> AllowPortFromTo one six 791 \<oplus> AllowPortFromTo two eight 958 \<oplus> AllowPortFromTo ten nine 632 \<oplus> AllowPortFromTo six five 693 \<oplus> AllowPortFromTo nine one 78 \<oplus> AllowPortFromTo five one 824 \<oplus> AllowPortFromTo ten five 129 \<oplus> AllowPortFromTo two seven 166

"

(*200  rules, 25  networks, 20% *)
definition Policy9 :: "(adr\<^isub>i\<^isub>p net, port) Combinators" where
"Policy9 =
DenyAll \<oplus>  AllowPortFromTo twelve twentytwo 430 \<oplus> AllowPortFromTo seventeen one 13 \<oplus> AllowPortFromTo fifteen eighteen 316 \<oplus> AllowPortFromTo eleven ten 728 \<oplus> AllowPortFromTo one two 481 \<oplus> AllowPortFromTo thirteen three 158 \<oplus> AllowPortFromTo twelve thirteen 645 \<oplus> AllowPortFromTo fourteen twentytwo 211 \<oplus> AllowPortFromTo twentytwo fifteen 316 \<oplus> DenyAllFromTo twentyfive ten\<oplus> AllowPortFromTo seven twenty 483 \<oplus> AllowPortFromTo twentythree eleven 231 \<oplus> AllowPortFromTo twentyfour seventeen 679 \<oplus> AllowPortFromTo twenty nine 322 \<oplus> AllowPortFromTo nineteen two 970 \<oplus> AllowPortFromTo three eleven 401 \<oplus> AllowPortFromTo four sixteen 79 \<oplus> AllowPortFromTo seventeen fourteen 355 \<oplus> DenyAllFromTo seventeen twentythree\<oplus> DenyAllFromTo twelve thirteen\<oplus> AllowPortFromTo seven six 28 \<oplus> AllowPortFromTo twentytwo seven 153 \<oplus> AllowPortFromTo twentythree eight 41 \<oplus> AllowPortFromTo twentyfive eight 480 \<oplus> DenyAllFromTo twentyfive fifteen\<oplus> AllowPortFromTo seventeen fifteen 54 \<oplus> AllowPortFromTo twentythree twenty 148 \<oplus> AllowPortFromTo eleven twelve 945 \<oplus> AllowPortFromTo twentyfour four 878 \<oplus> AllowPortFromTo twentyfive one 432 \<oplus> DenyAllFromTo sixteen nine\<oplus> AllowPortFromTo nine nineteen 796 \<oplus> AllowPortFromTo eight four 347 \<oplus> DenyAllFromTo twentyfour twelve\<oplus> AllowPortFromTo twentyfive twentyone 848 \<oplus> AllowPortFromTo three thirteen 903 \<oplus> AllowPortFromTo one twentyfive 306 \<oplus> DenyAllFromTo nineteen twentythree\<oplus> AllowPortFromTo fifteen twentyone 755 \<oplus> AllowPortFromTo eighteen twelve 929 \<oplus> AllowPortFromTo fourteen eleven 436 \<oplus> DenyAllFromTo twentyone fourteen\<oplus> DenyAllFromTo eighteen eleven\<oplus> AllowPortFromTo eight twentyfive 773 \<oplus> AllowPortFromTo twentyfive seven 582 \<oplus> AllowPortFromTo fifteen four 289 \<oplus> AllowPortFromTo fifteen two 395 \<oplus> AllowPortFromTo fourteen four 95 \<oplus> AllowPortFromTo nine twentyfour 403 \<oplus> AllowPortFromTo nine twentyfour 701 \<oplus> AllowPortFromTo twentyone one 419 \<oplus> AllowPortFromTo six three 428 \<oplus> AllowPortFromTo twelve twentyfive 509 \<oplus> DenyAllFromTo one eighteen\<oplus> AllowPortFromTo two ten 344 \<oplus> AllowPortFromTo two sixteen 27 \<oplus> DenyAllFromTo twentyone seven\<oplus> DenyAllFromTo four twelve\<oplus> AllowPortFromTo eight three 911 \<oplus> AllowPortFromTo thirteen twentytwo 615 \<oplus> AllowPortFromTo twentythree thirteen 832 \<oplus> AllowPortFromTo nineteen two 226 \<oplus> AllowPortFromTo twentytwo twentythree 371 \<oplus> AllowPortFromTo seventeen nineteen 266 \<oplus> AllowPortFromTo eleven eight 103 \<oplus> DenyAllFromTo seventeen four\<oplus> AllowPortFromTo seven seventeen 536 \<oplus> DenyAllFromTo six five\<oplus> AllowPortFromTo three thirteen 879 \<oplus> DenyAllFromTo fourteen nine\<oplus> DenyAllFromTo seventeen one\<oplus> AllowPortFromTo five eighteen 594 \<oplus> DenyAllFromTo seventeen nine\<oplus> AllowPortFromTo six two 146 \<oplus> AllowPortFromTo one twentyone 820 \<oplus> AllowPortFromTo sixteen seven 250 \<oplus> DenyAllFromTo nineteen twentyone\<oplus> AllowPortFromTo nine five 734 \<oplus> DenyAllFromTo fifteen eight\<oplus> DenyAllFromTo seventeen two\<oplus> AllowPortFromTo four eleven 149 \<oplus> AllowPortFromTo seventeen fifteen 586 \<oplus> AllowPortFromTo twenty twentythree 363 \<oplus> AllowPortFromTo two fifteen 236 \<oplus> AllowPortFromTo seven twentyone 889 \<oplus> AllowPortFromTo eight twentythree 228 \<oplus> AllowPortFromTo three twentyone 805 \<oplus> AllowPortFromTo seven fifteen 736 \<oplus> AllowPortFromTo eleven twenty 343 \<oplus> AllowPortFromTo eighteen twentythree 144 \<oplus> AllowPortFromTo twentyfour twentyfive 162 \<oplus> DenyAllFromTo six thirteen\<oplus> AllowPortFromTo twentytwo fifteen 560 \<oplus> DenyAllFromTo fourteen four\<oplus> AllowPortFromTo two seventeen 268 \<oplus> AllowPortFromTo eight seven 971 \<oplus> AllowPortFromTo seven four 943 \<oplus> AllowPortFromTo three seven 93 \<oplus> AllowPortFromTo twentyone seven 862 \<oplus> AllowPortFromTo eighteen five 845 \<oplus> AllowPortFromTo twentytwo sixteen 680 \<oplus> DenyAllFromTo twentyfive four\<oplus> AllowPortFromTo fifteen six 676 \<oplus> AllowPortFromTo twentyone nineteen 786 \<oplus> DenyAllFromTo seventeen eight\<oplus> AllowPortFromTo fourteen eight 813 \<oplus> AllowPortFromTo two twentytwo 876 \<oplus> AllowPortFromTo twenty fourteen 284 \<oplus> DenyAllFromTo one four\<oplus> DenyAllFromTo twentyfour five\<oplus> DenyAllFromTo three thirteen\<oplus> AllowPortFromTo one nineteen 541 \<oplus> AllowPortFromTo six eighteen 549 \<oplus> DenyAllFromTo nine twentyfive\<oplus> AllowPortFromTo nineteen twentyfour 272 \<oplus> DenyAllFromTo fifteen three\<oplus> AllowPortFromTo seven eleven 134 \<oplus> AllowPortFromTo fourteen twelve 841 \<oplus> AllowPortFromTo sixteen one 158 \<oplus> AllowPortFromTo eight twentyone 743 \<oplus> AllowPortFromTo fourteen two 229 \<oplus> AllowPortFromTo fifteen six 106 \<oplus> DenyAllFromTo ten nineteen\<oplus> AllowPortFromTo one eleven 826 \<oplus> DenyAllFromTo eighteen twentyfour\<oplus> AllowPortFromTo twentythree thirteen 541 \<oplus> AllowPortFromTo seventeen six 859 \<oplus> DenyAllFromTo twentytwo four\<oplus> AllowPortFromTo two thirteen 120 \<oplus> DenyAllFromTo fourteen twentythree\<oplus> AllowPortFromTo twentythree two 429 \<oplus> AllowPortFromTo fifteen ten 886 \<oplus> AllowPortFromTo eighteen fifteen 44 \<oplus> DenyAllFromTo eleven twentyfour\<oplus> DenyAllFromTo twenty three\<oplus> AllowPortFromTo five fifteen 685 \<oplus> AllowPortFromTo twentythree one 504 \<oplus> AllowPortFromTo twentyfive fifteen 443 \<oplus> AllowPortFromTo eleven thirteen 670 \<oplus> AllowPortFromTo seventeen eight 617 \<oplus> AllowPortFromTo one eleven 50 \<oplus> AllowPortFromTo sixteen twentyfive 182 \<oplus> AllowPortFromTo two six 607 \<oplus> AllowPortFromTo twentythree twelve 350 \<oplus> AllowPortFromTo twentyfour four 934 \<oplus> AllowPortFromTo eighteen seven 765 \<oplus> AllowPortFromTo thirteen nine 439 \<oplus> AllowPortFromTo seventeen two 392 \<oplus> AllowPortFromTo one eight 862 \<oplus> AllowPortFromTo twentyone eleven 17 \<oplus> AllowPortFromTo fourteen five 408 \<oplus> AllowPortFromTo twentyfive two 33 \<oplus> AllowPortFromTo eleven eight 397 \<oplus> AllowPortFromTo eleven eight 934 \<oplus> AllowPortFromTo twenty thirteen 909 \<oplus> DenyAllFromTo eight twentyfive\<oplus> AllowPortFromTo eighteen twenty 10 \<oplus> AllowPortFromTo thirteen twelve 351 \<oplus> AllowPortFromTo eight twentythree 908 \<oplus> AllowPortFromTo three five 158 \<oplus> AllowPortFromTo nine twentyone 965 \<oplus> AllowPortFromTo fifteen twenty 246 \<oplus> AllowPortFromTo fourteen twentyfive 111 \<oplus> AllowPortFromTo fifteen seven 370 \<oplus> DenyAllFromTo twenty thirteen\<oplus> AllowPortFromTo twentyone twentyfour 369 \<oplus> AllowPortFromTo sixteen ten 811 \<oplus> AllowPortFromTo ten seventeen 328 \<oplus> DenyAllFromTo twentyfive two\<oplus> AllowPortFromTo twentytwo five 722 \<oplus> DenyAllFromTo twentyfive four\<oplus> AllowPortFromTo nineteen twentyfive 132 \<oplus> AllowPortFromTo six twentyfour 778 \<oplus> DenyAllFromTo seventeen twentyfive\<oplus> AllowPortFromTo eight twentyfive 34 \<oplus> DenyAllFromTo nineteen two\<oplus> AllowPortFromTo sixteen ten 159 \<oplus> AllowPortFromTo twentytwo twentyfour 363 \<oplus> DenyAllFromTo one eight\<oplus> AllowPortFromTo seven eighteen 902 \<oplus> AllowPortFromTo sixteen four 706 \<oplus> AllowPortFromTo four twelve 299 \<oplus> AllowPortFromTo fourteen nineteen 771 \<oplus> DenyAllFromTo six fifteen\<oplus> AllowPortFromTo seven twelve 167 \<oplus> AllowPortFromTo eighteen twenty 710 \<oplus> AllowPortFromTo twentyone two 897 \<oplus> AllowPortFromTo twentytwo two 691 \<oplus> AllowPortFromTo six fourteen 843 \<oplus> AllowPortFromTo six twentyone 816 \<oplus> AllowPortFromTo twentyone twenty 20 \<oplus> AllowPortFromTo eighteen twelve 1 \<oplus> AllowPortFromTo twentyfour two 49 \<oplus> AllowPortFromTo nine twentyone 498 \<oplus> AllowPortFromTo twentyone twentythree 837 \<oplus> AllowPortFromTo three fifteen 503 \<oplus> AllowPortFromTo three sixteen 705 \<oplus> AllowPortFromTo twentytwo seven 114 \<oplus> AllowPortFromTo two six 581 \<oplus> AllowPortFromTo nineteen sixteen 525 "



(* 300 rules, 5 networks, 20% *)

fun DA :: "(adr\<^isub>i\<^isub>p net, port) Combinators list \<Rightarrow> int" where 
 "DA ((DenyAllFromTo a b)#xs) = (1 + (DA xs))"
|"DA (x#xs) = DA xs"
|"DA [] = 0"

lemma "DA (policy2list Policy9) = X"
apply (simp add: Policy9_def)
oops

lemma "numberOfRulesList[Policy9] = X"
apply (simp add: Policy9_def)
oops


definition Policy10 :: "(adr\<^isub>i\<^isub>p net, port) Combinators" where
"Policy10 =
DenyAll \<oplus>  AllowPortFromTo one two 667 \<oplus> AllowPortFromTo five four 776 \<oplus> AllowPortFromTo four five 38 \<oplus> AllowPortFromTo four two 27 \<oplus> DenyAllFromTo three five\<oplus> DenyAllFromTo five one\<oplus> AllowPortFromTo five four 999 \<oplus> AllowPortFromTo two four 942 \<oplus> AllowPortFromTo two three 63 \<oplus> AllowPortFromTo three four 965 \<oplus> DenyAllFromTo three one\<oplus> AllowPortFromTo four three 280 \<oplus> AllowPortFromTo three five 3 \<oplus> AllowPortFromTo three four 964 \<oplus> AllowPortFromTo two four 149 \<oplus> AllowPortFromTo four three 718 \<oplus> AllowPortFromTo three four 947 \<oplus> AllowPortFromTo one three 375 \<oplus> AllowPortFromTo two one 71 \<oplus> DenyAllFromTo three one\<oplus> AllowPortFromTo three one 617 \<oplus> AllowPortFromTo five four 5 \<oplus> AllowPortFromTo two five 441 \<oplus> AllowPortFromTo five four 764 \<oplus> AllowPortFromTo one four 975 \<oplus> AllowPortFromTo two four 785 \<oplus> AllowPortFromTo four one 161 \<oplus> AllowPortFromTo five two 996 \<oplus> AllowPortFromTo five three 393 \<oplus> AllowPortFromTo two three 434 \<oplus> AllowPortFromTo four one 253 \<oplus> AllowPortFromTo four one 125 \<oplus> AllowPortFromTo four one 670 \<oplus> DenyAllFromTo four five\<oplus> DenyAllFromTo four one\<oplus> AllowPortFromTo two five 173 \<oplus> AllowPortFromTo one five 509 \<oplus> AllowPortFromTo five two 532 \<oplus> DenyAllFromTo three one\<oplus> AllowPortFromTo five three 147 \<oplus> AllowPortFromTo one four 31 \<oplus> AllowPortFromTo one three 85 \<oplus> AllowPortFromTo five two 16 \<oplus> AllowPortFromTo one two 197 \<oplus> AllowPortFromTo five two 700 \<oplus> AllowPortFromTo one four 226 \<oplus> DenyAllFromTo one four\<oplus> AllowPortFromTo five three 718 \<oplus> AllowPortFromTo five one 293 \<oplus> AllowPortFromTo five two 953 \<oplus> AllowPortFromTo three two 407 \<oplus> AllowPortFromTo two five 214 \<oplus> DenyAllFromTo one four\<oplus> AllowPortFromTo four five 951 \<oplus> AllowPortFromTo one three 459 \<oplus> AllowPortFromTo one four 836 \<oplus> AllowPortFromTo five two 903 \<oplus> AllowPortFromTo two one 812 \<oplus> AllowPortFromTo four five 909 \<oplus> AllowPortFromTo one three 845 \<oplus> AllowPortFromTo two four 833 \<oplus> AllowPortFromTo one three 334 \<oplus> AllowPortFromTo one two 30 \<oplus> AllowPortFromTo one five 231 \<oplus> AllowPortFromTo one four 688 \<oplus> AllowPortFromTo three two 744 \<oplus> AllowPortFromTo four two 682 \<oplus> AllowPortFromTo three five 246 \<oplus> AllowPortFromTo two five 67 \<oplus> AllowPortFromTo five three 777 \<oplus> DenyAllFromTo four one\<oplus> AllowPortFromTo one two 251 \<oplus> AllowPortFromTo one three 17 \<oplus> AllowPortFromTo three two 563 \<oplus> AllowPortFromTo three four 812 \<oplus> AllowPortFromTo three one 311 \<oplus> AllowPortFromTo three one 757 \<oplus> AllowPortFromTo four five 536 \<oplus> AllowPortFromTo three four 983 \<oplus> AllowPortFromTo five three 419 \<oplus> AllowPortFromTo one four 614 \<oplus> AllowPortFromTo four one 701 \<oplus> AllowPortFromTo two one 518 \<oplus> AllowPortFromTo one five 926 \<oplus> DenyAllFromTo five three\<oplus> AllowPortFromTo three four 766 \<oplus> AllowPortFromTo three two 834 \<oplus> AllowPortFromTo three five 831 \<oplus> AllowPortFromTo four three 848 \<oplus> AllowPortFromTo two four 309 \<oplus> AllowPortFromTo four one 751 \<oplus> AllowPortFromTo five four 637 \<oplus> AllowPortFromTo two three 739 \<oplus> AllowPortFromTo three one 487 \<oplus> AllowPortFromTo one three 463 \<oplus> AllowPortFromTo one five 929 \<oplus> AllowPortFromTo one two 974 \<oplus> AllowPortFromTo one two 912 \<oplus> AllowPortFromTo three four 514 \<oplus> AllowPortFromTo three two 758 \<oplus> AllowPortFromTo one two 415 \<oplus> AllowPortFromTo two four 86 \<oplus> DenyAllFromTo one four\<oplus> AllowPortFromTo four one 562 \<oplus> DenyAllFromTo five four\<oplus> AllowPortFromTo three four 54 \<oplus> AllowPortFromTo three two 592 \<oplus> AllowPortFromTo five two 308 \<oplus> AllowPortFromTo four two 424 \<oplus> AllowPortFromTo four five 481 \<oplus> AllowPortFromTo three five 521 \<oplus> AllowPortFromTo two four 220 \<oplus> AllowPortFromTo one two 434 \<oplus> AllowPortFromTo five three 569 \<oplus> AllowPortFromTo two one 795 \<oplus> AllowPortFromTo three one 806 \<oplus> AllowPortFromTo four five 809 \<oplus> AllowPortFromTo four three 463 \<oplus> AllowPortFromTo five two 28 \<oplus> AllowPortFromTo two one 875 \<oplus> AllowPortFromTo five one 394 \<oplus> AllowPortFromTo two five 911 \<oplus> AllowPortFromTo three two 564 \<oplus> AllowPortFromTo three one 450 \<oplus> AllowPortFromTo three two 996 \<oplus> AllowPortFromTo two one 217 \<oplus> AllowPortFromTo two one 118 \<oplus> AllowPortFromTo one three 748 \<oplus> AllowPortFromTo three four 795 \<oplus> AllowPortFromTo two five 339 \<oplus> AllowPortFromTo two one 214 \<oplus> AllowPortFromTo five three 176 \<oplus> AllowPortFromTo three two 713 \<oplus> AllowPortFromTo four five 982 \<oplus> DenyAllFromTo three two\<oplus> AllowPortFromTo one four 291 \<oplus> AllowPortFromTo one four 995 \<oplus> AllowPortFromTo five two 937 \<oplus> AllowPortFromTo five four 884 \<oplus> AllowPortFromTo two five 439 \<oplus> AllowPortFromTo five four 70 \<oplus> AllowPortFromTo five one 130 \<oplus> AllowPortFromTo four three 853 \<oplus> AllowPortFromTo four one 763 \<oplus> DenyAllFromTo five three\<oplus> AllowPortFromTo three four 900 \<oplus> AllowPortFromTo two five 526 \<oplus> AllowPortFromTo five one 158 \<oplus> AllowPortFromTo two one 267 \<oplus> AllowPortFromTo two four 362 \<oplus> AllowPortFromTo four three 861 \<oplus> DenyAllFromTo five three\<oplus> AllowPortFromTo one four 881 \<oplus> DenyAllFromTo two one\<oplus> DenyAllFromTo five one\<oplus> AllowPortFromTo four three 552 \<oplus> DenyAllFromTo two one\<oplus> AllowPortFromTo three four 604 \<oplus> AllowPortFromTo five three 787 \<oplus> AllowPortFromTo one two 657 \<oplus> AllowPortFromTo three two 106 \<oplus> AllowPortFromTo one three 879 \<oplus> AllowPortFromTo five four 936 \<oplus> AllowPortFromTo one three 610 \<oplus> AllowPortFromTo five one 642 \<oplus> AllowPortFromTo five two 534 \<oplus> AllowPortFromTo four two 783 \<oplus> AllowPortFromTo five four 992 \<oplus> AllowPortFromTo two three 372 \<oplus> AllowPortFromTo two four 474 \<oplus> AllowPortFromTo one two 262 \<oplus> AllowPortFromTo four five 281 \<oplus> AllowPortFromTo three two 191 \<oplus> AllowPortFromTo five two 878 \<oplus> AllowPortFromTo five four 494 \<oplus> AllowPortFromTo one two 940 \<oplus> DenyAllFromTo four five\<oplus> DenyAllFromTo three four\<oplus> DenyAllFromTo four one\<oplus> DenyAllFromTo three one\<oplus> AllowPortFromTo one five 858 \<oplus> AllowPortFromTo five one 523 \<oplus> AllowPortFromTo five four 54 \<oplus> AllowPortFromTo three five 555 \<oplus> AllowPortFromTo two one 580 \<oplus> AllowPortFromTo five two 279 \<oplus> AllowPortFromTo three one 180 \<oplus> AllowPortFromTo two one 518 \<oplus> AllowPortFromTo two five 542 \<oplus> DenyAllFromTo two four\<oplus> AllowPortFromTo two four 110 \<oplus> AllowPortFromTo one five 658 \<oplus> AllowPortFromTo three four 745 \<oplus> AllowPortFromTo three four 353 \<oplus> DenyAllFromTo three five\<oplus> AllowPortFromTo one three 851 \<oplus> DenyAllFromTo five one\<oplus> AllowPortFromTo five four 737 \<oplus> AllowPortFromTo five four 871 \<oplus> DenyAllFromTo four one\<oplus> AllowPortFromTo five two 636 \<oplus> AllowPortFromTo five three 571 \<oplus> AllowPortFromTo three four 57 \<oplus> AllowPortFromTo two one 616 \<oplus> AllowPortFromTo one three 997 \<oplus> AllowPortFromTo two one 837 \<oplus> AllowPortFromTo four one 383 \<oplus> AllowPortFromTo four three 327 \<oplus> AllowPortFromTo one three 127 \<oplus> AllowPortFromTo five three 158 \<oplus> AllowPortFromTo five three 432 \<oplus> AllowPortFromTo three five 673 \<oplus> DenyAllFromTo three one\<oplus> AllowPortFromTo one four 885 \<oplus> AllowPortFromTo five three 449 \<oplus> DenyAllFromTo three two\<oplus> DenyAllFromTo one three\<oplus> AllowPortFromTo two five 242 \<oplus> DenyAllFromTo three four\<oplus> AllowPortFromTo one three 527 \<oplus> AllowPortFromTo three two 943 \<oplus> AllowPortFromTo four one 23 \<oplus> DenyAllFromTo one five\<oplus> DenyAllFromTo five four\<oplus> AllowPortFromTo one five 950 \<oplus> AllowPortFromTo three four 84 \<oplus> AllowPortFromTo one three 826 \<oplus> AllowPortFromTo three five 121 \<oplus> AllowPortFromTo one three 507 \<oplus> AllowPortFromTo five three 708 \<oplus> DenyAllFromTo four two\<oplus> AllowPortFromTo five three 321 \<oplus> AllowPortFromTo one three 474 \<oplus> DenyAllFromTo two five\<oplus> AllowPortFromTo two four 152 \<oplus> AllowPortFromTo five two 289 \<oplus> AllowPortFromTo four five 541 \<oplus> AllowPortFromTo one five 879 \<oplus> AllowPortFromTo one two 840 \<oplus> AllowPortFromTo five two 438 \<oplus> AllowPortFromTo one two 345 \<oplus> AllowPortFromTo four one 437 \<oplus> AllowPortFromTo five two 836 \<oplus> AllowPortFromTo two five 869 \<oplus> AllowPortFromTo three one 413 \<oplus> AllowPortFromTo two five 332 \<oplus> AllowPortFromTo five four 591 \<oplus> AllowPortFromTo one four 157 \<oplus> AllowPortFromTo two four 974 \<oplus> AllowPortFromTo three four 660 \<oplus> AllowPortFromTo four three 985 \<oplus> AllowPortFromTo one four 930 \<oplus> AllowPortFromTo five two 827 \<oplus> AllowPortFromTo five two 629 \<oplus> AllowPortFromTo five four 34 \<oplus> AllowPortFromTo four five 577 \<oplus> AllowPortFromTo one five 997 \<oplus> AllowPortFromTo four three 256 \<oplus> AllowPortFromTo one three 181 \<oplus> DenyAllFromTo five two\<oplus> AllowPortFromTo five two 857 \<oplus> DenyAllFromTo one four\<oplus> DenyAllFromTo three five\<oplus> AllowPortFromTo two four 725 \<oplus> AllowPortFromTo five one 895 \<oplus> AllowPortFromTo three four 751 \<oplus> AllowPortFromTo three five 396 \<oplus> AllowPortFromTo one four 48 \<oplus> AllowPortFromTo three four 459 \<oplus> AllowPortFromTo five two 771 \<oplus> DenyAllFromTo one five\<oplus> AllowPortFromTo five three 582 \<oplus> AllowPortFromTo four two 356 \<oplus> AllowPortFromTo two four 23 \<oplus> AllowPortFromTo one five 58 \<oplus> DenyAllFromTo one five\<oplus> AllowPortFromTo one five 726 \<oplus> AllowPortFromTo two four 392 \<oplus> AllowPortFromTo one four 557 \<oplus> AllowPortFromTo one three 421 \<oplus> AllowPortFromTo three two 11 \<oplus> AllowPortFromTo one five 688 \<oplus> AllowPortFromTo four three 55 \<oplus> AllowPortFromTo three two 91 \<oplus> AllowPortFromTo two one 780 \<oplus> AllowPortFromTo three four 983 \<oplus> AllowPortFromTo two three 144 \<oplus> AllowPortFromTo three one 790 \<oplus> AllowPortFromTo four three 681 \<oplus> AllowPortFromTo three five 452 \<oplus> AllowPortFromTo one five 765 \<oplus> AllowPortFromTo two three 984 \<oplus> AllowPortFromTo one five 479 \<oplus> AllowPortFromTo three five 379 \<oplus> AllowPortFromTo three four 299 \<oplus> AllowPortFromTo one two 206 \<oplus> AllowPortFromTo one four 537 \<oplus> AllowPortFromTo three two 158 \<oplus> AllowPortFromTo three four 352 \<oplus> AllowPortFromTo one five 50

"

(*300  rules, 10 networks, 20% *)
definition Policy11 :: "(adr\<^isub>i\<^isub>p net, port) Combinators" where
"Policy11 =
DenyAll \<oplus>  AllowPortFromTo eight nine 930 \<oplus> AllowPortFromTo two seven 722 \<oplus> AllowPortFromTo seven two 597 \<oplus> AllowPortFromTo four seven 224 \<oplus> DenyAllFromTo four five\<oplus> AllowPortFromTo eight nine 995 \<oplus> AllowPortFromTo five seven 253 \<oplus> AllowPortFromTo three two 503 \<oplus> DenyAllFromTo seven five\<oplus> AllowPortFromTo four ten 500 \<oplus> AllowPortFromTo two three 208 \<oplus> AllowPortFromTo seven six 773 \<oplus> DenyAllFromTo four two\<oplus> AllowPortFromTo two seven 510 \<oplus> AllowPortFromTo ten seven 81 \<oplus> AllowPortFromTo ten eight 78 \<oplus> AllowPortFromTo ten one 909 \<oplus> AllowPortFromTo six seven 129 \<oplus> AllowPortFromTo three four 71 \<oplus> AllowPortFromTo ten five 49 \<oplus> AllowPortFromTo three eight 673 \<oplus> AllowPortFromTo eight four 312 \<oplus> AllowPortFromTo ten one 512 \<oplus> AllowPortFromTo six one 867 \<oplus> AllowPortFromTo two eight 623 \<oplus> AllowPortFromTo eight four 798 \<oplus> AllowPortFromTo ten five 798 \<oplus> AllowPortFromTo six eight 433 \<oplus> AllowPortFromTo six two 50 \<oplus> DenyAllFromTo nine six\<oplus> AllowPortFromTo two eight 875 \<oplus> AllowPortFromTo five six 900 \<oplus> AllowPortFromTo ten seven 650 \<oplus> AllowPortFromTo five one 488 \<oplus> DenyAllFromTo nine two\<oplus> DenyAllFromTo eight two\<oplus> AllowPortFromTo six seven 171 \<oplus> AllowPortFromTo eight three 202 \<oplus> AllowPortFromTo five six 737 \<oplus> AllowPortFromTo six two 870 \<oplus> AllowPortFromTo six seven 721 \<oplus> AllowPortFromTo seven two 952 \<oplus> AllowPortFromTo three six 210 \<oplus> AllowPortFromTo seven ten 350 \<oplus> AllowPortFromTo two nine 853 \<oplus> AllowPortFromTo one ten 279 \<oplus> AllowPortFromTo four eight 89 \<oplus> AllowPortFromTo five ten 755 \<oplus> AllowPortFromTo six seven 448 \<oplus> AllowPortFromTo six seven 335 \<oplus> AllowPortFromTo nine six 150 \<oplus> AllowPortFromTo four one 86 \<oplus> DenyAllFromTo eight two\<oplus> DenyAllFromTo two five\<oplus> DenyAllFromTo three two\<oplus> AllowPortFromTo ten seven 102 \<oplus> AllowPortFromTo three nine 240 \<oplus> AllowPortFromTo five six 523 \<oplus> AllowPortFromTo nine six 148 \<oplus> AllowPortFromTo two one 436 \<oplus> AllowPortFromTo six five 288 \<oplus> AllowPortFromTo three seven 457 \<oplus> AllowPortFromTo four eight 902 \<oplus> DenyAllFromTo nine seven\<oplus> AllowPortFromTo three seven 71 \<oplus> AllowPortFromTo one seven 825 \<oplus> DenyAllFromTo five six\<oplus> DenyAllFromTo six seven\<oplus> AllowPortFromTo four eight 251 \<oplus> AllowPortFromTo nine seven 276 \<oplus> AllowPortFromTo four three 498 \<oplus> AllowPortFromTo one five 501 \<oplus> AllowPortFromTo six seven 581 \<oplus> DenyAllFromTo nine two\<oplus> DenyAllFromTo ten two\<oplus> DenyAllFromTo nine one\<oplus> AllowPortFromTo six eight 893 \<oplus> AllowPortFromTo ten four 328 \<oplus> AllowPortFromTo eight one 361 \<oplus> AllowPortFromTo seven five 147 \<oplus> AllowPortFromTo five ten 42 \<oplus> AllowPortFromTo four one 339 \<oplus> DenyAllFromTo eight ten\<oplus> DenyAllFromTo three ten\<oplus> AllowPortFromTo ten seven 166 \<oplus> AllowPortFromTo six seven 233 \<oplus> AllowPortFromTo six four 613 \<oplus> AllowPortFromTo nine eight 422 \<oplus> AllowPortFromTo one three 500 \<oplus> AllowPortFromTo five two 814 \<oplus> AllowPortFromTo five nine 243 \<oplus> AllowPortFromTo four five 633 \<oplus> AllowPortFromTo five six 882 \<oplus> DenyAllFromTo two seven\<oplus> DenyAllFromTo two four\<oplus> AllowPortFromTo three one 722 \<oplus> AllowPortFromTo nine three 702 \<oplus> AllowPortFromTo three ten 668 \<oplus> DenyAllFromTo eight four\<oplus> AllowPortFromTo ten two 866 \<oplus> AllowPortFromTo five two 95 \<oplus> AllowPortFromTo six two 888 \<oplus> DenyAllFromTo one ten\<oplus> AllowPortFromTo seven four 665 \<oplus> AllowPortFromTo three one 774 \<oplus> DenyAllFromTo four five\<oplus> AllowPortFromTo six ten 181 \<oplus> AllowPortFromTo nine three 247 \<oplus> AllowPortFromTo one eight 241 \<oplus> AllowPortFromTo eight four 473 \<oplus> AllowPortFromTo two one 57 \<oplus> DenyAllFromTo nine six\<oplus> AllowPortFromTo seven five 709 \<oplus> AllowPortFromTo ten one 43 \<oplus> AllowPortFromTo four eight 244 \<oplus> AllowPortFromTo eight three 965 \<oplus> AllowPortFromTo nine six 210 \<oplus> AllowPortFromTo four eight 83 \<oplus> AllowPortFromTo two four 555 \<oplus> AllowPortFromTo six eight 683 \<oplus> AllowPortFromTo eight four 197 \<oplus> AllowPortFromTo five ten 702 \<oplus> AllowPortFromTo ten nine 328 \<oplus> AllowPortFromTo ten five 861 \<oplus> DenyAllFromTo one ten\<oplus> AllowPortFromTo ten six 94 \<oplus> AllowPortFromTo seven three 149 \<oplus> AllowPortFromTo three one 429 \<oplus> AllowPortFromTo two three 951 \<oplus> AllowPortFromTo four nine 721 \<oplus> AllowPortFromTo five one 738 \<oplus> AllowPortFromTo five one 850 \<oplus> AllowPortFromTo eight six 623 \<oplus> DenyAllFromTo eight six\<oplus> AllowPortFromTo six ten 653 \<oplus> AllowPortFromTo one eight 731 \<oplus> AllowPortFromTo six three 89 \<oplus> AllowPortFromTo seven three 486 \<oplus> AllowPortFromTo three one 945 \<oplus> DenyAllFromTo one seven\<oplus> DenyAllFromTo eight three\<oplus> AllowPortFromTo ten six 827 \<oplus> AllowPortFromTo four five 910 \<oplus> AllowPortFromTo six four 540 \<oplus> DenyAllFromTo three two\<oplus> AllowPortFromTo eight four 40 \<oplus> AllowPortFromTo four ten 363 \<oplus> AllowPortFromTo one two 613 \<oplus> AllowPortFromTo nine one 325 \<oplus> AllowPortFromTo six five 378 \<oplus> AllowPortFromTo eight six 579 \<oplus> AllowPortFromTo ten eight 49 \<oplus> AllowPortFromTo ten one 799 \<oplus> AllowPortFromTo ten seven 43 \<oplus> AllowPortFromTo five eight 440 \<oplus> AllowPortFromTo seven one 881 \<oplus> AllowPortFromTo four eight 812 \<oplus> DenyAllFromTo three six\<oplus> AllowPortFromTo one three 803 \<oplus> AllowPortFromTo one four 87 \<oplus> DenyAllFromTo six five\<oplus> AllowPortFromTo nine two 475 \<oplus> AllowPortFromTo seven three 320 \<oplus> DenyAllFromTo five two\<oplus> AllowPortFromTo seven two 163 \<oplus> AllowPortFromTo eight three 124 \<oplus> AllowPortFromTo ten five 489 \<oplus> DenyAllFromTo one four\<oplus> AllowPortFromTo two seven 444 \<oplus> AllowPortFromTo three nine 908 \<oplus> AllowPortFromTo one seven 870 \<oplus> AllowPortFromTo eight seven 759 \<oplus> AllowPortFromTo ten four 118 \<oplus> AllowPortFromTo five four 273 \<oplus> AllowPortFromTo nine one 98 \<oplus> AllowPortFromTo ten one 986 \<oplus> AllowPortFromTo four five 321 \<oplus> AllowPortFromTo four six 415 \<oplus> AllowPortFromTo ten seven 697 \<oplus> AllowPortFromTo nine eight 3 \<oplus> DenyAllFromTo six ten\<oplus> AllowPortFromTo three four 979 \<oplus> AllowPortFromTo two nine 726 \<oplus> AllowPortFromTo eight six 932 \<oplus> DenyAllFromTo seven four\<oplus> AllowPortFromTo one three 464 \<oplus> AllowPortFromTo three seven 84 \<oplus> AllowPortFromTo eight six 345 \<oplus> AllowPortFromTo five two 190 \<oplus> AllowPortFromTo six two 416 \<oplus> AllowPortFromTo nine five 360 \<oplus> AllowPortFromTo one eight 458 \<oplus> AllowPortFromTo one two 394 \<oplus> AllowPortFromTo eight nine 617 \<oplus> AllowPortFromTo ten three 48 \<oplus> AllowPortFromTo seven ten 974 \<oplus> AllowPortFromTo four one 77 \<oplus> AllowPortFromTo four three 693 \<oplus> AllowPortFromTo two one 9 \<oplus> AllowPortFromTo ten four 231 \<oplus> AllowPortFromTo one three 796 \<oplus> DenyAllFromTo one three\<oplus> AllowPortFromTo six five 292 \<oplus> AllowPortFromTo three seven 557 \<oplus> AllowPortFromTo six ten 133 \<oplus> AllowPortFromTo four three 949 \<oplus> AllowPortFromTo eight four 878 \<oplus> AllowPortFromTo two seven 671 \<oplus> AllowPortFromTo six nine 834 \<oplus> AllowPortFromTo four two 993 \<oplus> AllowPortFromTo five eight 724 \<oplus> AllowPortFromTo six seven 871 \<oplus> AllowPortFromTo eight nine 227 \<oplus> AllowPortFromTo three four 805 \<oplus> DenyAllFromTo nine four\<oplus> AllowPortFromTo seven two 699 \<oplus> DenyAllFromTo eight nine\<oplus> DenyAllFromTo ten three\<oplus> DenyAllFromTo nine ten\<oplus> DenyAllFromTo nine seven\<oplus> AllowPortFromTo four six 636 \<oplus> AllowPortFromTo three two 110 \<oplus> DenyAllFromTo two ten\<oplus> AllowPortFromTo nine ten 328 \<oplus> DenyAllFromTo four one\<oplus> AllowPortFromTo five one 524 \<oplus> AllowPortFromTo six eight 807 \<oplus> AllowPortFromTo three one 772 \<oplus> AllowPortFromTo six one 183 \<oplus> AllowPortFromTo three two 749 \<oplus> AllowPortFromTo three seven 638 \<oplus> AllowPortFromTo nine two 249 \<oplus> AllowPortFromTo four eight 775 \<oplus> AllowPortFromTo one four 247 \<oplus> AllowPortFromTo seven three 305 \<oplus> DenyAllFromTo five three\<oplus> AllowPortFromTo four five 729 \<oplus> AllowPortFromTo one five 954 \<oplus> DenyAllFromTo nine one\<oplus> AllowPortFromTo three one 892 \<oplus> AllowPortFromTo five seven 432 \<oplus> AllowPortFromTo five one 904 \<oplus> AllowPortFromTo three one 730 \<oplus> DenyAllFromTo nine ten\<oplus> AllowPortFromTo seven four 296 \<oplus> AllowPortFromTo five nine 388 \<oplus> AllowPortFromTo eight one 557 \<oplus> AllowPortFromTo two one 429 \<oplus> DenyAllFromTo five eight\<oplus> AllowPortFromTo one ten 151 \<oplus> AllowPortFromTo five nine 997 \<oplus> DenyAllFromTo two seven\<oplus> AllowPortFromTo one two 1 \<oplus> AllowPortFromTo five nine 98 \<oplus> AllowPortFromTo six nine 74 \<oplus> AllowPortFromTo four nine 39 \<oplus> AllowPortFromTo ten four 885 \<oplus> AllowPortFromTo nine four 689 \<oplus> DenyAllFromTo four one\<oplus> AllowPortFromTo five seven 713 \<oplus> AllowPortFromTo five six 303 \<oplus> AllowPortFromTo nine five 124 \<oplus> AllowPortFromTo three six 207 \<oplus> AllowPortFromTo four three 738 \<oplus> AllowPortFromTo one six 429 \<oplus> AllowPortFromTo eight six 632 \<oplus> AllowPortFromTo eight three 48 \<oplus> AllowPortFromTo four one 317 \<oplus> AllowPortFromTo six nine 734 \<oplus> AllowPortFromTo ten four 769 \<oplus> AllowPortFromTo seven one 299 \<oplus> AllowPortFromTo ten four 744 \<oplus> AllowPortFromTo six one 944 \<oplus> AllowPortFromTo one four 62 \<oplus> AllowPortFromTo six two 414 \<oplus> AllowPortFromTo one seven 811 \<oplus> DenyAllFromTo seven nine\<oplus> AllowPortFromTo five eight 468 \<oplus> AllowPortFromTo six two 624 \<oplus> AllowPortFromTo five three 902 \<oplus> AllowPortFromTo three one 315 \<oplus> AllowPortFromTo five two 173 \<oplus> AllowPortFromTo six ten 504 \<oplus> DenyAllFromTo six three\<oplus> AllowPortFromTo three nine 491 \<oplus> AllowPortFromTo eight nine 247 \<oplus> AllowPortFromTo two ten 678 \<oplus> AllowPortFromTo ten six 348 \<oplus> AllowPortFromTo four two 655 \<oplus> DenyAllFromTo four six\<oplus> AllowPortFromTo ten nine 759 \<oplus> DenyAllFromTo four six\<oplus> AllowPortFromTo five eight 113 \<oplus> AllowPortFromTo eight three 270 \<oplus> AllowPortFromTo four one 328 \<oplus> AllowPortFromTo ten nine 243 \<oplus> AllowPortFromTo two one 302 \<oplus> DenyAllFromTo five six\<oplus> AllowPortFromTo five six 555 \<oplus> AllowPortFromTo four nine 287

"

(*300  rules, 25  networks, 20% *)
definition Policy12 :: "(adr\<^isub>i\<^isub>p net, port) Combinators" where
"Policy12 =
DenyAll \<oplus>  AllowPortFromTo twenty fifteen 164 \<oplus> AllowPortFromTo five twenty 363 \<oplus> AllowPortFromTo three four 783 \<oplus> AllowPortFromTo ten seventeen 247 \<oplus> AllowPortFromTo thirteen twentyfour 926 \<oplus> AllowPortFromTo thirteen twentythree 971 \<oplus> DenyAllFromTo twentyfive twentythree\<oplus> DenyAllFromTo two one\<oplus> AllowPortFromTo five seventeen 408 \<oplus> AllowPortFromTo seven twentyfour 558 \<oplus> AllowPortFromTo twentyone fourteen 227 \<oplus> AllowPortFromTo twentyone thirteen 876 \<oplus> AllowPortFromTo twentythree nineteen 677 \<oplus> AllowPortFromTo fifteen fourteen 95 \<oplus> AllowPortFromTo eight twelve 128 \<oplus> AllowPortFromTo nineteen twelve 431 \<oplus> AllowPortFromTo seventeen twentyfive 330 \<oplus> AllowPortFromTo twentyone twelve 334 \<oplus> AllowPortFromTo ten six 2 \<oplus> AllowPortFromTo six four 881 \<oplus> AllowPortFromTo eight two 10 \<oplus> AllowPortFromTo ten six 981 \<oplus> DenyAllFromTo twentythree one\<oplus> DenyAllFromTo six eighteen\<oplus> AllowPortFromTo one nine 432 \<oplus> AllowPortFromTo twenty ten 891 \<oplus> AllowPortFromTo eighteen six 318 \<oplus> AllowPortFromTo eleven two 651 \<oplus> AllowPortFromTo eleven four 815 \<oplus> DenyAllFromTo three six\<oplus> AllowPortFromTo nine fifteen 449 \<oplus> AllowPortFromTo three fourteen 43 \<oplus> AllowPortFromTo twentyfive nineteen 759 \<oplus> AllowPortFromTo nineteen nine 887 \<oplus> AllowPortFromTo five sixteen 831 \<oplus> AllowPortFromTo nineteen twentyfive 603 \<oplus> DenyAllFromTo one ten\<oplus> AllowPortFromTo five eighteen 340 \<oplus> AllowPortFromTo twentytwo seven 829 \<oplus> AllowPortFromTo three sixteen 658 \<oplus> DenyAllFromTo fourteen twelve\<oplus> AllowPortFromTo two twelve 934 \<oplus> DenyAllFromTo twentyfour twentytwo\<oplus> AllowPortFromTo ten twentyfour 964 \<oplus> AllowPortFromTo eighteen twentythree 258 \<oplus> AllowPortFromTo fifteen two 85 \<oplus> AllowPortFromTo twelve eighteen 755 \<oplus> AllowPortFromTo eight ten 676 \<oplus> AllowPortFromTo twenty twentyone 221 \<oplus> DenyAllFromTo six eight\<oplus> AllowPortFromTo nine twentyone 940 \<oplus> AllowPortFromTo ten thirteen 982 \<oplus> AllowPortFromTo thirteen five 420 \<oplus> AllowPortFromTo twentythree seventeen 362 \<oplus> AllowPortFromTo eleven nine 579 \<oplus> DenyAllFromTo five three\<oplus> AllowPortFromTo twentyfive fifteen 634 \<oplus> AllowPortFromTo fifteen twentythree 645 \<oplus> AllowPortFromTo two fourteen 600 \<oplus> AllowPortFromTo eleven two 666 \<oplus> AllowPortFromTo twenty twentyfour 805 \<oplus> DenyAllFromTo twentyfive eleven\<oplus> AllowPortFromTo three twentyfive 219 \<oplus> AllowPortFromTo two twentythree 454 \<oplus> AllowPortFromTo three twentythree 310 \<oplus> AllowPortFromTo eight twentyone 229 \<oplus> DenyAllFromTo thirteen six\<oplus> AllowPortFromTo twentyone fifteen 29 \<oplus> DenyAllFromTo seven twentythree\<oplus> AllowPortFromTo twentyfour four 371 \<oplus> AllowPortFromTo seven twentyfour 886 \<oplus> AllowPortFromTo fifteen ten 428 \<oplus> AllowPortFromTo twentyone ten 745 \<oplus> DenyAllFromTo nineteen thirteen\<oplus> AllowPortFromTo one twentyfour 755 \<oplus> AllowPortFromTo ten eighteen 183 \<oplus> AllowPortFromTo two eight 339 \<oplus> DenyAllFromTo twentytwo nineteen\<oplus> AllowPortFromTo three ten 771 \<oplus> AllowPortFromTo three nineteen 709 \<oplus> AllowPortFromTo eleven twentyfour 487 \<oplus> AllowPortFromTo five sixteen 27 \<oplus> DenyAllFromTo twentythree six\<oplus> DenyAllFromTo three eleven\<oplus> AllowPortFromTo twenty seven 224 \<oplus> AllowPortFromTo four fourteen 23 \<oplus> AllowPortFromTo sixteen two 462 \<oplus> AllowPortFromTo twentythree eighteen 762 \<oplus> AllowPortFromTo ten twentythree 269 \<oplus> DenyAllFromTo fourteen seventeen\<oplus> DenyAllFromTo nineteen nine\<oplus> AllowPortFromTo ten twentythree 313 \<oplus> AllowPortFromTo fourteen eleven 927 \<oplus> DenyAllFromTo eight twelve\<oplus> AllowPortFromTo thirteen nine 736 \<oplus> AllowPortFromTo fifteen eleven 610 \<oplus> AllowPortFromTo fifteen five 675 \<oplus> AllowPortFromTo twelve nine 481 \<oplus> AllowPortFromTo twentyfour twentyone 651 \<oplus> AllowPortFromTo seventeen twentyfour 830 \<oplus> DenyAllFromTo sixteen twentyfour\<oplus> DenyAllFromTo eight twentyfour\<oplus> AllowPortFromTo fourteen twentyfour 361 \<oplus> AllowPortFromTo fifteen twentyfive 118 \<oplus> AllowPortFromTo fourteen nineteen 757 \<oplus> AllowPortFromTo nineteen eighteen 455 \<oplus> AllowPortFromTo twelve three 97 \<oplus> AllowPortFromTo twelve nine 77 \<oplus> AllowPortFromTo twentyfive thirteen 749 \<oplus> DenyAllFromTo ten twenty\<oplus> AllowPortFromTo thirteen eight 732 \<oplus> AllowPortFromTo three eight 718 \<oplus> AllowPortFromTo twelve seventeen 266 \<oplus> DenyAllFromTo five fourteen\<oplus> AllowPortFromTo five eleven 1 \<oplus> AllowPortFromTo three twentythree 401 \<oplus> AllowPortFromTo twentythree sixteen 281 \<oplus> AllowPortFromTo thirteen eleven 400 \<oplus> AllowPortFromTo five fourteen 115 \<oplus> DenyAllFromTo one six\<oplus> AllowPortFromTo twentyfour thirteen 101 \<oplus> AllowPortFromTo seventeen twentyone 585 \<oplus> AllowPortFromTo thirteen eleven 488 \<oplus> DenyAllFromTo twentythree thirteen\<oplus> AllowPortFromTo thirteen five 797 \<oplus> AllowPortFromTo twentytwo eighteen 43 \<oplus> AllowPortFromTo nineteen seven 963 \<oplus> AllowPortFromTo fifteen twentyfive 75 \<oplus> AllowPortFromTo seven twelve 688 \<oplus> AllowPortFromTo three fifteen 858 \<oplus> DenyAllFromTo seventeen twentythree\<oplus> AllowPortFromTo four nine 568 \<oplus> AllowPortFromTo eight eleven 550 \<oplus> AllowPortFromTo eight eleven 455 \<oplus> AllowPortFromTo five fifteen 313 \<oplus> AllowPortFromTo three fourteen 237 \<oplus> AllowPortFromTo two five 297 \<oplus> AllowPortFromTo twenty nine 291 \<oplus> AllowPortFromTo four twentyfour 318 \<oplus> AllowPortFromTo nineteen five 924 \<oplus> DenyAllFromTo twelve ten\<oplus> AllowPortFromTo twelve five 141 \<oplus> AllowPortFromTo three eighteen 59 \<oplus> AllowPortFromTo six eleven 706 \<oplus> AllowPortFromTo two fifteen 834 \<oplus> AllowPortFromTo seventeen nineteen 465 \<oplus> AllowPortFromTo twelve one 421 \<oplus> AllowPortFromTo five fifteen 956 \<oplus> AllowPortFromTo ten twentytwo 727 \<oplus> AllowPortFromTo twentyone three 813 \<oplus> AllowPortFromTo eighteen twentyfour 884 \<oplus> AllowPortFromTo sixteen twentyone 914 \<oplus> AllowPortFromTo fourteen two 833 \<oplus> AllowPortFromTo twelve eight 436 \<oplus> AllowPortFromTo twelve eight 242 \<oplus> DenyAllFromTo twenty seven\<oplus> AllowPortFromTo nine thirteen 289 \<oplus> DenyAllFromTo five eighteen\<oplus> AllowPortFromTo twentythree thirteen 383 \<oplus> AllowPortFromTo twentythree eighteen 176 \<oplus> AllowPortFromTo nine twentyone 455 \<oplus> AllowPortFromTo thirteen fourteen 265 \<oplus> AllowPortFromTo twelve sixteen 851 \<oplus> DenyAllFromTo twentyfour four\<oplus> AllowPortFromTo ten seven 454 \<oplus> DenyAllFromTo one fifteen\<oplus> AllowPortFromTo sixteen twentythree 380 \<oplus> AllowPortFromTo eleven six 135 \<oplus> AllowPortFromTo ten nine 723 \<oplus> DenyAllFromTo thirteen eighteen\<oplus> DenyAllFromTo sixteen seventeen\<oplus> AllowPortFromTo nine twentyone 834 \<oplus> AllowPortFromTo three twentyone 186 \<oplus> DenyAllFromTo eighteen seven\<oplus> AllowPortFromTo twentyfive twentyone 607 \<oplus> AllowPortFromTo fourteen five 602 \<oplus> AllowPortFromTo twentyfive three 458 \<oplus> AllowPortFromTo twentythree ten 67 \<oplus> AllowPortFromTo twentyone ten 736 \<oplus> AllowPortFromTo twentytwo ten 282 \<oplus> AllowPortFromTo nineteen sixteen 971 \<oplus> AllowPortFromTo twentyone four 473 \<oplus> DenyAllFromTo two twentyfive\<oplus> AllowPortFromTo three eighteen 811 \<oplus> AllowPortFromTo twenty four 701 \<oplus> AllowPortFromTo twentyfour thirteen 344 \<oplus> AllowPortFromTo eleven three 199 \<oplus> DenyAllFromTo one three\<oplus> AllowPortFromTo sixteen fourteen 206 \<oplus> AllowPortFromTo twentythree five 610 \<oplus> DenyAllFromTo five seven\<oplus> AllowPortFromTo sixteen twentythree 835 \<oplus> AllowPortFromTo ten eight 609 \<oplus> DenyAllFromTo twentyfour twenty\<oplus> AllowPortFromTo six fifteen 848 \<oplus> AllowPortFromTo twenty one 942 \<oplus> DenyAllFromTo twentytwo five\<oplus> DenyAllFromTo ten twentyone\<oplus> AllowPortFromTo fourteen eleven 493 \<oplus> AllowPortFromTo twentyfive ten 400 \<oplus> AllowPortFromTo sixteen three 610 \<oplus> AllowPortFromTo five twelve 273 \<oplus> AllowPortFromTo nine nineteen 358 \<oplus> AllowPortFromTo eight fifteen 134 \<oplus> AllowPortFromTo two ten 511 \<oplus> AllowPortFromTo six ten 745 \<oplus> DenyAllFromTo nineteen ten\<oplus> DenyAllFromTo seven nineteen\<oplus> AllowPortFromTo twentyone nineteen 653 \<oplus> DenyAllFromTo four eight\<oplus> AllowPortFromTo four nine 206 \<oplus> DenyAllFromTo eight eighteen\<oplus> DenyAllFromTo two twentytwo\<oplus> AllowPortFromTo twenty five 681 \<oplus> AllowPortFromTo ten twentyfour 240 \<oplus> DenyAllFromTo seventeen nine\<oplus> AllowPortFromTo twentytwo two 619 \<oplus> AllowPortFromTo eighteen three 772 \<oplus> DenyAllFromTo fifteen fourteen\<oplus> AllowPortFromTo twentythree fifteen 444 \<oplus> AllowPortFromTo three four 59 \<oplus> DenyAllFromTo twentyfive twenty\<oplus> DenyAllFromTo twentythree four\<oplus> AllowPortFromTo fourteen seventeen 742 \<oplus> AllowPortFromTo two fourteen 406 \<oplus> AllowPortFromTo one nine 294 \<oplus> DenyAllFromTo fifteen twenty\<oplus> DenyAllFromTo twelve seven\<oplus> AllowPortFromTo two eighteen 821 \<oplus> AllowPortFromTo sixteen twenty 628 \<oplus> AllowPortFromTo thirteen twentyone 332 \<oplus> DenyAllFromTo fifteen twentyone\<oplus> AllowPortFromTo twelve four 908 \<oplus> AllowPortFromTo nine seventeen 792 \<oplus> AllowPortFromTo ten twenty 325 \<oplus> AllowPortFromTo seventeen one 604 \<oplus> AllowPortFromTo one twentyfive 53 \<oplus> AllowPortFromTo two one 352 \<oplus> AllowPortFromTo sixteen twentyone 582 \<oplus> AllowPortFromTo four thirteen 520 \<oplus> AllowPortFromTo fourteen eighteen 534 \<oplus> AllowPortFromTo eight two 93 \<oplus> AllowPortFromTo twentyfive nine 543 \<oplus> DenyAllFromTo twentyone fifteen\<oplus> AllowPortFromTo thirteen two 704 \<oplus> AllowPortFromTo ten twentythree 909 \<oplus> AllowPortFromTo thirteen nineteen 134 \<oplus> AllowPortFromTo twentyfour fourteen 649 \<oplus> AllowPortFromTo thirteen six 728 \<oplus> AllowPortFromTo seven two 37 \<oplus> DenyAllFromTo two four\<oplus> DenyAllFromTo twenty fourteen\<oplus> AllowPortFromTo twentytwo one 119 \<oplus> AllowPortFromTo fifteen twentyfour 106 \<oplus> AllowPortFromTo fifteen four 828 \<oplus> DenyAllFromTo fifteen nine\<oplus> AllowPortFromTo twelve twentyfour 920 \<oplus> DenyAllFromTo eleven twenty\<oplus> AllowPortFromTo sixteen twentyfive 458 \<oplus> AllowPortFromTo one twentyfour 742 \<oplus> AllowPortFromTo twentyfive fourteen 73 \<oplus> AllowPortFromTo five twelve 404 \<oplus> AllowPortFromTo twentytwo twenty 352 \<oplus> DenyAllFromTo eight twentyfive\<oplus> AllowPortFromTo twentytwo sixteen 393 \<oplus> AllowPortFromTo four twentyone 727 \<oplus> AllowPortFromTo nineteen twenty 864 \<oplus> AllowPortFromTo sixteen six 809 \<oplus> AllowPortFromTo fifteen one 749 \<oplus> AllowPortFromTo nine twenty 480 \<oplus> AllowPortFromTo twentyfour nineteen 682 \<oplus> DenyAllFromTo four twentytwo\<oplus> AllowPortFromTo nine twentyfour 951 \<oplus> AllowPortFromTo twentyone thirteen 673 \<oplus> AllowPortFromTo one sixteen 385 \<oplus> AllowPortFromTo four twentyone 263 \<oplus> AllowPortFromTo eleven nine 561 \<oplus> AllowPortFromTo fifteen two 416 \<oplus> DenyAllFromTo twentytwo five\<oplus> DenyAllFromTo eighteen three\<oplus> AllowPortFromTo twentyfive three 673 \<oplus> AllowPortFromTo three eighteen 292 \<oplus> AllowPortFromTo eight nineteen 468 \<oplus> AllowPortFromTo five seven 562 \<oplus> AllowPortFromTo fourteen nine 651 \<oplus> AllowPortFromTo four one 733 \<oplus> AllowPortFromTo eighteen seven 577 \<oplus> DenyAllFromTo nine twentyfive\<oplus> AllowPortFromTo thirteen two 669 \<oplus> DenyAllFromTo seven three\<oplus> AllowPortFromTo thirteen eleven 132 \<oplus> AllowPortFromTo ten nine 484 \<oplus> DenyAllFromTo twentyone fourteen\<oplus> AllowPortFromTo nine ten 240 \<oplus> AllowPortFromTo seven ten 412 \<oplus> AllowPortFromTo twelve five 804 \<oplus> DenyAllFromTo eight three\<oplus> AllowPortFromTo twentythree eighteen 998 \<oplus> AllowPortFromTo two twentyfive 444 \<oplus> AllowPortFromTo one fifteen 699"




lemmas policies =  Policy1_def Policy2_def Policy3_def Policy4_def Policy5_def Policy6_def Policy7_def Policy8_def Policy9_def Policy10_def Policy11_def Policy12_def  

lemmas UnfoldNetworkAndPolicy = UnfoldPolicy PLemmas policies adr\<^isub>i\<^isub>pLemmas


lemma xNotMT: "\<lbrakk>singleCombinators [x]; srcNet x = {{(a::int,b). a = Nn}}; 
destNet x = {{(a::int,b). a = M}}\<rbrakk> \<Longrightarrow> dom (C x) \<noteq> {}"
apply (case_tac x)
apply (simp_all add: PLemmas)
done

lemma xNotSC[rule_format]: "x \<in> set (policy2list P) \<longrightarrow> singleCombinators[x]"
apply (induct_tac P)
apply simp_all
done

lemma noMTP: "\<forall> x \<in> set (policy2list P). srcNet x = {{(a::int,b). a = Nn}} \<and>  destNet x = {{(a::int,b). a = M}} \<Longrightarrow> 
        \<forall> x \<in> set (policy2list P). dom (C x) \<noteq> {}"
apply (simp add: xNotSC xNotMT)
done

lemma DAnMT[simp]: "dom (C DenyAll) \<noteq> {}"
apply (simp add: PLemmas)
done


lemma noMT21: "\<forall> x \<in> set (policy2list Policy1). dom (C x) \<noteq> {}"
apply (simp add: policies)
apply (simp add: xNotMT UnfoldPolicy)
done
lemma noMT22: "\<forall> x \<in> set (policy2list Policy2). dom (C x) \<noteq> {}"
apply (simp add: policies)
apply (simp add: xNotMT UnfoldPolicy)
done

lemma noMT23: "\<forall> x \<in> set (policy2list Policy3). dom (C x) \<noteq> {}"
apply (simp add: policies)
apply (simp add: xNotMT UnfoldPolicy)
done
lemma noMT24: "\<forall> x \<in> set (policy2list Policy4). dom (C x) \<noteq> {}"
apply (simp add: policies)
apply (simp add: xNotMT UnfoldPolicy)
done
lemma noMT25: "\<forall> x \<in> set (policy2list Policy5). dom (C x) \<noteq> {}"
apply (simp add: policies)
apply (simp add: xNotMT UnfoldPolicy)
done
lemma noMT26: "\<forall> x \<in> set (policy2list Policy6). dom (C x) \<noteq> {}"
apply (simp add: policies)
apply (simp add: xNotMT UnfoldPolicy)
done
lemma noMT27: "\<forall> x \<in> set (policy2list Policy7). dom (C x) \<noteq> {}"
apply (simp add: policies)
apply (simp add: xNotMT UnfoldPolicy)
done


lemma noMT28: "\<forall> x \<in> set (policy2list Policy8). dom (C x) \<noteq> {}"
apply (simp add: policies)
apply (simp add: xNotMT UnfoldPolicy)
done

lemma noMT29: "\<forall> x \<in> set (policy2list Policy9). dom (C x) \<noteq> {}"
apply (simp add: policies)
apply (simp add: xNotMT UnfoldPolicy)
done

lemma noMT210: "\<forall> x \<in> set (policy2list Policy10). dom (C x) \<noteq> {}"
apply (simp add: policies)
apply (simp add: xNotMT UnfoldPolicy)
done

lemma noMT211: "\<forall> x \<in> set (policy2list Policy11). dom (C x) \<noteq> {}"
apply (simp add: policies)
apply (simp add: xNotMT UnfoldPolicy)
done

lemma noMT212: "\<forall> x \<in> set (policy2list Policy12). dom (C x) \<noteq> {}"
apply (simp add: policies)
apply (simp add: xNotMT UnfoldPolicy)
done


lemmas noMT2 = noMT21 noMT22 noMT23 noMT24 noMT25 noMT26 noMT27 noMT28 noMT29 noMT210 noMT211 noMT212 

(* THE FOLLOWING UNCOMMENTED LEMMAS ARE JUST FOR INSPECTION OF THE NORMALISED POLICIES AND NOT NEEDED 


lemma normalizeQ: "numberOfRulesList(normalizeQ Policy1) = X"
apply (insert nets_different noMT21)
apply (simp add: normalizeQ_def policies bothNets_def aux aux2 Nets_List_def)
apply( thin_tac "?X",thin_tac "?S")
oops



1, 4, 6, 4, 4, 4, 4, 4, 7, 7, 7


lemma normalizeQ: "numberOfRulesList(normalizeQ Policy2) = X"
apply (insert nets_different noMT22)
apply (simp add: normalizeQ_def policies bothNets_def aux aux2 Nets_List_def, thin_tac "?X",thin_tac "?S")
oops

(*
1, 3, 3, 3, 2, 3, 3, 3, 3, 5, 3, 4, 3, 3, 3, 4, 4, 3, 3, 3, 3, 3, 6, 4, 3, 5, 2, 3, 3, 3, 4, 4
*)

lemma normalizeQ: "numberOfRulesList(normalizeQ Policy3) = X"
apply (insert nets_different noMT23)
apply (simp add: normalizeQ_def policies bothNets_def aux aux2 Nets_List_def, thin_tac "?X",thin_tac "?S")
oops

(*
1, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 2, 3, 3, 3, 3, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 2, 3, 3, 2, 2, 2, 4, 3, 3, 3, 3, 4, 2, 3, 3, 3


*)
lemma normalizeQ: "numberOfRulesList(normalizeQ Policy4) = X"
apply (insert nets_different noMT24)
apply (simp add: normalizeQ_def policies bothNets_def aux aux2 Nets_List_def, thin_tac "?X",thin_tac "?S")
oops

(*
1, 4, 3, 5, 3, 15, 11, 4, 7, 11, 5

*)
lemma normalizeQ: "numberOfRulesList(normalizeQ Policy5) = X"
apply (insert nets_different noMT25)
apply (simp add: normalizeQ_def policies bothNets_def aux aux2 Nets_List_def, thin_tac "?X",thin_tac "?S")
oops

(*

1, 3, 3, 3, 3, 4, 3, 2, 5, 2, 2, 4, 5, 3, 3, 3, 4, 3, 3, 5, 2, 5, 6, 4, 5, 4, 3, 6, 3, 6, 6, 3, 3, 3, 4, 3, 7, 6, 5, 2, 4

*)
lemma normalizeQ: "numberOfRulesList(normalizeQ Policy6) = X"
apply (insert nets_different noMT26)
apply (simp add: normalizeQ_def policies bothNets_def aux aux2 Nets_List_def, thin_tac "?X",thin_tac "?S")
oops

(*
1, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 2, 3, 3, 3, 3, 4, 2, 2, 3, 3, 3, 2, 3, 3, 3, 4, 4, 3, 3, 3, 4, 3, 2, 3, 4, 3, 2, 3, 3, 4, 3, 3, 2, 4, 3, 3, 3, 3, 3, 2, 3, 3, 3, 3, 3, 3, 2, 3, 2, 2, 2, 3, 3, 2, 3, 3, 2, 3, 3, 3, 4, 3, 3, 2, 4, 3, 3, 4

*)
lemma normalizeQ: "numberOfRulesList(normalizeQ Policy7) = X"
apply (insert nets_different noMT27)
apply (simp add: normalizeQ_def policies bothNets_def aux aux2 Nets_List_def, thin_tac "?X",thin_tac "?S")
oops

(*

1, 12, 7, 8, 13, 12, 12, 4, 6, 10, 4

*)
lemma normalizeQ: "numberOfRulesList(normalizeQ Policy8) = X"
apply (insert nets_different noMT28)
apply (simp add: normalizeQ_def policies bothNets_def aux aux2 Nets_List_def, thin_tac "?X",thin_tac "?S")
oops

(*
1, 3, 4, 3, 5, 6, 4, 4, 7, 2, 4, 3, 3, 8, 2, 9, 7, 4, 5, 2, 6, 4, 5, 7, 4, 3, 5, 4, 2, 5, 5, 4, 4, 3, 5, 8, 6, 5, 3, 6, 6, 6, 8, 8, 9, 6

*)
lemma normalizeQ: "numberOfRulesList(normalizeQ Policy9) = X"
apply (insert nets_different noMT29)
apply (simp add: normalizeQ_def policies bothNets_def aux aux2 Nets_List_def, thin_tac "?X",thin_tac "?S")
oops

(*
1, 3, 3, 3, 3, 2, 3, 3, 3, 3, 3, 3, 2, 3, 3, 2, 3, 3, 2, 3, 4, 2, 3, 3, 2, 2, 3, 3, 4, 3, 3, 2, 3, 3, 3, 3, 3, 3, 2, 3, 2, 2, 2, 2, 4, 3, 3, 2, 3, 4, 4, 4, 3, 3, 3, 3, 2, 4, 2, 3, 3, 3, 4, 4, 3, 3, 3, 3, 2, 2, 3, 3, 3, 2, 3, 3, 3, 3, 3, 3, 2, 2, 4, 3, 2, 3, 2, 3, 3, 4, 2, 2, 3, 3, 3, 3, 3, 4, 3, 3, 4, 3, 4, 3, 3, 5, 3, 5, 3, 3, 3, 4, 2, 3, 3, 2, 3, 2, 3, 3, 2, 4, 2, 4, 3, 2, 4, 4, 3, 3, 4, 3, 4, 3, 4, 3, 3, 3, 4, 3, 4, 3, 3, 3, 4, 5, 3

*)

lemma normalizeQ: "numberOfRulesList(normalizeQ Policy10) = X"
apply (insert nets_different noMT210)
apply (simp add: normalizeQ_def policies bothNets_def aux aux2 Nets_List_def, thin_tac "?X",thin_tac "?S")
oops

(*
1, 6, 6, 9, 10, 13, 21, 8, 12, 21, 8

*)

lemma normalizeQ: "numberOfRulesList(normalizeQ Policy11) = X"
apply (insert nets_different noMT211)
apply (simp add: normalizeQ_def policies bothNets_def aux  aux2 Nets_List_def, thin_tac "?X",thin_tac "?S") 
oops

(*
1, 4, 4, 9, 3, 10, 6, 3, 6, 6, 13, 11, 6, 2, 9, 4, 7, 8, 6, 7, 8, 9, 10, 6, 10, 6, 6, 2, 8, 3, 10, 4, 3, 7, 5, 4, 7, 5, 4, 4, 6, 6, 5, 10, 4, 6

*)



lemma normalizeQ: "numberOfRulesList(normalizeQ Policy12) = X"
apply (insert nets_different noMT212)
apply (simp add: normalizeQ_def policies bothNets_def aux aux2 Nets_List_def, thin_tac "?X",thin_tac "?S")
oops



(*

1, 3, 2, 3, 3, 3, 3, 3, 3, 2, 3, 3, 2, 4, 2, 3, 2, 3, 2, 3, 3, 2, 3, 2, 4, 2, 3, 3, 2, 4, 3, 3, 2, 3, 3, 3, 4, 2, 3, 3, 3, 3, 3, 2, 2, 3, 3, 3, 4,
     3, 3, 3, 3, 4, 2, 3, 4, 3, 5, 3, 3, 4, 4, 3, 3, 2, 3, 3, 5, 3, 4, 2, 4, 2, 4, 3, 3, 3, 4, 2, 2, 5, 4, 3, 4, 4, 3, 3, 5, 3, 2, 3, 3, 5, 4, 3, 3, 3,
     4, 4, 3, 4, 3, 3, 3, 5, 2, 3, 3, 2, 4, 2, 4, 4, 3, 2, 4, 4, 2, 2, 3, 5, 4, 3, 3, 3, 3, 3, 3, 4, 3, 3, 3, 4, 3, 3, 5, 2, 6, 3, 4, 3, 3, 2, 2, 3, 3,
     3, 3, 3, 2, 3, 4, 3, 3, 2, 3, 3, 3, 4, 3, 2, 3, 5, 3, 5, 4, 5, 2, 5, 5, 3, 3, 3, 3, 3, 3, 4, 2, 5, 2, 5, 4, 6, 3, 6, 3, 4
*)

*)

lemma aND_aux: "c\<noteq>d \<Longrightarrow> ({(a, b). a = c} = {(a, b). a = d}) = False"
apply auto
done

lemma aND1: "allNetsDistinct (policy2list Policy1)"
apply (simp add: Policy1_def UnfoldPolicy netsDistinct nets_distinct_aux allNetsDistinct_def 
                  aND_aux)
apply (simp add: netsDistinct_def in_subnet_def)
apply auto
done

lemma aND2: "allNetsDistinct (policy2list Policy2)"
apply (simp add: Policy2_def allNetsDistinct_def nets_different)
apply (simp add: netsDistinct_def)
apply (auto simp: allNetsDistinct_def PLemmas UnfoldPolicy)
done

lemma aND3: "allNetsDistinct (policy2list Policy3)"
apply (simp add: Policy3_def allNetsDistinct_def nets_different)
apply (simp add: netsDistinct_def)
apply (auto simp: allNetsDistinct_def PLemmas UnfoldPolicy)
done

lemma aND4: "allNetsDistinct (policy2list Policy4)"
apply (simp add: Policy4_def allNetsDistinct_def nets_different)
apply (simp add: netsDistinct_def)
apply (auto simp: allNetsDistinct_def PLemmas UnfoldPolicy)
done

lemma aND5: "allNetsDistinct (policy2list Policy5)"
apply (simp add: Policy5_def allNetsDistinct_def nets_different)
apply (simp add: netsDistinct_def)
apply (auto simp: allNetsDistinct_def PLemmas UnfoldPolicy)
done

lemma aND6: "allNetsDistinct (policy2list Policy6)"
apply (simp add: Policy6_def allNetsDistinct_def nets_different)
apply (simp add: netsDistinct_def)
apply (auto simp: allNetsDistinct_def PLemmas UnfoldPolicy)
done

lemma aND7: "allNetsDistinct (policy2list Policy7)"
apply (simp add: Policy7_def allNetsDistinct_def nets_different)
apply (simp add: netsDistinct_def)
apply (auto simp: allNetsDistinct_def PLemmas UnfoldPolicy)
done

lemma aND8: "allNetsDistinct (policy2list Policy8)"
apply (simp add: Policy8_def allNetsDistinct_def nets_different)
apply (simp add: netsDistinct_def)
apply (auto simp: allNetsDistinct_def PLemmas UnfoldPolicy)
done

lemma aND9: "allNetsDistinct (policy2list Policy9)"
apply (simp add: Policy9_def allNetsDistinct_def nets_different)
apply (simp add: netsDistinct_def)
apply (auto simp: allNetsDistinct_def PLemmas UnfoldPolicy)
done

lemma aND10: "allNetsDistinct (policy2list Policy10)"
apply (simp add: Policy10_def allNetsDistinct_def nets_different)
apply (simp add: netsDistinct_def)
apply (auto simp: allNetsDistinct_def PLemmas UnfoldPolicy)
done

lemma aND11: "allNetsDistinct (policy2list Policy11)"
apply (simp add: Policy11_def allNetsDistinct_def nets_different)
apply (simp add: netsDistinct_def)
apply (auto simp: allNetsDistinct_def PLemmas UnfoldPolicy)
done

lemma aND12: "allNetsDistinct (policy2list Policy12)"
apply (simp add: Policy12_def allNetsDistinct_def nets_different)
apply (simp add: netsDistinct_def)
apply (auto simp: allNetsDistinct_def PLemmas UnfoldPolicy)
done

lemmas aND = aND1 aND2 aND3 aND4 aND5 aND6 aND7 aND8 aND9 aND10 aND11 aND12

lemma allow_aux[simp]: "((if dj = a then if dk = b \<and> ac = c then allow_all (a, (aa, b), (ab, ba), bb) else None else None) = None)
 = (dk = b \<and> ac = c \<longrightarrow> dj \<noteq> a)"
apply (simp add: PLemmas)
done

end
