#!/bin/sh

echo "
 
theory 
  fw_rules
imports
  FWTesting
begin

declare [[testgen_profiling]]

definition
  workstation::"IntegerPort net" where


  "workstation = \{\{\(a,b\) . \(a=3\) \}\}"

definition
  internet :: "IntegerPort net" where
  "internet = {{(a,b).  \<not> (a =3)}}"

definition
  not_in_same_net :: "(IntegerPort,DummyContent) packet \<Rightarrow> bool" where
  "not_in_same_net x  =  ((src x \<sqsubset> workstation \<longrightarrow> ( (dest x \<sqsubset> internet))) \<and> 
  (src x \<sqsubset> internet \<longrightarrow>  dest x \<sqsubset> workstation))"

definition
   policy_00 :: "(IntegerPort, DummyContent) FWPolicy" where
  "policy_00 = deny_all"


lemmas UnfoldPolicy =  src_def dest_def in_subnet_def IntegerPort.src_port_def 
                       IntegerPort.dest_port_def 
                       workstation_def internet_def policy_00_def 


test_spec "not_in_same_net x \<longrightarrow> FUT x = policy_00 x"
apply (prepare_fw_spec)
apply (simp add: UnfoldPolicy PortCombinators)
apply (gen_test_cases "FUT")
apply (simp_all add: not_in_same_net_def UnfoldPolicy)
store_test_thm "policy_00"

gen_test_data "policy_00"

" > fw-rules1

for i in 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36

do

$j = $i - 1

echo"

definition
   policy_$i :: "(IntegerPort, DummyContent) FWPolicy" where
  "policy_$i = policy_$j ++ allow_from_port_to ($i::port) workstation internet"

lemmas UnfoldPolicy = UnfoldPolicy policy_$i

test_spec "not_in_same_net x \<longrightarrow> FUT x = policy_$i x"
apply (prepare_fw_spec)
apply (simp add: UnfoldPolicy PortCombinators)
apply (gen_test_cases "FUT")
apply (simp_all add: not_in_same_net_def UnfoldPolicy)
store_test_thm "policy_$i"

gen_test_data "policy_$i"
" >> fw-rules1.thy

done

echo "

write_clocks "time_stats_rulesIntegerNetwork.tex"

declare [[testgen_profiling = false]]"

end
>> fw-rules1.thy