structure Scenario : sig
  type 'a equal
  val equal : 'a equal -> 'a -> 'a -> bool
  val eq : 'a equal -> 'a -> 'a -> bool
  datatype inta = Pls | Min | Bit0 of inta | Bit1 of inta |
    Number_of_int of inta
  val pred : inta -> inta
  val succ : inta -> inta
  val insert : 'a equal -> 'a -> ('a -> bool) -> 'a -> bool
  type 'a ord
  val less_eq : 'a ord -> 'a -> 'a -> bool
  val less : 'a ord -> 'a -> 'a -> bool
  type 'a preorder
  val ord_preorder : 'a preorder -> 'a ord
  type 'a order
  val preorder_order : 'a order -> 'a preorder
  type 'a bot
  val order_bot : 'a bot -> 'a order
  val bot : 'a bot -> 'a
  val bot_boola : bool
  val less_bool : bool -> bool -> bool
  val less_eq_bool : bool -> bool -> bool
  val ord_bool : bool ord
  val preorder_bool : bool preorder
  val order_bool : bool order
  val bot_bool : bool bot
  val bot_fun : 'b bot -> 'a -> 'b
  val set : 'a equal -> 'a list -> 'a -> bool
  val plus_int : inta -> inta -> inta
  val less_eq_int : inta -> inta -> bool
  val less_int : inta -> inta -> bool
  val upto : inta -> inta -> inta list
  val member : 'a -> ('a -> bool) -> bool
  val map_add : ('a -> 'b option) -> ('a -> 'b option) -> 'a -> 'b option
  val collect : ('a -> bool) -> 'a -> bool
  val equal_inta : inta -> inta -> bool
  val equal_int : inta equal
  datatype 'a decision = Allow of 'a | Deny of 'a
  type 'a adr
  val fst : 'a * 'b -> 'a
  val snd : 'a * 'b -> 'b
  val src : 'a adr -> inta * ('a * ('a * 'b)) -> 'a
  datatype protocol = Tcp | Udp
  datatype dummyContent = Data
  val dest : 'a adr -> inta * ('a * ('a * 'b)) -> 'a
  val adr_int : inta adr
  val adr_prod : 'a adr -> 'b adr -> ('a * 'b) adr
  datatype hosts = Host1 | Host2
  val equal_protocol : protocol -> protocol -> bool
  val deny_all : 'a -> unit decision option
  val equal_hosts : hosts -> hosts -> bool
  val host1a : hosts * (inta * protocol) -> bool
  val host2a : hosts * (inta * protocol) -> bool
  val allow_all : 'a -> unit decision option
  val adr_hosts : hosts adr
  val adr_protocol : protocol adr
  val dom_restrict :
    ('a -> bool) -> ('a -> 'b decision option) -> 'a -> 'b decision option
  val allow_from_to_port_prot_single :
    protocol ->
      inta ->
        (hosts * (inta * protocol) -> bool) ->
          (hosts * (inta * protocol) -> bool) ->
            inta *
              ((hosts * (inta * protocol)) *
                ((hosts * (inta * protocol)) * dummyContent)) ->
              unit decision option
  val allow_from_to_ports_prot_single :
    protocol ->
      (inta -> bool) ->
        (hosts * (inta * protocol) -> bool) ->
          (hosts * (inta * protocol) -> bool) ->
            inta *
              ((hosts * (inta * protocol)) *
                ((hosts * (inta * protocol)) * dummyContent)) ->
              unit decision option
  val testPolicy :
    inta *
      ((hosts * (inta * protocol)) *
        ((hosts * (inta * protocol)) * dummyContent)) ->
      unit decision option
end = struct

type 'a equal = {equal : 'a -> 'a -> bool};
val equal = #equal : 'a equal -> 'a -> 'a -> bool;

fun eq A_ a b = equal A_ a b;

datatype inta = Pls | Min | Bit0 of inta | Bit1 of inta | Number_of_int of inta;

fun pred (Bit1 k) = Bit0 k
  | pred (Bit0 k) = Bit1 (pred k)
  | pred Min = Bit0 Min
  | pred Pls = Min;

fun succ (Bit1 k) = Bit0 (succ k)
  | succ (Bit0 k) = Bit1 k
  | succ Min = Pls
  | succ Pls = Bit1 Pls;

fun insert A_ y a x = eq A_ y x orelse a x;

type 'a ord = {less_eq : 'a -> 'a -> bool, less : 'a -> 'a -> bool};
val less_eq = #less_eq : 'a ord -> 'a -> 'a -> bool;
val less = #less : 'a ord -> 'a -> 'a -> bool;

type 'a preorder = {ord_preorder : 'a ord};
val ord_preorder = #ord_preorder : 'a preorder -> 'a ord;

type 'a order = {preorder_order : 'a preorder};
val preorder_order = #preorder_order : 'a order -> 'a preorder;

type 'a bot = {order_bot : 'a order, bot : 'a};
val order_bot = #order_bot : 'a bot -> 'a order;
val bot = #bot : 'a bot -> 'a;

val bot_boola : bool = false;

fun less_bool true b = false
  | less_bool false b = b;

fun less_eq_bool true b = b
  | less_eq_bool false b = true;

val ord_bool = {less_eq = less_eq_bool, less = less_bool} : bool ord;

val preorder_bool = {ord_preorder = ord_bool} : bool preorder;

val order_bool = {preorder_order = preorder_bool} : bool order;

val bot_bool = {order_bot = order_bool, bot = bot_boola} : bool bot;

fun bot_fun B_ = (fn _ => bot B_);

fun set A_ [] = bot_fun bot_bool
  | set A_ (x :: xs) = insert A_ x (set A_ xs);

fun plus_int (Number_of_int v) (Number_of_int w) = Number_of_int (plus_int v w)
  | plus_int (Bit1 k) (Bit1 l) = Bit0 (plus_int k (succ l))
  | plus_int (Bit1 k) (Bit0 l) = Bit1 (plus_int k l)
  | plus_int (Bit0 k) (Bit1 l) = Bit1 (plus_int k l)
  | plus_int (Bit0 k) (Bit0 l) = Bit0 (plus_int k l)
  | plus_int k Min = pred k
  | plus_int k Pls = k
  | plus_int Min k = pred k
  | plus_int Pls k = k;

fun less_eq_int (Bit1 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_eq_int (Bit1 k1) (Bit0 k2) = less_int k1 k2
  | less_eq_int (Bit0 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_eq_int (Bit0 k1) (Bit0 k2) = less_eq_int k1 k2
  | less_eq_int (Bit1 k) Min = less_eq_int k Min
  | less_eq_int (Bit0 k) Min = less_eq_int k Min
  | less_eq_int (Bit1 k) Pls = less_int k Pls
  | less_eq_int (Bit0 k) Pls = less_eq_int k Pls
  | less_eq_int Min (Bit1 k) = less_eq_int Min k
  | less_eq_int Min (Bit0 k) = less_int Min k
  | less_eq_int Min Min = true
  | less_eq_int Min Pls = true
  | less_eq_int Pls (Bit1 k) = less_eq_int Pls k
  | less_eq_int Pls (Bit0 k) = less_eq_int Pls k
  | less_eq_int Pls Min = false
  | less_eq_int Pls Pls = true
  | less_eq_int (Number_of_int k) (Number_of_int l) = less_eq_int k l
and less_int (Bit1 k1) (Bit1 k2) = less_int k1 k2
  | less_int (Bit1 k1) (Bit0 k2) = less_int k1 k2
  | less_int (Bit0 k1) (Bit1 k2) = less_eq_int k1 k2
  | less_int (Bit0 k1) (Bit0 k2) = less_int k1 k2
  | less_int (Bit1 k) Min = less_int k Min
  | less_int (Bit0 k) Min = less_eq_int k Min
  | less_int (Bit1 k) Pls = less_int k Pls
  | less_int (Bit0 k) Pls = less_int k Pls
  | less_int Min (Bit1 k) = less_int Min k
  | less_int Min (Bit0 k) = less_int Min k
  | less_int Min Min = false
  | less_int Min Pls = true
  | less_int Pls (Bit1 k) = less_eq_int Pls k
  | less_int Pls (Bit0 k) = less_int Pls k
  | less_int Pls Min = false
  | less_int Pls Pls = false
  | less_int (Number_of_int k) (Number_of_int l) = less_int k l;

fun upto i j =
  (if less_eq_int i j then i :: upto (plus_int i (Number_of_int (Bit1 Pls))) j
    else []);

fun member x a = a x;

fun map_add m1 m2 = (fn x => (case m2 x of NONE => m1 x | SOME a => SOME a));

fun collect p = p;

fun equal_inta (Bit1 k1) (Bit1 k2) = equal_inta k1 k2
  | equal_inta (Bit1 k1) (Bit0 k2) = false
  | equal_inta (Bit0 k1) (Bit1 k2) = false
  | equal_inta (Bit0 k1) (Bit0 k2) = equal_inta k1 k2
  | equal_inta (Bit1 k1) Min = equal_inta k1 Min
  | equal_inta (Bit0 k1) Min = false
  | equal_inta (Bit1 k1) Pls = false
  | equal_inta (Bit0 k1) Pls = equal_inta k1 Pls
  | equal_inta Min (Bit1 k2) = equal_inta Min k2
  | equal_inta Min (Bit0 k2) = false
  | equal_inta Min Min = true
  | equal_inta Min Pls = false
  | equal_inta Pls (Bit1 k2) = false
  | equal_inta Pls (Bit0 k2) = equal_inta Pls k2
  | equal_inta Pls Min = false
  | equal_inta Pls Pls = true
  | equal_inta (Number_of_int k) (Number_of_int l) = equal_inta k l;

val equal_int = {equal = equal_inta} : inta equal;

datatype 'a decision = Allow of 'a | Deny of 'a;

type 'a adr = {};

fun fst (a, b) = a;

fun snd (a, b) = b;

fun src A_ = fst o snd;

datatype protocol = Tcp | Udp;

datatype dummyContent = Data;

fun dest A_ = fst o snd o snd;

val adr_int = {} : inta adr;

fun adr_prod A_ B_ = {} : ('a * 'b) adr;

datatype hosts = Host1 | Host2;

fun equal_protocol Udp Tcp = false
  | equal_protocol Tcp Udp = false
  | equal_protocol Udp Udp = true
  | equal_protocol Tcp Tcp = true;

fun deny_all p = SOME (Deny ());

fun equal_hosts Host2 Host1 = false
  | equal_hosts Host1 Host2 = false
  | equal_hosts Host2 Host2 = true
  | equal_hosts Host1 Host1 = true;

fun host1a x = collect (fn (a, _) => equal_hosts a Host1) x;

fun host2a x = collect (fn (a, _) => equal_hosts a Host2) x;

fun allow_all p = SOME (Allow ());

val adr_hosts = {} : hosts adr;

val adr_protocol = {} : protocol adr;

fun dom_restrict s p = (fn x => (if member x s then p x else NONE));

fun allow_from_to_port_prot_single pr po sr de =
  dom_restrict
    (collect
      (fn pa =>
        member (src (adr_prod adr_hosts (adr_prod adr_int adr_protocol)) pa)
          sr andalso
          (member (dest (adr_prod adr_hosts (adr_prod adr_int adr_protocol)) pa)
             de andalso
            (equal_protocol
               (snd (snd (dest (adr_prod adr_hosts
                                 (adr_prod adr_int adr_protocol))
                           pa)))
               pr andalso
              equal_inta
                (fst (snd (dest (adr_prod adr_hosts
                                  (adr_prod adr_int adr_protocol))
                            pa)))
                po))))
    allow_all;

fun allow_from_to_ports_prot_single pr po sr de =
  dom_restrict
    (collect
      (fn pa =>
        member (src (adr_prod adr_hosts (adr_prod adr_int adr_protocol)) pa)
          sr andalso
          (member (dest (adr_prod adr_hosts (adr_prod adr_int adr_protocol)) pa)
             de andalso
            (equal_protocol
               (snd (snd (dest (adr_prod adr_hosts
                                 (adr_prod adr_int adr_protocol))
                           pa)))
               pr andalso
              member
                (fst (snd (dest (adr_prod adr_hosts
                                  (adr_prod adr_int adr_protocol))
                            pa)))
                po))))
    allow_all;

fun testPolicy x =
  map_add deny_all
    (map_add
      (allow_from_to_port_prot_single Tcp
        (Number_of_int (Bit1 (Bit1 (Bit1 (Bit0 (Bit1 Pls)))))) host1a host2a)
      (map_add
        (allow_from_to_port_prot_single Udp
          (Number_of_int (Bit0 (Bit1 (Bit1 (Bit0 (Bit1 Pls)))))) host1a host2a)
        (map_add
          (allow_from_to_port_prot_single Tcp
            (Number_of_int
              (Bit1 (Bit1 (Bit0 (Bit1 (Bit1
(Bit1 (Bit0 (Bit1 (Bit1 Pls))))))))))
            host2a host1a)
          (map_add
            (allow_from_to_port_prot_single Tcp
              (Number_of_int (Bit1 (Bit0 (Bit1 (Bit0 (Bit1 Pls)))))) host2a
              host1a)
            (map_add
              (allow_from_to_port_prot_single Udp
                (Number_of_int
                  (Bit0 (Bit1 (Bit0 (Bit0 (Bit1
    (Bit0 (Bit0 (Bit1 (Bit1 (Bit1 (Bit1 (Bit1 (Bit1 Pls))))))))))))))
                host2a host1a)
              (map_add
                (allow_from_to_port_prot_single Tcp
                  (Number_of_int
                    (Bit0 (Bit0 (Bit0 (Bit0
(Bit1 (Bit0 (Bit0 (Bit1 (Bit1 (Bit1 (Bit1 (Bit1 (Bit1 Pls))))))))))))))
                  host1a host2a)
                (map_add
                  (allow_from_to_port_prot_single Tcp
                    (Number_of_int
                      (Bit1 (Bit0 (Bit1 (Bit1
  (Bit1 (Bit1 (Bit0 (Bit0 (Bit1 (Bit0 (Bit1 (Bit1 Pls)))))))))))))
                    host1a host2a)
                  (allow_from_to_ports_prot_single Tcp
                    (set equal_int
                      (upto (Number_of_int
                              (Bit0 (Bit0 (Bit0
    (Bit0 (Bit0 (Bit0 (Bit0 (Bit0 (Bit0 (Bit0 (Bit1 Pls))))))))))))
                        (Number_of_int
                          (Bit0 (Bit0 (Bit0
(Bit0 (Bit0 (Bit0 (Bit0 (Bit0 (Bit0 (Bit0 (Bit0 (Bit0 (Bit1 Pls))))))))))))))))
                    host1a host2a))))))))
    x;

end; (*struct Scenario*)
