

 
header{* File generated by script "generate_nat_thy.sh", on 
Tue Oct  9 22:16:02 CEST 2012.
*}
 
theory 
  fwnats
imports
  FWTesting
begin

declare [[testgen_profiling]]
declare [[testgen_iterations=50]]
declare [[testgen_SMT=true]]

definition
   filter_0 :: "(adr\<^isub>i\<^isub>p, DummyContent) FWPolicy" where
  "filter_0 = deny_all"

definition 
 nat_0  where 
 "nat_0 = (A\<^sub>f(\<lambda>x. {x}))"


definition subnet1 :: "adr\<^isub>i\<^isub>p net" where
 "subnet1 = {{(d,e). d > 1 \<and> d < 256}}"

definition subnet2 :: "adr\<^isub>i\<^isub>p net" where
 "subnet2 = {{(d,e). d > 500 \<and> d < 1256}}"


definition
  "accross_subnets x  \<equiv> 
 ((src x \<sqsubset> subnet1 \<and> (dest x \<sqsubset> subnet2)) \<or>
  (src x \<sqsubset> subnet2 \<and> (dest x \<sqsubset> subnet1)))"

lemmas UnfoldPolicy0 =filter_0_def nat_0_def 
                      NATLemmas 
                      ProtocolPortCombinators.ProtocolCombinators 
                      adr\<^isub>i\<^isub>pLemmas
                      packet_defs accross_subnets_def
         

lemmas subnets = subnet1_def subnet2_def 



definition
   filter_1 :: "(adr\<^isub>i\<^isub>p, DummyContent) FWPolicy" where
  "filter_1 = filter_0 ++ allow_from_port_to (1::port) subnet1 subnet2"


definition adr11 :: "int set"
where "adr11 = {d. d > 2 \<and> d < 3}"

definition adr21 :: "int set" where
 "adr21 = {d. d > 502 \<and> d < 503}"


definition nat_1 where
 "nat_1 = nat_0 ++ (srcPat2pool_IntPort adr11 adr21)"


definition policy_1 where
 "policy_1 = ((\<lambda> (x,y). x) o_f 
 ((nat_1 \<Otimes>\<^sub>2 filter_1) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy1 = UnfoldPolicy0 filter_1_def nat_1_def adr11_def adr21_def policy_1_def


definition
   filter_2 :: "(adr\<^isub>i\<^isub>p, DummyContent) FWPolicy" where
  "filter_2 = filter_1 ++ allow_from_port_to (2::port) subnet1 subnet2"


definition adr12 :: "int set"
where "adr12 = {d. d > 4 \<and> d < 6}"

definition adr22 :: "int set" where
 "adr22 = {d. d > 504 \<and> d < 506}"


definition nat_2 where
 "nat_2 = nat_1 ++ (srcPat2pool_IntPort adr12 adr22)"


definition policy_2 where
 "policy_2 = ((\<lambda> (x,y). x) o_f 
 ((nat_2 \<Otimes>\<^sub>2 filter_2) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy2 = UnfoldPolicy1 filter_2_def nat_2_def adr12_def adr22_def policy_2_def


definition
   filter_3 :: "(adr\<^isub>i\<^isub>p, DummyContent) FWPolicy" where
  "filter_3 = filter_2 ++ allow_from_port_to (3::port) subnet1 subnet2"


definition adr13 :: "int set"
where "adr13 = {d. d > 6 \<and> d < 9}"

definition adr23 :: "int set" where
 "adr23 = {d. d > 506 \<and> d < 509}"


definition nat_3 where
 "nat_3 = nat_2 ++ (srcPat2pool_IntPort adr13 adr23)"


definition policy_3 where
 "policy_3 = ((\<lambda> (x,y). x) o_f 
 ((nat_3 \<Otimes>\<^sub>2 filter_3) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy3 = UnfoldPolicy2 filter_3_def nat_3_def adr13_def adr23_def policy_3_def


definition
   filter_4 :: "(adr\<^isub>i\<^isub>p, DummyContent) FWPolicy" where
  "filter_4 = filter_3 ++ allow_from_port_to (4::port) subnet1 subnet2"


definition adr14 :: "int set"
where "adr14 = {d. d > 8 \<and> d < 12}"

definition adr24 :: "int set" where
 "adr24 = {d. d > 508 \<and> d < 512}"


definition nat_4 where
 "nat_4 = nat_3 ++ (srcPat2pool_IntPort adr14 adr24)"


definition policy_4 where
 "policy_4 = ((\<lambda> (x,y). x) o_f 
 ((nat_4 \<Otimes>\<^sub>2 filter_4) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy4 = UnfoldPolicy3 filter_4_def nat_4_def adr14_def adr24_def policy_4_def


definition
   filter_5 :: "(adr\<^isub>i\<^isub>p, DummyContent) FWPolicy" where
  "filter_5 = filter_4 ++ allow_from_port_to (5::port) subnet1 subnet2"


definition adr15 :: "int set"
where "adr15 = {d. d > 10 \<and> d < 15}"

definition adr25 :: "int set" where
 "adr25 = {d. d > 510 \<and> d < 515}"


definition nat_5 where
 "nat_5 = nat_4 ++ (srcPat2pool_IntPort adr15 adr25)"


definition policy_5 where
 "policy_5 = ((\<lambda> (x,y). x) o_f 
 ((nat_5 \<Otimes>\<^sub>2 filter_5) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy5 = UnfoldPolicy4 filter_5_def nat_5_def adr15_def adr25_def policy_5_def



test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_1 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy1 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy1}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT1

gen_test_data "natT1"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_2 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy2 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy2}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT2

gen_test_data "natT2"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_3 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy3 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy3}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT3

gen_test_data "natT3"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_4 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy4 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy4}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT4

gen_test_data "natT4"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_5 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy5 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy5}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT5

gen_test_data "natT5"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_6 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy6 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy6}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT6

gen_test_data "natT6"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_7 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy7 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy7}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT7

gen_test_data "natT7"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_8 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy8 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy8}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT8

gen_test_data "natT8"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_9 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy9 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy9}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT9

gen_test_data "natT9"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_10 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy10 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy10}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT10

gen_test_data "natT10"




write_clocks "time_stats_fwnats.tex"

declare [[testgen_profiling = false]]

end
