

 
header{* File generated by script "generate_SingleNat_thy.sh", on 
Tue Oct  9 22:16:36 CEST 2012.
*}

 
theory 
  single_fwnats
imports
  FWTesting
begin

declare [[testgen_profiling]]
declare [[testgen_iterations=50]]
declare [[testgen_SMT=true]]

definition subnet1 :: "adr\<^isub>i\<^isub>p net" where
 "subnet1 = {{(d,e). d > 1 \<and> d < 256}}"

definition subnet2 :: "adr\<^isub>i\<^isub>p net" where
 "subnet2 = {{(d,e). d > 500 \<and> d < 1256}}"


definition
  "accross_subnets x  \<equiv> 
 ((src x \<sqsubset> subnet1 \<and> (dest x \<sqsubset> subnet2)) \<or>
  (src x \<sqsubset> subnet2 \<and> (dest x \<sqsubset> subnet1)))"

definition
   filter :: "(adr\<^isub>i\<^isub>p, DummyContent) FWPolicy" where
  "filter = allow_from_port_to (1::port) subnet1 subnet2 ++
             allow_from_port_to (2::port) subnet1 subnet2 ++
             allow_from_port_to (3::port) subnet1 subnet2 ++ deny_all"

definition 
 nat_0  where 
 "nat_0 = (A\<^sub>f(\<lambda>x. {x}))"


lemmas UnfoldPolicy0 =filter_def nat_0_def 
                      NATLemmas 
                      ProtocolPortCombinators.ProtocolCombinators 
                      adr\<^isub>i\<^isub>pLemmas
                      packet_defs accross_subnets_def
                      subnet1_def subnet2_def


lemmas subnets = subnet1_def subnet2_def 





definition Adr11 :: "int set"
where "Adr11 = {d. d > 2 \<and> d < 3}"

definition Adr21 :: "int set" where
 "Adr21 = {d. d > 502 \<and> d < 503}"


definition nat_1 where
 "nat_1 = nat_0 ++ (srcPat2pool_IntPort Adr11 Adr21)"


definition policy_1 where
 "policy_1 = ((\<lambda> (x,y). x) o_f 
 ((nat_1 \<Otimes>\<^sub>2 filter) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy1 = UnfoldPolicy0 nat_1_def Adr11_def Adr21_def policy_1_def




definition Adr12 :: "int set"
where "Adr12 = {d. d > 4 \<and> d < 6}"

definition Adr22 :: "int set" where
 "Adr22 = {d. d > 504 \<and> d < 506}"


definition nat_2 where
 "nat_2 = nat_1 ++ (srcPat2pool_IntPort Adr12 Adr22)"


definition policy_2 where
 "policy_2 = ((\<lambda> (x,y). x) o_f 
 ((nat_2 \<Otimes>\<^sub>2 filter) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy2 = UnfoldPolicy1 nat_2_def Adr12_def Adr22_def policy_2_def




definition Adr13 :: "int set"
where "Adr13 = {d. d > 6 \<and> d < 9}"

definition Adr23 :: "int set" where
 "Adr23 = {d. d > 506 \<and> d < 509}"


definition nat_3 where
 "nat_3 = nat_2 ++ (srcPat2pool_IntPort Adr13 Adr23)"


definition policy_3 where
 "policy_3 = ((\<lambda> (x,y). x) o_f 
 ((nat_3 \<Otimes>\<^sub>2 filter) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy3 = UnfoldPolicy2 nat_3_def Adr13_def Adr23_def policy_3_def




definition Adr14 :: "int set"
where "Adr14 = {d. d > 8 \<and> d < 12}"

definition Adr24 :: "int set" where
 "Adr24 = {d. d > 508 \<and> d < 512}"


definition nat_4 where
 "nat_4 = nat_3 ++ (srcPat2pool_IntPort Adr14 Adr24)"


definition policy_4 where
 "policy_4 = ((\<lambda> (x,y). x) o_f 
 ((nat_4 \<Otimes>\<^sub>2 filter) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy4 = UnfoldPolicy3 nat_4_def Adr14_def Adr24_def policy_4_def




definition Adr15 :: "int set"
where "Adr15 = {d. d > 10 \<and> d < 15}"

definition Adr25 :: "int set" where
 "Adr25 = {d. d > 510 \<and> d < 515}"


definition nat_5 where
 "nat_5 = nat_4 ++ (srcPat2pool_IntPort Adr15 Adr25)"


definition policy_5 where
 "policy_5 = ((\<lambda> (x,y). x) o_f 
 ((nat_5 \<Otimes>\<^sub>2 filter) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy5 = UnfoldPolicy4 nat_5_def Adr15_def Adr25_def policy_5_def




definition Adr16 :: "int set"
where "Adr16 = {d. d > 12 \<and> d < 18}"

definition Adr26 :: "int set" where
 "Adr26 = {d. d > 512 \<and> d < 518}"


definition nat_6 where
 "nat_6 = nat_5 ++ (srcPat2pool_IntPort Adr16 Adr26)"


definition policy_6 where
 "policy_6 = ((\<lambda> (x,y). x) o_f 
 ((nat_6 \<Otimes>\<^sub>2 filter) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy6 = UnfoldPolicy5 nat_6_def Adr16_def Adr26_def policy_6_def




definition Adr17 :: "int set"
where "Adr17 = {d. d > 14 \<and> d < 21}"

definition Adr27 :: "int set" where
 "Adr27 = {d. d > 514 \<and> d < 521}"


definition nat_7 where
 "nat_7 = nat_6 ++ (srcPat2pool_IntPort Adr17 Adr27)"


definition policy_7 where
 "policy_7 = ((\<lambda> (x,y). x) o_f 
 ((nat_7 \<Otimes>\<^sub>2 filter) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy7 = UnfoldPolicy6 nat_7_def Adr17_def Adr27_def policy_7_def




definition Adr18 :: "int set"
where "Adr18 = {d. d > 16 \<and> d < 24}"

definition Adr28 :: "int set" where
 "Adr28 = {d. d > 516 \<and> d < 524}"


definition nat_8 where
 "nat_8 = nat_7 ++ (srcPat2pool_IntPort Adr18 Adr28)"


definition policy_8 where
 "policy_8 = ((\<lambda> (x,y). x) o_f 
 ((nat_8 \<Otimes>\<^sub>2 filter) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy8 = UnfoldPolicy7 nat_8_def Adr18_def Adr28_def policy_8_def




definition Adr19 :: "int set"
where "Adr19 = {d. d > 18 \<and> d < 27}"

definition Adr29 :: "int set" where
 "Adr29 = {d. d > 518 \<and> d < 527}"


definition nat_9 where
 "nat_9 = nat_8 ++ (srcPat2pool_IntPort Adr19 Adr29)"


definition policy_9 where
 "policy_9 = ((\<lambda> (x,y). x) o_f 
 ((nat_9 \<Otimes>\<^sub>2 filter) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy9 = UnfoldPolicy8 nat_9_def Adr19_def Adr29_def policy_9_def




definition Adr110 :: "int set"
where "Adr110 = {d. d > 20 \<and> d < 30}"

definition Adr210 :: "int set" where
 "Adr210 = {d. d > 520 \<and> d < 530}"


definition nat_10 where
 "nat_10 = nat_9 ++ (srcPat2pool_IntPort Adr110 Adr210)"


definition policy_10 where
 "policy_10 = ((\<lambda> (x,y). x) o_f 
 ((nat_10 \<Otimes>\<^sub>2 filter) o (\<lambda> x. (x,x))))"


lemmas UnfoldPolicy10 = UnfoldPolicy9 nat_10_def Adr110_def Adr210_def policy_10_def



test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_1 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy1 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy1}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT1

gen_test_data "natT1"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_2 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy2 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy2}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT2

gen_test_data "natT2"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_3 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy3 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy3}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT3

gen_test_data "natT3"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_4 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy4 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy4}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT4

gen_test_data "natT4"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_5 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy5 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy5}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT5

gen_test_data "natT5"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_6 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy6 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy6}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT6

gen_test_data "natT6"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_7 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy7 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy7}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT7

gen_test_data "natT7"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_8 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy8 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy8}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT8

gen_test_data "natT8"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_9 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy9 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy9}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT9

gen_test_data "natT9"




test_spec 
"accross_subnets x  \<longrightarrow> 
FUT x = policy_10 x"
apply (prepare_fw_spec)
apply (gen_test_cases FUT simp: subnets UnfoldPolicy10 
                                split_tupled_all)
apply (tactic 
 "ALLGOALS(TestGen.ONLY_POS(
      (full_simp_tac (simpset_of @{context}addsimps @{thms  PO_def UnfoldPolicy10}))
      THEN_ALL_NEW ( (rtac @{thm PO_add}))))") 
store_test_thm natT10

gen_test_data "natT10"




write_clocks "time_stats_single_fwnats.tex"

declare [[testgen_profiling = false]]

end
