#!/bin/bash

export WD=`pwd`
timing=5000


declare -a examples 
examples=('2010-icst/RandomDefinitions/Random6 $timing' '2010-icst/RandomDefinitions/RandomQuick6 $timing'
          '2010-icst/NormalisedTests/Normalized2 $timing'
           'CommonScenarios/Scenario1 $timing' 'CommonScenarios/Scenario2 $timing' 'CommonScenarios/Scenario4 $timing' 
           'CommonScenarios/Scenario5 $timing' 
           'ftp $timing' 'nat_normalisation $timing' 'rules $timing' 'networks $timing' 'ftpvoip $timing' 'nat $timing')
element_count=${#examples[@]}
index=0

echo "Regression Test Firewall Testing"

while [ "$index" -lt "$element_count" ]
do 
    dir=`echo ${examples[$index]} | awk '{print $1}'`
    t=`echo ${examples[$index]} | awk '{print $timing}'`
    t=$timing
    echo 
    echo "***************************************************************************"
    echo "* Started $dir on `date`" 
    echo "* time limit: $t"
    cd $dir;
    ulimit -S -t $t
    isabelle env ISABELLE_OUTPUT=$WD/heaps make -f IsaMakefile -B;
    rm -rf ../heaps
    echo "* Finished $dir successfully on `date`" >> ../time.log
    echo "***************************************************************************" 
    echo 
    cd $WD;
    let "index = $index + 1"
done

#zgrep -hEo "^.+test cases in.+$" heaps/log/*.gz > RandomLogs.tex
