(*****************************************************************************
 * HOL-TestGen --- theorem-prover based test case generation
 *                 http://www.brucker.ch/projects/hol-testgen/
 *                                                                            
 * code_fsharp.thy  --- 
 * This file is part of HOL-TestGen.
 *
 * Copyright (c) 2010-2012 ETH Zurich, Switzerland
 *               2010-2012 Achim D. Brucker, Germany
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials provided
 *       with the distribution.
 *
 *     * Neither the name of the copyright holders nor the names of its
 *       contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************)
(* $Id: code_fsharp.thy 9263 2011-12-25 15:49:36Z brucker $ *)

theory code_fsharp
imports Main
uses "code_fsharp.ML"
begin

setup {*
  Solve_Direct.setup
  #> Code_Preproc.setup
  #> Code_Simp.setup
  #> Code_FSharp.setup
  #> Quickcheck.setup
*}

(* In file HOL/HOL.thy *)
code_type bool
  (Fsharp "bool")

code_const True and False and Not and HOL.conj and HOL.disj and If
  (Fsharp "true" and "false" and "not"
    and infixl 3 "&&" and infixl 2 "||"
    and "!(if (_)/ then (_)/ else (_))")

code_reserved Fsharp
  bool

code_const undefined
  (Fsharp "failwith/ \"undefined\"")

(* In file HOL/Option.thy *)
code_type option
  (Fsharp "_ option")

code_const None and Some
  (Fsharp "None" and "Some _")

code_reserved Fsharp
  option None Some

(* In file HOL/List.thy *)
code_type list
  (Fsharp "_ list")

code_const Nil
  (Fsharp "[]")

code_const Cons
  (Fsharp "(_ ::/ _)")

code_reserved Fsharp
  list

code_const "op @"
  (Fsharp infixr 6 "@")

code_type unit
  (Fsharp "unit")

code_const Unity
  (Fsharp "()")

code_reserved Fsharp
  unit

code_type prod
  (Fsharp infix 2 "*")

code_const Pair
  (Fsharp "!((_),/ (_))")

end
